/* The SREhttp/2 content management system (CMS) program 

   This module will add records to a CMS dataseries
  1) first, it will provide a pick list of cms dataseries (for this host)
  2) given the chosen dataseries, it will present a form with fields for each
     variable
  3) it will add the record, using filled in values for the variables, and
     report back



*/

/******** User changeable parameters ***/
/* root directory for the SREhttp/2 CMS addon
   Leave blank to use default (CMS subdirectory of srehttp/2 addon directory */
cmsdir=''

/* maximum size of URLs to download (in bytes) */
max_url_size=50000

/* maximum size of files to upload (in bytes) */
max_file_size=1000000

/* maximum size, in bytes, of a record. This does NOT include size of uploaded files & URLS */
max_record_size=5000


/******** Dne of user changeable parameters ***/


parse arg list,servername,verb,tempfile,,
          prog_file,reqnum,verbose,client_ip,privset,,
          uri,host_nickname,idinfo,aiter,attribs,seluse2

crlf='0d0a'x

if verb=" " then do
   say "This SREhttp/2 procedure is not meant to be run in standalone mode "
   exit
end  

addon_dir=sre_value('H2_ADDON_DIR_DEFAULT',,'SRE')
if cmsdir='' then cmsdir=strip(addon_dir,,'\')||'\CMS'
foo=dosisdir(cmsdir)
if foo=0 then return 'String Error:unable to find CMS directory: ('cmsdir

cmsdir_data=cmsdir||'\DATA'
okk=dosisdir(cmsdir_data)
if okk=0 then do
  return 'string unable to find CMS data directory: 'cmsdir_data
end

cmsdir_lib=cmsdir||'\LIB'
okk=dosisdir(cmsdir_lib)
if okk=0 then do
  return 'string unable to find CMS index directory: 'cmsdir_lib
end

cmsdir_pol=cmsdir||'\LIB\POL'
okk=dosisdir(cmsdir_pol)
if okk=0 then do
  return 'string unable to find CMS index directory: 'cmsdir_pol
end


cmsdir_index=cmsdir||'\INDEX'
okk=dosisdir(cmsdir_index)
if okk=0 then do
  return 'string unable to find CMS index directory: 'cmsdir_index
end

parse var uri thisaddon '?' .
jj=lastpos('/',thisaddon)
mainaddon=left(uri,jj)||'cms.cmd'
root=left(uri,jj)

optname.=''
m=0
if list='' then list='action=1'

list0=list

atype=sre_reqfield('content-type')
if abbrev(strip(translate(atype)),'MULTIPART/FORM-DATA')=1 then do     /* special POST */
   astatus=parse_multipart(list)
   is_multipart=1
end
else do
  do until list=""
    parse var list opt1 '&' list
    m=m+1
    parse var opt1 avar '=' aval ; avar=strip(translate(avar)) 
    optname.0=optname.0||' '||avar
    aval=translate(aval,' ', '+')
    aval=sre_packur(aval)
    avar1='!!'avar
    optname.avar1=aval
    avar2='!'avar
    aval2=strip(translate(aval,' ','090a0d'x))
    optname.avar2=aval2
  end
  is_multipart=0
end

/***** End of GENERIC CMS addon code *****/

if optname.!action='1' then do   /* find the list of dataseries defined for this host*/
  call show_datafiles
  foo=result
  return foo
end

if optname.!action='2' then do   /* ask for variable values*/
  call ask_values
  foo=result
  return foo
end

if optname.!action='22' then do   /* ask for variable values -- auto generate*/
  call ask_values_2
  foo=result
  return foo
end


if optname.!action='3' then do   /* save values to dataseries*/
  call save_values
  foo=result
  return foo
end

return 'String Error in CMS_ADD, unknown action: 'optname.!action


/*******************/
/* pick one of the current cms datafiles (for this host) */
show_datafiles:

call lineout tempfile,'<html><head><title>CMS: Choose a CMS datafile</title></head> '


call lineout tempfile,'<font size=-1><a href="'||mainaddon||'?action=1">Another CMS action</a></font><br>'

call lineout tempfile,'<h3>Select a CMS dataseries</h3><em> to a record to...</em><p> '

ahost=host_nickname

/* look for files, in cmsDIR_index dir, of the form: ahost_nnnn.DEF
   These .DEF files define "CMS indices" --- nnnn is a number from 0 to 9999
*/

cookie_value=sreh2_get_cookie('CMS') 

call lineout tempfile,'<FORM name="" action="'||thisaddon||'" method="POST">'
call lineout tempfile,'<input type="hidden" name="action" value="2">'
ff=cmsdir_index||'\'||ahost||'*.DEF'
goo=sysfiletree(ff,'ff2','FO')

call lineout tempfile,'For host: <Tt>'||ahost||'</tt>, the following CMS dataseries have been created'

call lineout tempfile,'<table border=1>'
do jj=1 to ff2.0
   daname=filespec('n',ff2.jj)
   call read_deffile ff2.jj
   call lineout tempfile,'<tr><th align="left">' 
   if daname=cookie_value  | (cookie_value='' & jj=1) then
      call lineout tempfile,'<INPUT TYPE="RADIO" checked name="deffile" value="'||daname||'">' 
   else
      call lineout tempfile,'<INPUT TYPE="RADIO"  name="deffile" value="'||daname||'">' 
   gob=strip(stuff.!series)||'</th>'
   call lineout tempfile,gob||'<td> <em>&nbsp;'||stuff.!desc||'</em></td>'
end

call lineout tempfile,'</table>'


call lineout tempfile,''
call lineout tempfile,'<p><INPUT name="sub2" TYPE="submit" VALUE="Choose a CMS dataseries">'
call lineout tempfile,'</form>'
call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode


/*******************/
/* display a form, created from a form-template with substitution;
   with fields for each variable in a cms dataseries */

ask_values_2:


/* note: might end up deleting tempfile, so writing this now is a bit of hack */
call lineout tempfile,'<html><head><title>CMS: Specify values for a CMS datafile record</title></head> '
call lineout tempfile,'<font size=-1><a href="'||mainaddon||'?action=1">Another CMS action</a></font><br>'
call lineout tempfile,'<h3>Add record to a CMS dataseries</h3> '

daindx=optname.!deffile
ff=cmsdir_index||'\'||daindx
goo=stream(ff,'c','query exists')
if goo='' then do
   call lineout tempfile,'Error: could not find index file: '||ff
   signal gooble
end

astat=sreh2_set_cookie('CMS',daindx,1,root,,1) 

call read_deffile ff

/* check for access rights */
rcode=check_access(stuff.!OWNERS,stuff.!SERIES)
if rcode<>1 then return rcode


a=sre_cache_data(stuff.!series,'OPEN INDEX ',stuff.!file)
if a>0 then do
   amess=sre_cache_data('OPEN','ERROR',a)
   call lineout tempfile,'<b>Error:</b> '||amess
   signal gooble
end

a=sre_cache_data(stuff.!series,'INFO',,'MODIFIED RECORDS VARS DESCRIPTION')
parse var a astat a ; astat=strip(astat)
if astat<>'0' then do
   amess=sre_cache_data('INFO','ERROR',astat)
   call lineout tempfile,'<b>Error retrieving info:</b> '||amess
   signal gooble
end
parse var a . '0d0a'x . '09'x modified  '=' . '09'x nrecords '09'x  varlist_sre '09'x  desc
nrecords=nrecords-4     /* at least 4 meta-data records */
ii=0

/* now, read the form file */
afile0=optname.!FORMFILE
if afile0='' then do
   call lineout tempfile,'<b>Error:</b>no FORMFILE specified  '
   signal gooble
end
cmtdir=stuff.!FILEDIR
if cmtdir<>'' then
    afile=fix_file(afile0,strip(cmtdir,,'\')||'\')
else
   afile=fix_file(afile0,strip(cmsdir_lib,,'\')||'\')

if stream(afile,'c','query exists')='' then do
   afile=fix_file(afile0,strip(cmsdir_lib,,'\')||'\')
   if stream(afile,'c','query exists')='' then do
      call lineout tempfile,'<b>Error</b>: CMS form file does not exist: 'afile0
      signal gooble
   end
end

stuff=sre_read_file(afile,2,2,1)
if stuff='' then do
      call lineout tempfile,'<b>Error</b>: CMS form file is empty or unreadable: 'afile
      signal gooble
end


ii=pos('<!--FORM_START-->',stuff)
if ii=0 then do
      call lineout tempfile,'<b>Error</b>. No FORM_START replaceable string in record-add template: 'afile
end


/* now we are ready to make the replacements. First close of tempfile, and delete it */
call lineout tempfile
foo=sysfiledelete(tempfile)


/***
         FORM_START: this is the ONLY required "replaceable string".
                     It is used at the beginning of the FORM.
                     It will be replaced by a FORM .. element, and
                     by some crucial hidden elements.

         CURRENT_DATETIME  : The current date and time (in GMT)
         HINT         : The hint: from the .def file

         SERIES        : The name of this dataseries 
         DESC          : Short description of the dataseries
         LASTMODIFIED  : Date and time a record was added or modified         
         TOTALRECORDS: Total # of records in dataseries

         VARS       : a space delimited list of the variables in the 
                      dataseries. If an Abstract was specified, its name will
                      be $ABSTRACT.

         VARTYPES   : a space delimited list of the types of the variables in the 
                      dataseries
         _SELECT_VARNAME : create a selection list for the select-list variable VARNAME

        _POLL_VARNAME  : create a poll-questionaire box

***/



aa='<FORM name="cmsd" ACTION="'||thisaddon||'" METHOD="POST" enctype="multipart/form-data">'
aa=aa||'<input type="hidden" name="series" value="'||stuff.!series||'"> '
aa=aa||'0d0a'x||'<input type="hidden" name="action" value=3>'
aa=aa||'0d0a'x||'<input type="hidden" name="deffile" value="'||daindx||'">'
aa=aa||'0d0a'x||'<input type="hidden" name="-VAR_$STATUS" value=0> '
if optname.!RESPFILE<>'' then
  aa=aa||'0d0a'x||'<input type="hidden" name="RESPFILE" value="'||optname.!RESPFILE||'"> '

stuff=sre_replacestrg(stuff,'<!--FORM_START-->',aa,'ALL')
stuff=sre_replacestrg(stuff,'<!--CURRENT_DATETIME-->',sre_datestamp(),'ALL')
stuff=sre_replacestrg(stuff,'<!--HINT-->',stuff.!HINT,'ALL')

vnames=stuff.!varnames
vtypes=stuff.!vartypes
vnames1='' ; vtypes1=''
do mm=1 to words(vnames)
    aw=translate(strip(word(vnames,mm)))
    if aw<>'$STATUS' then do
        vnames1=vnames1||' '||aw
        att=translate(strip(word(vtypes,mm)))
        vtypes1=vtypes1||' '||att
    end
end
stuff=sre_replacestrg(stuff,'<!--VARS-->',strip(vnames1),'ALL')
stuff=sre_replacestrg(stuff,'<!--VARTYPES-->',strip(vtypes1),'ALL')

stuff=sre_replacestrg(stuff,'<!--TOTALRECORDS-->',nrecords,'ALL')
stuff=sre_replacestrg(stuff,'<!--DESC-->',stuff.!DESC,'ALL')
stuff=sre_replacestrg(stuff,'<!--SERIES-->',stuff.!series,'ALL')
stuff=sre_replacestrg(stuff,'<!--MODIFIED-->',modified,'ALL')

/* do now do auto-generation of fields. The kind of input
   field generarted depends on the type of the variable */

/* first, do SELECT variables */
sels=stuff.!SELECT
do until sels=''
   parse var sels asel ';' sels
   if asel='' then iterate
   parse upper var asel bvarname '=' bfilename ;bvarname=strip(bvarname)
   ll='<!--%'||bvarname||'-->'
   if pos(ll,stuff)=0 then iterate

/* otherwise, replace with a SELECT .. OPTION .. /SELECT */
   aa='<SELECT name="-VAR_'||bvarname||'" size=1>'||'0d0a'x


  aa='<Select size=1 name="-VAR_'||bvarname||'" size=1 '||'0d0a'x
   aa=aa||' onChange="i1=this.selectedIndex ; a1=options[i1].value ; '||'0d0a'x
   aa=aa||'  if (a1==''$''){ a2=options[i1].text ;  '||'0d0a'x
   aa=aa||'     a3=window.prompt(''Enter value for: '' + a2 ) ;'||'0d0a'x
   aa=aa||'     options[i1].value=a3 ; options[i1].text=options[i1].text + '' = '' + a3 ; '||'0d0a'x
   aa=aa||'  }"> '


   bfile=cmsdir_lib||'\'||strip(bfilename)||'.OPT'
   if stream(bfile,'c','query exists')='' then do
      rr='<!-- ERROR,  unable to find Select-Option file '||bfile|| ' --> '
      stuff=sre_replacestrg(stuff,ll,rr,'ALL')
      iterate
   end
   in1=sre_read_file(bfile,2,2,1)
   if in1='' then do
      rr='<!-- ERROR, empty Select-Option file '||bfile|| ' --> '||'0d0a'x
      stuff=sre_replacestrg(stuff,ll,rr,'ALL')
      iterate
   end
   do until in1=''
       parse var in1 aline '0d0a'x in1
       aline=strip(aline)
       if aline='' then iterate
       if abbrev(aline,';')=1 then iterate
       parse var aline a1 '=' a2
       aa=aa||'  <option value="'||strip(a1)||'">'||strip(a2)||'0d0a'x
   end 
   aa=aa||'</select>'||'0d0a'x
   stuff=sre_replacestrg(stuff,ll,aa,'ALL')
end             /* get next select-list variable */

/* next, do POLL variables */
pols=stuff.!POLL
do until pols=''
   parse var pols apol ';' pols
   if apol='' then iterate
   parse upper var apol bvarname '=' bfilename ;bvarname=strip(bvarname)
   bfilename=strip(bfilename)

   ll='<!--%'||bvarname||'-->'
   if pos(ll,stuff)=0 then iterate
   isobspoll=0
/* both of these replace LL in STUFF */
   if bfilename='*' then do             /* ask for a poll file */
      foo=sel_polfile(ll,bvarname)         /* sets bfilename for this observation */
   end
   else do
      call do_poll
   end 
end             /* get next poll variable */


/* do all other variables */
do mm=1 to words(vnames)
    aw=strip(translate(word(vnames,mm)))
    atype=strip(translate(word(vtypes,mm)))
    ll='<!--%'||aw||'-->'
    if pos(ll,stuff)=0 then iterate
    select              /* substitution depends on atype */    
       when atype='1' then do
          aa='<Input type="text" name="-VAR_'||aw||'" size=50>'
       end 
       when atype='A' then do
          aa='<Input type="text" name="-VAR_'||aw||'" size=80>'
       end
       when atype='N' then do
          aa='<Input type="text" name="-VAR_'||aw||'" size=15>'
       end
       when atype='T' then do
          aa=''
          foo=write_datetime_input(aw,1)
       end 
       when atype='M' then do
          aa='<textarea name="-VAR_'||aw||'" rows=5 cols=80></textarea>'
       end
       when atype='C' then do
          aa='<Input type="checkbox" name="-VAR_'||aw||'" value="1" >'
       end
       when atype='F' then do
          aa='<input size=55 type="FILE" name="-VAR_'||aw||'">'
       end
       otherwise iterate        /* SELECT, POLL ,or no such type, skip it */
    end  /* select */
    stuff=sre_replacestrg(stuff,ll,aa,'ALL')
  
end

a=sre_cache_data(stuff.!series,'CLOSE')
rcode=sre_command('VAR ETAG_AUTO EXPIRES 30s NOCACHE NOIF TYPE text/html ',stuff,idinfo)
return rcode


gooble:         /* jump here on error */
a=sre_cache_data(stuff.!series,'CLOSE')

call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode


/***********************/
/* select one of the poll choice */
do_poll:
usedir=cmsdir_pol
if abbrev(bfilename,'~')=1 then do
    bfilename=substr(bfilename,2)
    usedir=stuff.!filedir||'\POLLS'
end 
bfile=usedir||'\'||strip(bfilename)||'.POL'
if stream(bfile,'c','query exists')='' then do
      rr='<!-- ERROR,  unable to find poll-definition file '||bfile|| ' --> '
      stuff=sre_replacestrg(stuff,ll,rr,'ALL')
      return
end
in1=sre_read_file(bfile,2,2,1)

if in1='' then do
      rr='<!-- ERROR, empty poll-definition file '||bfile|| ' --> '||'0d0a'x
      stuff=sre_replacestrg(stuff,ll,rr,'ALL')
      return 0
end

vopts.='' ; nopts=0
do until in1=''
      parse var in1 aline '0d0a'x in1
      aline=strip(aline)
      if aline='' then iterate
      if abbrev(aline,';')=1 then iterate
      parse var aline a1 ':' a2
      a1=strip(translate(a1))
      r1=a1
      va1='!'||a1
      if vopts.va1='' then do
        vopts.va1=strip(a2)
        vopts.0=vopts.0||' '||a1
      end
      else do
        vopts.va1=vopts.va1||'0d0a'x||strip(a2)
      end
      if datatype(a1)='NUM' then do
         nopts=nopts+1
         vopts.nopts=a1
      end 
end   
btmp=''
if vopts.!COLOR<>'' then btmp=' bgcolor="'||vopts.!COLOR||'" '
tt='<table border=1 '||btmp||' > '||'0d0a'x
if vopts.!HEADER<>'' then
      tt=tt||'<tr><td>'||vopts.!HEADER||'</td>'||'0d0a'x
aq='!?'
tt=tt||'<tr><td>'||'<b>'||vopts.aq||'</b>'||'0d0a'x
tt=tt||'<ul>'||'0d0a'x
tt=tt||'<li><input type="radio" name="-VAR_'||bvarname||'" checked value="" >all counts set to 0 '

do jjj=1 to nopts
        aw=vopts.jjj
        vaw='!'||aw
        tt=tt||'<li><input type="radio" name="-VAR_'||bvarname||'" value="'||aw||'" > '
        tt=tt||vopts.vaw||'0d0a'x
end

tt=tt||'</td>'||'0d0a'x
if vopts.!FOOTER<>'' then
     tt=tt||'<tr><td>'||vopts.!FOOTER||'</td>'||'0d0a'x
tt=tt||'</table>'||'0d0a'x 

tt=tt||'0d0a'x
stuff=sre_replacestrg(stuff,ll,tt,'ALL')

return 1

/*****************/
/* ask for a poll file (for observation specific polls. returns bfilename */
sel_polfile:procedure expose bfilename  cmsdir_lib cmsdir_pol optname. stuff stuff. 
parse arg ll,avar
myfiledir=stuff.!filedir
aa=''

oo=sysfiletree(cmsdir_pol||'\*.POL','ofiles','FO')
oo=sysfiletree(myfiledir||'\POLLS\*.POL','ofiles2','FO')
if ofiles2.0+ofiles.0=0 then do
     aa='There are <b>no</b> poll-definition files (.POL files) currently available in <tt>'||cmsdir_pol||'</tt>'
     aa=aa||', or in <tt>'||fdir||'\POLLS </tt>'
     stuff=sre_replacestrg(stuff,ll,aa,'ALL')
     return 1
  end
  else do
     do j1=1 to ofiles.0
        ofiles.j1=filespec('n',ofiles.j1)
        parse var ofiles.j1 ofiles.j1 '.' .
     end 
     do j1=1 to ofiles2.0
        ofiles2.j1=filespec('n',ofiles2.j1)
        parse var ofiles2.j1 ofiles2.j1 '.' .
     end 
     aa=aa||'<table>'||'0d0a'x
     aa=aa||'<tr><td><b>'||avar||'</b>:</td> '||'0d0a'x
     aa=aa||'<td>'
     aa=aa||'<select name="-VAR_'||avar||'" size=1>'||'0d0a'x
     aa=aa||'<option selected value="-">Select a poll-definition file'||'0d0a'x

     do mm2=1 to ofiles.0
         aa=aa||'<option value="'||ofiles.mm2||'">'ofiles.mm2||'0d0a'x
     end 

     if fdir<>'' then do
          aa=aa||'<option value="-"> - Series specific files-'||'0d0a'x
          do mm2=1 to ofiles2.0         /* note use of ~ in short name (~ signal filedir) */
             aa=aa||'<option value="~'||ofiles2.mm2||'">'ofiles2.mm2||'0d0a'x
           end 
      end

       aa=aa||'</select></td>'||'0d0a'x
    end
    aa=aa||'</table>'||'0d0a'x

    stuff=sre_replacestrg(stuff,ll,aa,'ALL')
return 1


/*******************/
/* generate a form with fields for each variable in a cms dataseries */
ask_values:

call lineout tempfile,'<html><head><title>CMS: Specify values for a CMS datafile record</title></head> '

call lineout tempfile,'<font size=-1><a href="'||mainaddon||'?action=1">Another CMS action</a></font><br>'

call lineout tempfile,'<h3> Add record to a CMS dataseries</h3> '

daindx=optname.!deffile
ff=cmsdir_index||'\'||daindx
goo=stream(ff,'c','query exists')
if goo='' then do
   call lineout tempfile,'Error: could not find index file: '||ff
   signal gooble
end

call read_deffile ff

astat=sreh2_set_cookie('CMS',daindx,1,root,,1) 

/* check for access rights */
rcode=check_access(stuff.!OWNERS,stuff.!SERIES)
if rcode<>1 then return rcode

a=sre_cache_data(stuff.!series,'OPEN INDEX ',stuff.!file)
if a>0 then do
   amess=sre_cache_data('OPEN','ERROR',a)
   call lineout tempfile,'<b>Error:</b> '||amess
   signal gooble
end

a=sre_cache_data(stuff.!series,'INFO',,'MODIFIED RECORDS VARS DESCRIPTION')

parse var a astat a ; astat=strip(astat)
if astat<>'0' then do
   amess=sre_cache_data('INFO','ERROR',astat)
   call lineout tempfile,'<b>Error retrieving info:</b> '||amess
   signal gooble
end

parse var a . '0d0a'x . '09'x modified  '=' . '09'x nrecords '09'x  varlist_sre '09'x  desc
nrecords=nrecords-4     /* at least 4 meta-data records */
ii=0

varlist=stuff.!varnames
vartypes=stuff.!vartypes
if words(varlist)<>words(vartypes) then do
   call lineout tempfile,'<b>Error in .DEF file ('ff'), Mismatch in variable names and types:<br>'
   call lineout tempfile,'Names: <tt>'||varlist||'</tt><br>'
   call lineout tempfile,'Types: <tt>'||vartypes||'</tt><br>'
   signal gooble
end

do kk=1 to words(varlist)
   avar=strip(translate(word(varlist,kk)))
   atype=strip(translate(word(vartypes,kk)))
   varnames.kk=avar
   vartypes.kk=atype
end

ss=stuff.!select
selfiles.=''
do until ss=''
   if ss='' then leave
   parse var ss s1 ';' ss
   parse var s1 svar '=' sfile
   vvar='!'||strip(translate(svar))
   afile=cmsdir_lib||'\'||strip(sfile)||'.OPT'
   if stream(afile,'c','query exists')='' then do
      call lineout tempfile,'<b>Error:</b> unable to find Select-Option file '||afile
      signal gooble
   end 
   selfiles.vvar=afile
end 


ss=stuff.!poll
polfiles.=''
do until ss=''
   if ss='' then leave
   parse var ss s1 ';' ss
   parse var s1 svar '=' sfile0 ; sfile=strip(sfile0)
   vvar='!'||strip(translate(svar))

   if sfile='*' then do /* obseration specific polls */
        afile='*'       
   end 
   else do
     usedir=cmsdir_pol
     if abbrev(sfile,'~')=1 then do
        sfile=substr(sfile,2)
        usedir=stuff.!filedir||'\POLLS'
     end 

     afile=usedir||'\'||strip(sfile)||'.POL'
     if stream(afile,'c','query exists')='' then do
        call lineout tempfile,'<b>Error1:</b> unable to find poll-definition file '||afile
        signal gooble
     end 
   end
   polfiles.vvar=afile
   polfiles.vvar.!sfile0=sfile0
end 


varnames.0=words(varlist)
call lineout tempfile,'<FORM name="doadd" target="_self" action="'||thisaddon||'" method="POST" enctype="multipart/form-data">'
call lineout tempfile,'<input type="hidden" name="action" value="3">'
call lineout tempfile,'<input type="hidden" name="deffile" value="'||daindx||'">'
call lineout tempfile,'<input type="hidden" name="preview" value="0">'

if optname.!RESPFILE<>'' then
   call lineout tempfile,'<input type="hidden" name="respfile" value="'||optname.!RESPFILE||'">'


call lineout tempfile,'<em>For the CMS dataseries: </eM><b>'||stuff.!series||'</b><br>'
call lineout tempfile,'<table>'
call lineout tempfile,'<tr><th align="left">Last modified:</th><td>'||modified||'</td>'
call lineout tempfile,'<tr><th align="left"># of records currently in dataseries:</th><td>'||(nrecords)||'</td>'
call lineout tempfile,'<tr><th align="left">Description:</th><td>'||desc||'</td>'
if stuff.!HINT<>"" then do
  call lineout tempfile,'<tr><th bgcolor="#aabbaa" align="left">Hints:</th><td>'||stuff.!hint||'</td>'
end

call lineout tempfile,'</table>'
call lineout tempfile,'<p>Add a record, with the following values<p>'
call lineout tempfile,'<table>'

is_status=0
do ii=1 to varnames.0
   aname=varnames.ii ; atype=vartypes.ii
   aname0=aname
   if atype='A' then aname0='<EM>Abstract</em>'
  
   if aname='$STATUS' then do
     is_status=1
     iterate
   end

   call lineout tempfile,'<tr><td>'||aname0||'</td>'
   select 
      when atype='C' then do
         call lineout tempfile,'<td><input type="checkbox" name="-VAR_'||varnames.ii||'" value=1>'
      end
      when atype='M' then do
          call lineout tempfile,'<td><textarea rows=6 cols=80 name="-VAR_'||varnames.ii||'"></textarea>'
      end
      when atype='F' then do
          call lineout tempfile,'<td><table><tr>'
          call lineout tempfile,'<td><input size=55 type="FILE" name="-VAR_'||varnames.ii||'"></td>'
          call lineout tempfile,'<td> <em>enter a url (starting with http://),<br> or use the button to upload a file)</td>'
          call lineout tempfile,'</table>'
      end
      when atype="A" then do
          call lineout tempfile,'<td><input type="text" name="-VAR_'||varnames.ii||'" size=50></td>'
      end
      when atype="N" then do
          call lineout tempfile,'<td><input type="text" name="-VAR_'||varnames.ii||'" size=22> <em>(enter a number)</em></td>'
      end
      when atype="T" then do
          call lineout tempfile,'<td>'
          foo=write_datetime_input(varnames.ii,0)
          call lineout tempfile,'</td>'
      end

      when atype="S" then do
          vv2='!'||varnames.ii ; sfile=selfiles.vv2
          if sfile='' then do
              call lineout tempfile,'<TD><b>Error:</b> No  Select-Option specified for '||varnames.ii
              signal gooble
          end
          selstuff=sre_read_file(sfile,2,2,1)
          if selstuff='' then do
              call lineout tempfile,'<TD><b>Error:</b> Empty Select-Option file '||afile
              signal gooble
          end
       
          call lineout tempfile,'<td><Select size=1 name="-VAR_'||varnames.ii||'" '
          call lineout tempfile,' onChange="i1=this.selectedIndex ; a1=options[i1].value ; '
          call lineout tempfile,'  if (a1==''$''){ a2=options[i1].text ;  '
          call lineout tempfile,'     a3=window.prompt(''Enter value for: '' + a2 ) ;'
          call lineout tempfile,'     options[i1].value=a3 ; options[i1].text=options[i1].text + '' = '' + a3 ; '
          call lineout tempfile,'     }"> '

          do until selstuff=''
             parse var selstuff sline '0d0a'x selstuff; sline=strip(sline)
             if abbrev(sline,';')=1 | sline='' then iterate
             if pos('=',sline)>0 then do
                parse var sline sval '=' sdisp
             end
             else do
                 sval=strip(sline); sval=sdisp
             end
             isselected=' '
             if abbrev(sval,'(')=1 then do
                isselected=' SELECTED '; parse var sval  '(' sval ')' 
                if pos('=',sline)=0  then sdisp=sval
             end 
             sval=strip(sval)
             call lineout tempfile,'<OPTION '||isselected||' value="'||sval||'">'||sdisp
          end 
          call lineout tempfile,'</select>'
          call lineout tempfile,'</td>'

      end

      when atype="P" then do
          vv2='!'||varnames.ii ; pfile=polfiles.vv2
          if pfile='' then do
              call lineout tempfile,'<td><b>Error2:</b> No  poll-definition file specified for '||varnames.ii
              signal gooble
          end

          if pfile='*' then do          /* observation specific poll file */
               call sel1_polfile
          end
          else do
               call do1_poll
          end

      end

      otherwise do              /* string */
          call lineout tempfile,'<td><input type="text" name="-VAR_'||varnames.ii||'" size=80></td>'
      end
   end
end
call lineout tempfile,'</table>'

if is_status=1 then do   /* STATUS is determined by CMS -- the 0 is a placeholder */
  call lineout tempfile,'<input type="hidden" name="-VAR_$STATUS" value=0> '
end

call lineout tempfile,'<input type="submit" value="Add a record" '
call lineout tempfile,'  onClick="document.doadd.preview.value=0 ; document.doadd.target=''_self''"  '
call lineout tempfile,'>'
call lineout tempfile,'<em> or ... </em>'
call lineout tempfile,'<input type="submit" onClick="document.doadd.preview.value=1 ; document.doadd.target=''PREVIEW''"  value="Preview the record (without saving)">'

call lineout tempfile,'<br><input type="reset" >'

call lineout tempfile,'</form>'


gooble:         /* jump here on error */
a=sre_cache_data(stuff.!series,'CLOSE')

call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode



/************************/
/* ask for a poll file (for observation specific polls.) used by ask_values */

sel1_polfile:

call lineout tempfile,'<td>'
myfiledir=stuff.!filedir
avar=varnames.ii
call lineout tempfile,'<table border=1><tr><td><em>Pick an observation-specific<br>'
mdir=translate(myfiledir,'/','\')
call lineout tempfile,'<a target="poll" href="/CMS/cms_poll.cmd?doclose=1&action=5&fdir='||mdir||'">poll-definition file</a></em>...</td>'
oo=sysfiletree(cmsdir_pol||'\*.POL','ofiles','FO')
oo=sysfiletree(myfiledir||'\POLLS\*.POL','ofiles2','FO')
if ofiles2.0+ofiles.0=0 then do
  call lineout tempfile,'<td>There are <b>no</b> poll-definition files (.POL files) currently available in <tt>'||cmsdir_pol||'</tt>'
  call lineout tempfile,', or in <tt>'||fdir||'\POLLS </tt></td></table>'
  return 0
end
else do
   do j1=1 to ofiles.0
        ofiles.j1=filespec('n',ofiles.j1)
        parse var ofiles.j1 ofiles.j1 '.' .
    end 
    do j1=1 to ofiles2.0
        ofiles2.j1=filespec('n',ofiles2.j1)
        parse var ofiles2.j1 ofiles2.j1 '.' .
    end 
    call lineout tempfile,'<td>'
    call lineout tempfile,'<select name="-VAR_'||avar||'" size=1>'||'0d0a'x

    do mm2=1 to ofiles.0
        call lineout tempfile,'<option value="'||ofiles.mm2||'">'ofiles.mm2
    end 
    call lineout tempfile,'<option value="-"> - Series specific files-'
    do mm2=1 to ofiles2.0         /* note use of ~ in short name (~ signal filedir) */
            call lineout tempfile,'<option value="~'||ofiles2.mm2||'">'ofiles2.mm2
    end 
    call lineout tempfile,'</select>'
    call lineout tempfile,'</td></table></td>'
    return 1
end


/* never should get here */


/************************/
/* do a poll (used by ask_values) */
do1_poll:
polstuff=sre_read_file(pfile,2,2,1)
if polstuff='' then do
      call lineout tempfile,'<td><b>Error:</b> An empty poll-definition file '||afile
      signal gooble
end

vopts.=''
nopts=0
do until polstuff=''
   parse var polstuff aline '0d0a'x polstuff
   aline=strip(aline)
   if aline='' then iterate
   if abbrev(aline,';')=1 then iterate
   parse var aline a1 ':' a2
   a1=strip(translate(a1))
   r1=a1
   va1='!'||a1
   if vopts.va1='' then do
      vopts.va1=strip(a2)
      vopts.0=vopts.0||' '||a1
   end
   else do
      vopts.va1=vopts.va1||'0d0a'x||strip(a2)
   end
   if datatype(a1)='NUM' then do
         nopts=nopts+1
         vopts.nopts=a1
   end 
end   
vv='!?'

avar=varnames.ii
call lineout tempfile,'<td><table border=1><tr><td><em>You can add a poll response (otherwise,'
call lineout tempfile,'<br> this observation''s poll will start with 0 responses)</td>'

call lineout tempfile,'<td><font size=-1>'||vopts.vv||'</font><br>'
call lineout tempfile,'<Select size=1 name="-VAR_'||varnames.ii||'" >'
call lineout tempfile,'<option value=""  selected > ...'

/****     call lineout tempfile,' onChange="i1=this.selectedIndex ; a1=options[i1].value ; '
          call lineout tempfile,'  if (a1==''$''){ a2=options[i1].text ;  '
          call lineout tempfile,'     a3=window.prompt(''Enter value for: '' + a2 ) ;'
          call lineout tempfile,'     options[i1].value=a3 ; options[i1].text=options[i1].text + '' = '' + a3 ; '
          call lineout tempfile,'     }"> '
          do jjj=1 to words(vopts.0)
             aw=strip(Translate(word(vopts.0,jjj)))
             if datatype(aw)<>'NUM' then iterate
             vaw='!'||aw
             call lineout tempfile,'<option value="'||aw||'" > '||vopts.vaw
          end
****/
do jjj=1 to nopts
         aw=vopts.jjj
         vaw='!'||aw
         call lineout tempfile,'<option value="'||aw||'" > '||vopts.vaw
end
call lineout tempfile,'</select></td></table>'
call lineout tempfile,'</td>'

return 1


/*******************/
/* write a multi-field date-time input */
write_datetime_input:
parse arg vname,toaa


call lineout2 '<input type="hidden" name="-VAR_'||vname||'" value="compute">'

call lineout2 '<select name="$'||vname||'$DAY">'
call lineout2 '<option value="Day" selected >Day '
mlist='01 02 03 04 05 06 07 08 09 10 '||,
       ' 11 12 13 14 15 16 17 18 19 20 '||,
       ' 21 22 23 24 25 26 27 28 29 30 31 '
do mm=1 to words(mlist)
   aw=strip(word(mlist,mm))
   call lineout2 '<option value="'||aw||'">'||aw
end
call lineout2 '</select>'

call lineout2 '<select name="$'||vname||'$MONTH">'
call lineout2 '<option value="Month" selected >Month '
mlist='Jan Feb March April May June July Aug Sept Oct Nov Dec '
do mm=1 to words(mlist)
   aw=strip(word(mlist,mm))
   mm2=right(mm,2,'0')
   call lineout2 '<option value="'||mm2||'">'||aw
end
call lineout2 '</select>'

call lineout2 '<select  name="$'||vname||'$YEAR"'
call lineout2 'onChange=" if (this.options[1].selected) '
call lineout2  '  {ycust=prompt(''Enter a year (4 digits)'',1999) ;'
call lineout2 '    this.options[1].value=ycust ; this.options[1].text=ycust '
call lineout2 '}"' 
call lineout2 '>'

call lineout2 '<option value="Year" selected >Year '
call lineout2 '<option value="0"  >(other) '

mlist='2001 2002 2003 2004 2005 2006 2007 2008 2009 2010'
do mm=1 to words(mlist)
   aw=strip(word(mlist,mm))
   call lineout2 '<option value="'||aw||'">'||aw
end
call lineout2 '</select>'

call lineout2 '<select name="$'||vname||'$HOUR">'
call lineout2 '<option value="Year" selected >Hour '
mlist='12AM 1 2 3 4 5 6 7 8 9 10 11 12PM 1 2 3 4 5 6 7 8 9 10 11'
do mm=1 to words(mlist)
   aw=strip(word(mlist,mm))
   mm2=right(mm-1,2,'0')
   call lineout2 '<option value="'||mm2||'">'||aw
end
call lineout2 '</select>'

call lineout2 '<input type="text" size=6 name="$'||vname||'$MINUTE" value="Minute"> '

return ''

lineout2:
parse arg tmp1
if toaa=0 then
 call lineout tempfile,tmp1
else
 aa=aa||tmp1||'0d0a'x
return 1


/*******************/
/* save values to a cms record */
save_values:

call lineout tempfile,'<html><head><title>CMS: Add a record to a CMS dataseries</title></head> '

call lineout tempfile,'<font size=-1><a href="'||mainaddon||'?action=1">Another CMS action</a> || '

daindx=optname.!deffile
ff=cmsdir_index||'\'||daindx
goo=stream(ff,'c','query exists')
if goo='' then do
   call lineout tempfile,'</font><br>'
   call lineout tempfile,'<h3>   Add record to a CMS dataseries</h3> '
   call lineout tempfile,'Error: could not find index file: '||ff
   signal gooble
end

call lineout tempfile,'<a href="'||thisaddon||'?action=2&deffile='||daindx||'">Add another record</a>'
call lineout tempfile,'</font><br>'

call lineout tempfile,'<h3>    Add record to a CMS dataseries</h3> '

call read_deffile ff

/* check for access rights */
rcode=check_access(stuff.!OWNERS,stuff.!SERIES)
if rcode<>1 then return rcode

varnames=stuff.!varnames
vartypes=stuff.!vartypes
if words(varnames)<>words(stuff.!vartypes) then do
   call lineout tempfile,'Error: mismatch in vars and vartypes in '||ff
   signal gooble
end

vartypes.=''
varnames.=''
varnames.0=0
do mm=1 to words(varnames)
  avar=strip(translate(word(varnames,mm)))
  varnames.mm=avar
  atype=strip(translate(word(vartypes,mm)))
  varnames.mm.!type=atype
  vv='!'||avar
  vartypes.vv=atype
end
varnames.0=words(varnames)

a=sre_cache_data(stuff.!series,'OPEN  INDEX',stuff.!file)
if a>0 then do
   amess=sre_cache_data('OPEN','ERROR',a,stuff.!file)
   call lineout tempfile,'<b>Error:</b> '||amess
   signal gooble
end

a=sre_cache_data(stuff.!series,'INFO',,'MODIFIED RECORDS VARS DESCRIPTION')
parse var a astat a ; astat=strip(astat)
if astat<>'0' then do
   amess=sre_cache_data9('INFO','ERROR',astat)
   call lineout tempfile,'<b>Error retrieving info:</b> '||amess
   signal gooble
end
parse var a . '0d0a'x . '09'x modified  '=' . '09'x nrecords0 '09'x  vlist_sre '09'x  desc
nrecords=nrecords0-4


vlist=sre_cache_data(stuff.!series,'INFO',,'VARS')
parse upper var vlist astat . '0d0a'x . '09'x vlist2

/* check that the specials are in there */
do mm=1 to words(optname.!specials)
   aww=strip(translate(word(specials,mm)))
   if wordpos(aww,vlist2)=0 then do
       call lineout tempfile,'<b>Error</b>: Special variable ('||aww||') not in dataseries variables '||vlist2 
       signal gooble
   end 
end 

/* are there file variables? */
hasfiles=pos('F',vartypes)
if hasfiles>0 then do   /* check for okay filestorage directory */
  ddir=strip(strip(stuff.!UPLOADDIR),,'\')
  if right(ddir,1)=':' then ddir=ddir||'\'
  if dosisdir(ddir)=0 then do
    call lineout tempfile,'<b>Error:</b> bad file-storage directory: '||stuff.!UPLOADDIR
    signal gooble
  end
  ddir=strip(ddir,,'\')||'\'
end


/* poll variables (read from .DEF file)? */
ss=stuff.!poll
polfiles.=''
do until ss=''
   if ss='' then leave
   parse var ss s1 ';' ss
   parse var s1 svar '=' sfile0  ;sfile0=strip(sfile0) ; sfile=sfile0
   vvar='!'||strip(translate(svar))
   if sfile='*' then do   
     afile=sfile                /* signal to do more work (below) */
   end
   else do
     usedir=cmsdir_pol
     if abbrev(sfile,'~')=1 then do
       sfile=substr(sfile,2)
       usedir=strip(stuff.!filedir)||'\POLLS'
     end 
     afile=usedir||'\'||strip(sfile)||'.POL'
     if stream(afile,'c','query exists')='' then  afile='' /* signal a problem */
   end
   polfiles.vvar=afile
   polfiles.vvar.!sfile0=sfile0
   polfiles.!0=polfiles.!0||' '||strip(translate(svar))
end 


call lineout tempfile,'For dataseries:<tt>'||stuff.!series||'</tt><p>'

daid=sre_gmt(,,'JS',0)

allopt=translate(optname.0)         /* variables supplied by browser */
vdo.='' ; vdorig.='(not set)'
varsset=''
vars_got=''
pollvars_done=''

do until allopt=''

   parse var allopt avv allopt 
   avv=sre_packur(strip(translate(avv)))
   if abbrev(avv,'-VAR_')=0 then iterate
   parse var avv '-VAR_' avv2 .
   vv='!'||avv2

/* avv2 is the variable name, vv is the ! reference */

   atype=vartypes.vv

   if vartypes.vv='' then do
       call lineout tempfile,'<b>Error</b>: unknown variable '||avv2
       signal gooble
   end 

   if wordpos(avv2,varsset)>0 then do
      call lineout tempfile,'<b>Error</b>: more then one value given for variable '||avv2
      signal gooble
   end
        
   varsset=varsset||' '||avv2        

   if is_multipart then
      avv3='!-VAR_'||avv2
   else
      avv3='!!-VAR_'||avv2

   vdo.vv=optname.avv3
   if vv='!$STATUS' then do         /* set current status */
       vdo.vv=' CMT_CNT=0 CMT_MOD=0 MOD='||daid
   end

   if vdo.vv<>'' then vars_got=vars_got||' '||avv2

   vdorig.vv=vdo.vv             /* used in response files */

   if atype='T' then do
     if translate(vdo.vv)='COMPUTE' then do
        aa=cvt_datetime(avv2)
        if aa=1 then do
           vdo.vv=j_time
           vdorig.vv=use_time||'='||j_time
        end
        else do
           call lineout tempfile,'Time entry error ('||use_time||'): '||aa
           signal gooble
        end
     end
   end

   if atype='M' then do
       vdo.vv=sre_pack64_make(vdo.vv)   /* PACK64 it, so as to retain crlfs, etc */
   end 
   if atype='N' then do
       if vdo.vv='' then vdo.vv=0
       if datatype(vdo.vv)<>'NUM' then do
          call lineout tempfile,'<B>Error.</b> Non-number entered in a <tt>Number</tt> variable.'
          call lineout tempfile,'<br><a href="javascript:history.go(-1)">Go back and fix it.</a>'
          signal gooble
       end 
   end 
   if atype='F' then do      /* a file, save contents and save filename*/
      tryme=optname.avv3.!FILENAME
      if tryme='' then iterate   /* empty, leave it alone */
      if abbrev(strip(tryme),'HTTP://')=1  then do      /* download a URL */
         daurl=strip(optname.avv3.!!FILENAME)
         tmp1=sre_get_url(daurl,max_url_size)

         vdorig.vv=daurl

         parse var tmp1 hdrs '0d0a0d0a'x acontent 

         if length(acontent) >= max_url_size then do
            call lineout tempfile,'<b>Error:</b> URL (<tt>'||daurl||')</tt>  contents exceed maximum of 'max_url_size
            signal gooble
         end

         parse var hdrs aline '0d0a'x hdrs
         parse var aline . icode . ; icode=strip(icode)
         if abbrev(icode,'2')=0 then do         /* failure */
            call lineout tempfile,'<b>Error:</b> problem downloading URL'
            call lineout tempfile,'<pre>'||aline||'</pre>'
            signal gooble
         end 
         
         do until hdrs=''
            parse var hdrs aline '0d0a'x hdrs
            parse var aline typec ':' valc
            if translate(strip(typec))='CONTENT-TYPE' then do
                optname.avv3.!CONTENT_TYPE=strip(valc)
                leave
            end 
         end 
         vdo.vv=acontent
         parse var tryme . '//' uuu '/' .
         uuu=translate(uuu,' ','.') 
         ll=max(1,words(uuu)-1)
         aww=strip(word(uuu,ll))
         tryme=aww||'.URL'
      end
      else do           /* check uploaded file size */
         if length(acontent) >= max_file_size then do
            call lineout tempfile,'<b>Error:</b> file (<tt>'||tryme||')</tt> size exceeds maximum of 'max_file_size
            signal gooble
         end
      end
   
      if pos('.',tryme)='' then tryme=tryme||'.'
      tryme2=ddir||tryme
      if stream(tryme2,'c','query exists')<>'' then do  /* modify the suggested filename */
         t1=tryme||'_????'
         sfile=sre_tempfile(t1,,ddir)
      end
      else do
         sfile=tryme2
      end 
      if optname.!PREVIEW<>1 then arf=sre_append_file(sfile,vdo.vv,2,,1)  /* don't actualy save file if preview enabled */
      if arf<0 then do
         call lineout tempfile,'<b>Error:</b> unable to store uploaded file to 'ddir
         signal gooble
      end
      vdo.vv=optname.avv3.!!FILENAME||'='||filespec('n',sfile)||' ; content-type='||optname.avv3.!CONTENT_TYPE
      vdorig.vv=vdo.vv
   end          /* file upload */

   if atype='P' then do         /* make a Nchoices+1 x 1 vector. First item =1, choice =1, all others=0 */
       pfile=polfiles.vv
       doingdef=0
       if pfile='*' then do
          doingdef=1
          sfile=strip(vdo.vv) ; sfile0=sfile
          if sfile="-" then do
              call lineout tempfile,'<b>Error:</b> CMS_ADD: No observation-specific poll-definition file specified for '||avv2
              signal gooble
          end
       end 
       else do
          sfile=strip(polfiles.vv.!sfile0)
          sfile0=sfile
       end 
       usedir=cmsdir_pol
       if abbrev(sfile,'~')=1 then do
             sfile=substr(sfile,2)
             usedir=stuff.!filedir||'\POLLS'
        end 
       pfile=usedir||'\'||strip(sfile)||'.POL'

       if pfile='' then do
              call lineout tempfile,'<b>Error:</b> CMS_ADD: No poll-definition file specified for '||avv2
              signal gooble
       end
       polstuff=sre_read_file(pfile,2,2,1)
       if polstuff='' then do
           call lineout tempfile,'<b>Error:</b> CMS_ADD: for 'avv2', an empty poll-definition file ['||pfile||']'
           signal gooble
       end
       vopts.='' ; daques=''
       nopts=0 ; noptlist=''
       do until polstuff=''
          parse var polstuff aline '0d0a'x polstuff
          aline=strip(aline)
          if aline='' then iterate
          if abbrev(aline,';')=1 then iterate
          parse var aline a1 ':' a2
          a1=strip(translate(a1))
          va1='!'||a1
          
          if datatype(a1)='NUM' then do
             if wordpos(a1,noptlist)=0 then do
               nopts=nopts+1
               vopts.nopts=a1
               noptlist=noptlist||' '||a1
             end
          end 
          if a1='?' then daques=daques||' '||strip(a2)
       end   
       tmp1=left('1',6,' ')
       if vdo.vv='' | doingdef=1 then  tmp1=left('0',6,' ')

       do jj=1 to nopts  
          adda=left('0',6,' ')
          if doingdef=0 & vdo.vv=vopts.jj then adda=left('1',6,' ')
          tmp1=tmp1||adda
       end
       vdo.vv=tmp1||' :'||left(sfile0,max(length(sfile0),15),' ')||','||left(daques,40,' ')||':'
       vdorig.vv=vdo.vv

       pollvars_done=pollvars_done||' '||avv2
   end          /* p type */


end 

/* check "required" */
if optname.!REQUIRED<>'' then do
   didnt_do=''
   do mm=1 to words(optname.!REQUIRED)
       aw=strip(translate(word(optname.!REQUIRED,mm)))
       if wordpos(aw,vars_got)=0 then didnt_do=didnt_do||' '||aw
   end 
   if didnt_do<>'' then do      /* oops, user forgot to enter values for at least 1 required variable */
        call lineout tempfile,'<b>Error:</b> you did not enter values for the following required variables:<tt>'||didnt_do||'</tt>'
        call lineout tempfile,'<br><a href="javascript:history.go(-1)">Go back and fix it.</a>'
        signal gooble
   end
end 


/* check that all poll vars done */
didntdo=''
spoll=stuff.!poll
do mm=1 to words(polfiles.!0)
   aww=strip(translate(word(polfiles.!0,mm)))
   if wordpos(aww,pollvars_done)=0 then do
        didntdo=didntdo||' '||aww
   end
end
if didntdo<>'' then do
        call lineout tempfile,'<b>Error:</b> you did not enter initialization for the following poll variables:<tt>'||didntdo||'</tt>'
        call lineout tempfile,'<br><a href="javascript:history.go(-1)">Go back and fix it.</a>'
        signal gooble
end



/* now write two types: packed and "special" 
   data_var1 = packed values
   data_var2 = index to data_var1
   data_var3 .. = special vars
*/


specs.=''
if stuff.!pack='' then do
   data_var1=''
   data_var2=0
end 
else do
   data_var1=''
   data_var2=''
   do nn=1 to words(stuff.!pack)
       aww=strip(translate(word(stuff.!pack,nn)))
       vv='!'||aww
       if vartypes.vv='' then do
          call lineout tempfile,'Error: unknown packed variable '||aww
          signal gooble
       end 
       data_var1=data_var1||vdo.vv
       klen=length(vdo.vv)
       data_var2=data_var2||klen||' ' 
   end
end 

ltot=length(data_var1)+length(data_var2)

/* and the special variables */
if stuff.!specials='' then do
  specs.=''
end
else do                 /* there should ALWAYS be a $STATUS special-variable */
   do nn=1 to words(stuff.!specials)
       aww=strip(translate(word(stuff.!specials,nn)))
       vv='!'||aww
       if vartypes.vv='' then do
          call lineout tempfile,'Error: unknown special variable '||aww
          signal gooble
       end 
       specs.nn=vdo.vv
   end
   ltot=ltot+length(specs.nn)
end

/* record too big? */
if ltot>max_record_size then do
   call lineout tempfile,'Error: record size (<tt>'||ltot||'</tt>) is too large (maximum is '||max_record_size||' bytes)'
   signal gooble
end


/* preview mode? */
if optname.!PREVIEW=1 then do
  a=sre_cache_data(stuff.!series,'CLOSE')
  call do_preview
  call lineout tempfile,'</body> </html>'
  call lineout tempfile
  rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
  return rcode
end

/* else, write the record */

do mm=1 to 100
  poo=sre_cache_data(stuff.!series,'ADD WRITE',daid,,
              data_var1,data_var2,specs.1,specs.2,specs.3,specs.4,specs.5,specs.6,specs.7,specs.8)

  if poo=6 then do              /* on the slight chance that someone else added a record 
                                   within the last second */
     call syssleep(1)
     daid=sre_gmt(,,'JS',0)
     iterate
  end 

  leave
end 


gooble:         /* jump here on error */


a=sre_cache_data(stuff.!series,'CLOSE')

if lengtH(poo)>1 then
  call lineout tempfile,'New record created using id: <TT>'||daid||'</tt><em> ( '||poo||' ) </em>'
else
  call lineout tempfile,'<p>Unable to create new record -- try again later <p>'


/* well... use a response file instead? */
rfile=optname.!respfile
if rfile='' then do
  call lineout tempfile,'</body> </html>'
  call lineout tempfile
  rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
  return rcode
end

/* well... use a response file instead? */

cmtdir=stuff.!FILEDIR
if cmtdir<>'' then
   tfile=fix_file(rfile,strip(cmtdir,,'\')||'\')
else
   tfile=fix_file(rfile,strip(cmsdir_lib,,'\')||'\')
if stream(tfile,'c','query exists')='' then do
  tfile=fix_file(rfile,strip(cmsdir_lib,,'\')||'\')
  if stream(tfile,'c','query exists')='' then do
     tfile=''
     return 'string CMS Error: unable to find CMS data file: '||tfile
  end
end

If tfile<>'' then do
  stuff=sre_read_file(tfile,2,2,1)
  if stuff='' then tfile=''
end
if tfile='' then do
  call lineout tempfile,'<p><b>Note:</b> unable to use response file <tt>'||rfile||'</tt>'
  call lineout tempfile,'</body> </html>'
  call lineout tempfile
  rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
  return rcode
end

call lineout tempfile   /* otherwise, use response file (and delete tempfile) */
foo=sysfiledelete(tempfile)

/* now do string replacements */

/*
         CURRENT_DATETIME  : The current date and time (in GMT)
         HINT          : hint: from .def file
         SERIES        : The name of this dataseries 
         DESC          : Short description of the dataseries
         RECID         : Record id of the record just added
         LENGTH        : length (in bytes) of the record just added
         TOTALRECORDS: Total # of records in dataseries
         VARS       : a space delimited list of the variables in the   dataseries (including $ABSTRACT)
         VARSET     : a space delimited list of the variables that were set
         VARNOTSET  : a space delimited list of the variables that were not set
         VARTYPES   : a space delimited list of the types of the variables in the dataseries
*/

stuff=sre_replacestrg(stuff,'<!--CURRENT_DATETIME-->',sre_datestamp(),'ALL')
stuff=sre_replacestrg(stuff,'<!--HINT-->',stuff.!hint,'ALL')

stuff=sre_replacestrg(stuff,'<!--SERIES-->',stuff.!series,'ALL')
stuff=sre_replacestrg(stuff,'<!--DESC-->',stuff.!desc,'ALL')
stuff=sre_replacestrg(stuff,'<!--RECID-->',daid,'ALL')
stuff=sre_replacestrg(stuff,'<!--LENGTH-->',ltot,'ALL')
stuff=sre_replacestrg(stuff,'<!--TOTALRECORDS-->',(nrecords+1),'ALL')
stuff=sre_replacestrg(stuff,'<!--VARS-->',varnames,'ALL')
stuff=sre_replacestrg(stuff,'<!--VARTYPES-->',vartypes,'ALL')
parse var varsset p1 '$STATUS' p2 ; varsset=p1||' '||p2
stuff=sre_replacestrg(stuff,'<!--VARSET-->',varsset,'ALL')
vnot=''
do mm=1 to words(varnames)
    aw=strip(translate(word(varnames,mm)))
    if aw='$STATUS' then iterate
    if wordpos(aw,varsset)>0 then iterate
    vnot=vnot||' '||aw
end
stuff=sre_replacestrg(stuff,'<!--VARNOTSET-->',vnot,'ALL')
do mm=1 to words(varnames)
    aw=strip(translate(word(varnames,mm)))
    v2='!'||Aw
    stuff=sre_replacestrg(stuff,'<!--%'||aw||'-->',vdorig.v2,'ALL')
end

rcode=sre_command('VAR ETAG_AUTO EXPIRES 30s NOCACHE NOIF  TYPE text/html  ',stuff,idinfo)
return rcode


/****************************************/
/* preview entries before saving */
do_preview:

call lineout tempfile
foo=sysfiledelete(tempfile) 

call lineout tempfile,'<html><head><title>CMS: Preview a record</title></head> '
call lineout tempfile,'<body>'
call lineout tempfile,'<font size=-1><a href="javascript:close()">close window</a>'
call lineout tempfile,'</font>'


call lineout tempfile,'<hr><h3>Preview entries before saving a record </h3> '

call lineout tempfile,'<table>'

call lineout tempfile,'<em>For the CMS dataseries: </eM><b>'||stuff.!series||'</b><br>'
call lineout tempfile,'A record, with the following values, will be saved to the dataseries.<p>'

do ii=1 to varnames.0
   aww=varnames.ii ; vv='!'||aww ; vv2='!'||vv
   atype=vartypes.vv
   aname=aww
   if atype='A' then aname='Abstract'
   if abbrev(aname,'$S')=1 then iterate

   aval1=vdorig.vv

   if atype='M' then do
      aval1=sre_replacestrg(aval1,'0d0a'x,'<BR>','ALL')
   end 
   aval1=sre_html_encode(aval1)
   
   call lineout tempfile,'<tr><th align="left" >'||aname||'</th><td>'||aval1||'</td>'
end 
call lineout tempfile,"</table>"


gooble:         /* jump here on error */

call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode




/******/
/* convert datetime fields to a datetime */
cvt_datetime:procedure expose optname. j_time use_time
parse arg aww2

      j_time='' ;  use_time=''

      vv='!$'||aww2||'$DAY'
      tday=optname.vv
      if datatype(tday)<>'NUM' then  return 'Bad day value: 'tday
      if tday<1 | tday>31 then return 'Bad day value (not between 1 and 31): 'tday
      tday=right(tday,2,'0')

      vv='!$'||aww2||'$MONTH'
      tmonth=optname.vv
      if datatype(tmonth)<>'NUM' then  return 'Bad month value: 'tmonth
      if tmonth<1 | tmonth>12 then return 'Bad month value (not between 1 and 12): 'tmonth
      tmonth=right(tmonth,2,'0')

      vv='!$'||aww2||'$YEAR'
      tyear=strip(optname.vv)
      if datatype(tyear)<>'NUM' then  return 'Bad year value: 'tyear
      if length(tyear)<>4 then  return 'Bad year value (must be 4 digits): 'tyear

      goo=dateconv(tyear||tmonth||tday,'S','B')
      if goo='' then return 'Error: bad date entry: '||tyear' 'tmonth' 'tday
      goo=goo-726467

      vv='!$'||aww2||'$HOUR'
      thour=optname.vv
      if datatype(thour)<>'NUM' then thour='0'
      if thour<0 | thour>23 then return 'Bad hour value (must be between 0 and 23): 'thour

      vv='!$'||aww2||'$MINUTE'
      tminute=optname.vv
      if datatype(tminute)<>'NUM' then tminute='0'
      if tminute<0 | tminute>59 then return 'Bad minute value (must be between 0 and 59): 'tminute

       goo2=((thour*60)+tminute)/1440
       if goo2>1 | GOO2<0 then return 'Error: bad time-of-day entry: '||thour' 'tminute
       parse var goo2 . '.' goo2

       j_time=goo||'.'||goo2

      mlist='Jan Feb March April May June July Aug Sept Oct Nov Dec '
      tmonth2=word(mlist,tmonth)
      avalt=right(tday,2,'0')||' 'tmonth2' 'tyear' '||right(thour,2,'0')||':'||right(tminute,2,'0')
      use_time=avalt

      return 1


/*************/
/* read a definition file */
read_deffile:
parse arg afile
stuff.=''
stuff=sre_read_file(afile,2,2,1)
do until stuff=''
   parse var stuff aline '0d0a'x stuff ; aline=strip(aline)
   if aline='' then iterate
   if abbrev(aline,';')=1 then iterate
   parse var aline aname ':' avalue
   aname='!'||strip(translate(aname))
   if stuff.aname='' then
      stuff.aname=strip(avalue)
   else
      stuff.aname=stuff.aname||'0d0a'x||strip(avalue)

end

return 1




/******************/
/* read a multipart/form-data type of submission 
(that a web browser could submit when responding to a form
with an action of POST and an enctype of "multipart/form-data")

syntax:
   astatus=parse_multipart(post_body)
where post_body is the body of the POST response (from the browser)

Data is returned in the OPTNAME. stem variable (which is exposed)

  optname.0 =space delimited  list of variable names
  optname.!varname = contents of the "varname" variable (varname is one of the words
                     stored in varname.0)
  optname.!varname.!filename = if the contents are due to submission of a file,
                               this contains the name of the file (as supplied by
                               the browser). Otherwise, it is blank
  optname.!varname.!CONTENT_TYPE = if the contents are due to submission of a file,
                                   this contains the content-type. If no content-type
                                   was specified, this will be text/plain.
                                   If NOT due to a file submission, this is blank.

Astatus contains status info:
  0 = Success
  1 = Not a multipart/form-data 
  2 = No multipart/form-data in content-type 
  3 = No boundary 
  4 = No data recieved 


*/
parse_multipart:procedure expose optname.
parse arg abody

crlf='0d0a'x
rept=''

optname.=''

/*get content type request header */
atype=sre_reqfield('content-type')

/*typical value of atype
      multipart/form-data; boundary=---------------------------309151678928465
*/

/* is there a content-type request header ? */
if atype="" then do
    return 1
end

parse var atype thetype ";" boog 'boundary=' abound0    /* get the type */

abound="--"||strip(abound0)  /* since boundaries always start with -- */

if strip(translate(thetype))<>"MULTIPART/FORM-DATA" then do
   return 2
end

if abound="" then do
   return 3
end

/* basic status okay. So pull out stuff */

abd1=crlf||abound
abd2=abound

/* A multi-part submission typically has the following structure:

   Content-Type: multipart/form-data; boundary=AaB03x

   --AaB03x
   Content-Disposition: form-data; name="personal_name"

   Larry
   --AaB03x
   Content-Disposition: form-data; name="myfile"; filename="file1.txt"
   Content-Type: text/plain

   ... contents of file1.txt ...
   --AaB03x--

  Thus, processing works by:
   a) pull out a block, where blocks are defined by "boundary strings"
   b) for each block, pull out the headers, where the headers end at the first
      blank line
   c) the contents is everything remaining in the block, after this empty line
   
  There are two important headers, the content-disposition and content-type.
  If the content-disposition contains a  filename="xx" field, then this block
  contains a FILE upload. Otherwise, this block contains the value of a regular form
  field (such as an <INPUT type="TEXT" var="personal_name"> element)

  The content-type is sometimes also sent by the browser.
 
*/

parse var abody foo1 (abd2) abody    /* move beyond first boundary and it's crlf */

/* check for netscape 2.0 incorrect format */
if pos(abound,abody)=0 then do   /* no ending boundary, so add one */
   abody=abody||crlf||abound||" -- "
end
mm=0

do until abody=""
  if mm>0 then do
    if abbrev(abody,'--')=1 then leave        /* -- signals no more */
  end

  parse var abody . (crlf) thestuff (abd1) abody        /* get a  boundary defined block */
  mm=mm+1

  varname=''
  filename=''
  ctype=''

/* we have a "block", as delimited by the boundary string. */

  do forever            /* get block headers.  Stop when hit a blank line */
     parse var thestuff anarg (crlf) thestuff

     if anarg="" then do                /* empty line means "end of headers */
           leave
     end
     else do                    /* extract the arguments on this line */
         parse var anarg ahd ':' anarg
         ahd=strip(translate(ahd))
         select
            when ahd='CONTENT-TYPE' then do
                ctype=strip(anarg)
            end 
            otherwise do                /* strip out arguments */
               do until anarg=''
                  parse var anarg anarg1 ';' anarg
                  if pos('=',anarg1)='' then iterate
                  parse var anarg1 cvar '=' cval
                  cval2=strip(strip(cval),,'"')
                  cvar=strip(translate(cvar))
                  select               
                    when cvar="NAME" then varname=strip(translate(cval2))          /* name of this block */
                    when cvar="FILENAME" then filename=strip(cval2)   /* original file name */
                    when cvar="CONTENT-TYPE" then strip(cval2)        /* some browsers might send this here */
                    otherwise nop               /* ignore other arguments */
                  end           /* select */
               end     /* extract arguments */
            end        /* otherwise */
         end            /* select */
     end                /* else do*/
   end                    /* get a line */

/* when here, got a block's headers. The rest is the content of the block (i.e.;
   the value of a variable */
  if varname='' then iterate            /* no name, so ignore */
  vv=strip(translate(varname))
  optname.0=optname.0||' '||vv
  vv1='!'||vv
  optname.vv1=thestuff
  optname.vv1.!filename=translate(filename)
  optname.vv1.!!FIlename=filename
  if filename<>'' & ctype='' then ctype='text/plain'
  if filename<>'' then optname.vv1.!content_type=ctype

end             /* back to top to get the next block */


if mm=0 then do
     return 4
end


return 0


/******************************/
/* check access rights. Return 1 if okay. Otherwise, return a string to be
  sent back to SREhttp/2 (an authorization response string) */
check_access:procedure expose privset host_nickname idinfo uri aiter
parse  upper arg owners,series

if owners='' then return 1      /* no owners listed, means open access */
tpr=translate(aiter '== 'privset)
pneeded=space(translate('CMS:'||strip(series)),0)
if wordpos(pneeded,tpr)>0 then return 1          /* explicit privilege for this */
if wordpos('SUPERUSER',tpr)>0 then return 1

/* see if a cookie exists */
look_cook='CMS_'||series
aa=sreh2_get_cookie(lookcook)
if aa=1  then return 1 

if aiter=''  then do            /* first time, so recheck privs */
  return 'PRIVS   Access to this dataseries is restricted to specific users '
end 

/* otherwise, see if a username has been sent  */
username=''
authh=sre_reqfield('Authorization')
if authh<>'' then username=sre_extract_username(authh) 
if username='' then do             /* no username available */
  return  'AUTH  Access to this dataseries is restricted to specific users '
end

/* is this one of the OWNERS? */
if pos('*',owners)=0 then do            /* * means "any user" */
if wordpos(translate(username),translate(owners))=0 then do
   return 'AUTH  Access to this dataseries is restricted to specific users '
end
end

/* One of the OWNERS, now check password */
stuff=sreh2_get_userinfo(authh,host_nickname,idinfo)
if stuff='' then do
  return 'AUTH   Access to this dataseries is restricted to specific users. Please enter a new username/password.'
end

parse var uri thisaddon '?' .
jj=lastpos('/',thisaddon)
pp=left(thisaddon,jj)

foo=sreh2_set_cookie(lookcook,1,'30m',pp,,1)

/* if here, legit user.  Record a cookie */
return 1

/****
call lineout tempfile,optname.0
do until optname.0=''
   parse var optname.0 k1 optname.0
   k11='!'||k1
   call lineout tempfile,k1 ': 'optname.k11.!filename', 'optname.k11.!content_type ' == 'optname.k11
end
call lineout tempfile
return 'file erase type text/plain name 'tempfile
***/

/************/
/* figure out a filename, possibly randomized, possibly relative to a directory of a 
reference file*/
fix_file:procedure
parse arg afile,reffile,noast,ith,doover

afile=strip(afile)
if abbrev(afile,'\')=0 & pos(':',afile)=0 then do     /* relative filename */
  afile=strip(filespec('d',reffile)||filespec('p',reffile),,'\')||'\'||afile
end
if pos('*',afile)+pos('?',afile)=0 then return afile  /* no randomization component */

if noast=1 then return afile

if doover=1  then do                    /* use ITH to determine file name (don't search for unused name)*/
  if pos('*',afile)=0 then return afile||'_'||ith
   parse var afile p1 '*' p2 ; afile=p1||ith||p2
  return afile
end

if pos('*',afile)>0 then do
     parse var afile p1 '*' p2 ; afile=p1||'????'||p2
end 
fpath=filespec('d',afile)||filespec('p',afile)
fname=filespec('n',afile)
aname=sre_tempfile(fname,'?',fpath)

return aname




