/* The SREhttp/2 content management system (CMS) program 
Backup (to data\archive) the several components of a CMS dataseries.

*/

/******** User changeable parameters ***/
/* root directory for the SREhttp/2 CMS addon.
   Leave blank to use default (CMS subdirectory of srehttp/2 addon directory */
cmsdir=''


/******** end of user changeable parameters ***/


parse arg list,servername,verb,tempfile,,
          prog_file,reqnum,verbose,client_ip,privset,,
          uri,host_nickname,idinfo,aiter,attribs,seluse2

crlf='0d0a'x

if verb=" " then do
   say "This SREhttp/2 procedure is not meant to be run in standalone mode "
   exit
end  

addon_dir=sre_value('H2_ADDON_DIR_DEFAULT',,'SRE')
if cmsdir='' then cmsdir=strip(addon_dir,,'\')||'\CMS'
foo=dosisdir(cmsdir)
if foo=0 then return 'String Error:unable to find CMS directory: ('cmsdir

cmsdir_data=cmsdir||'\DATA'
okk=dosisdir(cmsdir_data)
if okk=0 then do
  return 'string unable to find CMS data directory: 'cmsdir_data
end

cmsdir_files=cmsdir||'\FILES'
okk=dosisdir(cmsdir_files)
if okk=0 then do
  return 'string unable to find CMS working-files directory: 'cmsdir_files
end


cmsdir_archive=cmsdir||'\DATA\ARCHIVE'
okk=dosisdir(cmsdir_archive)
if okk=0 then do
  return 'string unable to find CMS archive directory: 'cmsdir_archive
end


cmsdir_index=cmsdir||'\INDEX'
okk=dosisdir(cmsdir_index)
if okk=0 then do
  return 'string unable to find CMS index directory: 'cmsdir_index
end

parse var uri thisaddon '?' .
jj=lastpos('/',thisaddon)
if jj=0 then
  cmsroot='/'
else
  cmsroot=left(uri,jj)
mainaddon=cmsroot||'cms.cmd'

ii=lastpos('/',thisaddon)

optname.=''
m=0
if list='' then list='action=1'
do until list=""
    parse var list opt1 '&' list
    m=m+1
    parse var opt1 avar '=' aval ; avar=strip(translate(avar)) 
    optname.0=optname.0||' '||avar
    aval=translate(aval,' ', '+')
    aval=sre_packur(aval)
    avar1='!!'avar
    if optname.avar1<>'' then
       optname.avar1=optname.avar1||' '||aval
    else
       optname.avar1=aval
    avar2='!'avar
    aval2=strip(translate(aval,' ','090a0d'x))
    optname.avar2=aval2
end

/***** End of GENERIC CMS addon code *****/

if optname.!action='1' then do   /* find the list of dataseries defined for this host*/
  call show_datafiles
  foo=result
  return foo
end

if optname.!action='2'  & optname.!DOLIST=1 then do  /* list arcives, with restore */
  call dolist1
  foo=result
  return foo
end


if optname.!action='2'  & optname.!DOLIST=2 then do  /* list arcives, with delete */
  call dolist2
  foo=result
  return foo
end

if optname.!action='2'  & (optname.!DOLIST='' | optname.!DOLIST=0) then do   /* do a backup */
  call dobackup1
  foo=result
  return foo
end


if optname.!action='3' then do   /* verify restoration */
  call do_restore1
  foo=result
  return foo
end


if optname.!action='5' then do   /* do restoration*/
  call do_restore2
  foo=result
  return foo
end

if optname.!action='6' then do   /* do restoration*/
  call do_delete1
  foo=result
  return foo
end


if optname.!action='7' then do   /* do restoration*/
  call do_delete2
  foo=result
  return foo
end


return "no such action: "optname.!action ',' optname.!dolist

/*******************/
/* pick one of the current cms datafiles (for this host) */
show_datafiles:

call lineout tempfile,'<html><head><title>CMS: Backup a CMS datafile</title> '


call lineout tempfile,'<font size=-1><a href="'||mainaddon||'?action=1">Another CMS action</a></font><br>'

call lineout tempfile,'<h3> Backup a CMS dataseries</h3><p> '

ahost=host_nickname

/* look for files, in cmsDIR_index dir, of the form: ahost_nnnn.DEF
   These .DEF files define "CMS indices" --- nnnn is a number from 0 to 9999
*/

call lineout tempfile,'<FORM name="back1" action="'||thisaddon||'" method="POST">'
call lineout tempfile,'<input type="hidden" name="action" value="2">'
call lineout tempfile,'<input type="hidden" name="DOLIST" value="0">'

ff=cmsdir_index||'\'||ahost||'*.DEF'
goo=sysfiletree(ff,'ff2','FO')

call lineout tempfile,'For host: <Tt>'||ahost||'</tt>, the following CMS dataseries currently exist'

call lineout tempfile,'<table border=1>'
do jj=1 to ff2.0
   daname=filespec('n',ff2.jj)
   call read_deffile ff2.jj
   call lineout tempfile,'<tr><th align="left">' 
   call lineout tempfile,'<INPUT TYPE="RADIO"  name="deffile" value="'||daname||'">'
   gob=strip(stuff.!series)||'</th>'
   call lineout tempfile,gob||'<td> <em>&nbsp;'||stuff.!desc||'</em></td>'
end

call lineout tempfile,'</table>'

call lineout tempfile,'<p>'
call lineout tempfile,'<table>'
call lineout tempfile,'<tr><th>'
call lineout tempfile,'<em>After selecting<br> a dataseries, <br>you can ....</em>'
call lineout tempfile,'</th><td>'
call lineout tempfile,'<table>'

call lineout tempfile,'<tr bgcolor="#aaaaaa"><td>Enter a descriptive note:'
call lineout tempfile,'<input type="text" size=60 name="NOTE"><br>'
call lineout tempfile,'and then '
call lineout tempfile,'<INPUT name="sub2" TYPE="submit" VALUE="backup the CMS dataseries" '
call lineout tempfile,'onClick="document.back1.DOLIST.value=0">'

call lineout tempfile,'<tr><th ><em>or...</em></th>'

call lineout tempfile,'<tr bgcolor="#bbbbbb"><td>List current backups, '
call lineout tempfile,'<input type="submit" onClick="document.back1.DOLIST.value=1" '
call lineout tempfile,' value="and restore  one of them"></tD>'

call lineout tempfile,'<tr><th ><em>or...</em></th>'

call lineout tempfile,'<tr bgcolor="#bbbbbb"><td>List current backups, '
call lineout tempfile,'<input type="submit" onClick="document.back1.DOLIST.value=2" '
call lineout tempfile,' value="and  delete one of them"></tD>'



call lineout tempfile,'</td>'
call lineout tempfile,'</table>'

call lineout tempfile,'</td>'
call lineout tempfile,'</table>'

call lineout tempfile,'<input type="reset">'

call lineout tempfile,'</form>'

call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode


/*******************/
/* list the dataseries, with restore optin */
dolist1:

call lineout tempfile,'<html><head><title>CMS: Restore a backup of a dataseries</title> '
call lineout tempfile,'<script language="javascript">'


call lineout tempfile,'</head><body>'
call lineout tempfile,'<font size=-1>'
call lineout tempfile,'<a href="'||mainaddon||'?action=1">Another CMS action</a> || '
call lineout tempfile,'<a href="'||thisaddon||'?action=1">Choose a different dataseries</a>  '
call lineout tempfile,'</font><hr>'

aa=cmsdir_archive||'\*.SUM'             /* find summary files for backups */
arf=sysfiletree(aa,'fils','O')

daindx=optname.!deffile

if daindx='' then do
   call lineout tempfile,'You forgot to select a dataseries. Go <a href="javascript:history.go(-1)">back</a> and try again.'
   signal gooble
end 

ff=cmsdir_index||'\'||daindx
goo=stream(ff,'c','query exists')
if goo='' then do
   call lineout tempfile,'Error: could not find index file: '||ff
   signal gooble
end
daindx_file=ff

call read_deffile ff
/* check for access rights */
rcode=check_access(stuff.!OWNERS,stuff.!SERIES)
if rcode<>1 then return rcode

call lineout tempfile,'<h3 align="center">Restore a CMS dataseries from a backup</h3> '

if fils.0=0 then signal gooble


call lineout tempfile,'The following backups are available for the CMS dataseries <b>'||stuff.!series||'</b>, under host <u>'||host_nickname||'</u><p>'
call lineout tempfile,'<form method="POST" action="'||thisaddon||'">'
call lineout tempfile,'<input type="hidden" name="deffile" value="'||daindx||'">'
call lineout tempfile,'<input type="hidden" name="action" value=3>'

call lineout tempfile,'<table><tr><td>When you check one of the</td>  '
call lineout tempfile,'<td bgcolor="#eeeeee"><input type="radio"  name="RESTORE" value="">'
call lineout tempfile,'<em>radio buttons</em>,</td><td> you can then'
call lineout tempfile,'<input type="submit" value="restore the CMS dataseries"></td></table>'


/* remove non archive files */
ii=0
do i=1 to fils.0
    aname=filespec('n',fils.i)
    if substr(aname,9,1)<>'$' then iterate
    adate=left(aname,8)
    if datatype(adate)<>'NUM' then iterate
    ii=ii+1
    fils2.ii=aname
end 
fils2.0=ii

/* check each summary file, keep if series and host match */
call lineout tempfile,'<ol type="i">'

do mm=1 to fils2.0

   stuff=sre_read_file(cmsdir_archive||'\'||fils2.mm,2,2,1)
 
   if stuff='' then iterate
   call do_stuff
   if translate(opts.!SERIES)<>strip(translate(stuff.!SERIES)) then iterate
    v1=translate(opts.!host)
    v2=strip(translate(host_nickname))
    if v1<>v2 then iterate

    call lineout tempfile,'<li> '
    call lineout tempfile,'<INPUT TYPE="radio" name="RESTORE" value="'||fils2.mm||'">'
    call lineout tempfile,' <tt>'||opts.!CREATED||'</tt> <em>('||opts.!note||')</em>'
   call lineout tempfile,'<table>'
   isize=stream(cmsdir_archive||'\'||opts.!NEWRECORDS,'c','query size') ; if isize='' then isize=0
   if isize=0 then 
        call lineout tempfile,'<tr><td colspan=3><B>Error:</b> missing records file = 'opts.!NEWRECORDS||'</td>'
   else
        call lineout tempfile,'<tr><td>Records file </td><td><u>'||opts.!NEWRECORDS||'</u></td><td> <tt>'||isize||' bytes</tt> </td>'

   isize=stream(cmsdir_archive||'\'||opts.!NEWcomments,'c','query size') ; if isize='' then isize=0
   if isize=0 then 
        call lineout tempfile,'<tr><td colspan=3><B>Error:</b> missing comments file = 'opts.!NEWcomments||'</td>'
   else
        call lineout tempfile,'<tr><td>comments file </td><td><u>'||opts.!NEWcomments||'</u></td><td> <tt>'||isize||' bytes</tt> </td>'

   isize=stream(cmsdir_archive||'\'||opts.!NEWDEF,'c','query size') ; if isize='' then isize=0
   if isize=0 then 
        call lineout tempfile,'<tr><td colspan=3><B>Error:</b> missing definition (.DEF) file = 'opts.!NEWDEF||'</td>'
   else
        call lineout tempfile,'<tr><td>definition (.DEF) file </td><td><u>'||opts.!NEWDEF||'</u></td><td> <tt>'||isize||' bytes</tt> </td>'
   call lineout tempfile,'</table>'
    

end 
call lineout tempfile,'</ol>'

call lineout tempfile,'<input type="submit" value="Restore the CMS dataseries"><input type="reset">'
call lineout tempfile,'</form>'

gooble:         /* jump here on error */


call lineout tempfile,'<hr><h4>Notes</h4><ul>'
call lineout tempfile,'<li><em>Backup files are stored in</em> <tt>'||cmsdir_archive||'</tt><br>'
if fils.0=0 then do
   call lineout tempfile,'<li>Currently, there are <b>no</b> CMS backups in the archive directory!'
end 
else do
   call lineout tempfile,'<li>Currently, there are <tt>'||fils.0||'</tt> CMS backups in the archive directory'
end
call lineout tempfile,'</ul>'


call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode


/************/
/* parse .SUM file */
do_stuff:
opts.=''
do until stuff=''
   parse var stuff aline '0d0a'x stuff ;aline=strip(aline)
   if aline='' |  abbrev(aline,';')=1 then iterate
   parse var aline avar ':' aval
   vvar='!'||strip(translate(avar))
   opts.vvar=strip(aval)
end
return 0



/*******************/
/* list the dataseries, with delete option */
dolist2:

call lineout tempfile,'<html><head><title>CMS:List backups of a dataseries</title> '
call lineout tempfile,'<script language="javascript">'


call lineout tempfile,'</head><body>'
call lineout tempfile,'<font size=-1>'
call lineout tempfile,'<a href="'||mainaddon||'?action=1">Another CMS action</a> || '
call lineout tempfile,'<a href="'||thisaddon||'?action=1">Choose a different dataseries</a> '
call lineout tempfile,'</font><hr>'

daindx=optname.!deffile

aa=cmsdir_archive||'\*.SUM'
arf=sysfiletree(aa,'fils','O')

if daindx='' then do
   call lineout tempfile,'You forgot to select a dataseries. Go <a href="javascript:history.go(-1)">back</a> and try again.'
   signal gooble
end 

ff=cmsdir_index||'\'||daindx
goo=stream(ff,'c','query exists')
if goo='' then do
   call lineout tempfile,'Error: could not find index file: '||ff
   signal gooble
end
daindx_file=ff

call read_deffile ff
/* check for access rights */
rcode=check_access(stuff.!OWNERS,stuff.!SERIES)
if rcode<>1 then return rcode

call lineout tempfile,'<h3 align="center">Delete a backup of a a CMS dataseries</h3> '


if fils.0=0 then signal gooble


call lineout tempfile,'The following <b>backups</b> are available for the CMS dataseries <tt>'||stuff.!series||'</tt>, under host <u>'||host_nickname||'</u><p>'
call lineout tempfile,'<form method="POST" action="'||thisaddon||'">'
call lineout tempfile,'<input type="hidden" name="deffile" value="'||daindx||'">'
call lineout tempfile,'<input type="hidden" name="action" value=6>'

call lineout tempfile,'<table><tr><td colspan=4>To delete one of these <b>backups</b> ...'
call lineout tempfile,'<tr><td > &nbsp;&nbsp;<td><em>First</em>, select  the</td>  '
call lineout tempfile,'<td bgcolor="#eeeeee"><input type="radio"  name="DELETE" value="">'
call lineout tempfile,'<em>radio button</em> </td><td>next to its descripton.</td>'
call lineout tempfile,' <td><em>Then</em>, hit this button to '
call lineout tempfile,'<input type="submit" value="delete it."></td></table>'


/* remove non archive files */
ii=0
do i=1 to fils.0
    aname=filespec('n',fils.i)
    if substr(aname,9,1)<>'$' then iterate
    adate=left(aname,8)
    if datatype(adate)<>'NUM' then iterate
    ii=ii+1
    fils2.ii=aname
end 
fils2.0=ii

/* check each summary file, keep if series and host match */
call lineout tempfile,'<ol type="i">'

do mm=1 to fils2.0

   stuff=sre_read_file(cmsdir_archive||'\'||fils2.mm,2,2,1)
 
   if stuff='' then iterate
   call do_stuff
   if translate(opts.!SERIES)<>strip(translate(stuff.!SERIES)) then iterate
    v1=translate(opts.!host)
    v2=strip(translate(host_nickname))
    if v1<>v2 then iterate

    call lineout tempfile,'<li> '
    call lineout tempfile,'<INPUT TYPE="radio" name="DELETE" value="'||fils2.mm||'">'
    call lineout tempfile,' <tt>'||opts.!CREATED||'</tt> <em>('||opts.!note||')</em>'
   call lineout tempfile,'<table>'
   isize=stream(cmsdir_archive||'\'||opts.!NEWRECORDS,'c','query size') ; if isize='' then isize=0
   if isize=0 then 
        call lineout tempfile,'<tr><td colspan=3><B>Error:</b> missing records file = 'opts.!NEWRECORDS||'</td>'
   else
        call lineout tempfile,'<tr><td>Records file </td><td><u>'||opts.!NEWRECORDS||'</u></td><td> <tt>'||isize||' bytes</tt> </td>'

   isize=stream(cmsdir_archive||'\'||opts.!NEWcomments,'c','query size') ; if isize='' then isize=0
   if isize=0 then 
        call lineout tempfile,'<tr><td colspan=3><B>Error:</b> missing comments file = 'opts.!NEWcomments||'</td>'
   else
        call lineout tempfile,'<tr><td>comments file </td><td><u>'||opts.!NEWcomments||'</u></td><td> <tt>'||isize||' bytes</tt> </td>'

   isize=stream(cmsdir_archive||'\'||opts.!NEWDEF,'c','query size') ; if isize='' then isize=0
   if isize=0 then 
        call lineout tempfile,'<tr><td colspan=3><B>Error:</b> missing definition file = 'opts.!NEWDEF||'</td>'
   else
        call lineout tempfile,'<tr><td>definition file </td><td><u>'||opts.!NEWDEF||'</u></td><td> <tt>'||isize||' bytes</tt> </td>'
   call lineout tempfile,'</table>'
    

end 
call lineout tempfile,'</ol>'

call lineout tempfile,'<input type="submit" value="Delete selected backup of a CMS dataseries"><input type="reset">'
call lineout tempfile,'</form>'

gooble:         /* jump here on error */


call lineout tempfile,'<hr><h4>Notes</h4><ul>'
call lineout tempfile,'<li><em>Backup files are stored in</em> <tt>'||cmsdir_archive||'</tt><br>'
if fils.0=0 then do
   call lineout tempfile,'<li>Currently, there are <b>no</b> CMS backups in the archive directory!'
end 
else do
  call lineout tempfile,'Currently, there are <tt>'||fils.0||'</tt> CMS backups in the archive directory'
end
call lineout tempfile,'</ul>'

call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode



/*******************/
/* archive the dataseries */
dobackup1:

call lineout tempfile,'<html><head><title>CMS:Backup a dataseries</title> '
call lineout tempfile,'<script language="javascript">'


call lineout tempfile,'</head><body>'

  call lineout tempfile,'<font size=-1>'
if optname.!CLOSER<>1 then
  call lineout tempfile,'<a href="'||mainaddon||'?action=1">Another CMS action</a>'
else
  call lineout tempfile,'<a href="javascript:close()">Close window</a>'
call lineout tempfile,'</font><hr>'

daindx=optname.!deffile

if daindx='' then do
   call lineout tempfile,'You forgot to select a dataseries. Go <a href="javascript:history.go(-1)">back</a> and try again.'
   signal gooble
end 


ff=cmsdir_index||'\'||daindx
goo=stream(ff,'c','query exists')
if goo='' then do
   call lineout tempfile,'Error: could not find index file: '||ff
   signal gooble
end
daindx_file=ff

call read_deffile ff
/* check for access rights */
rcode=check_access(stuff.!OWNERS,stuff.!SERIES)
if rcode<>1 then return rcode

call lineout tempfile,'<h3>Backup a CMS dataseries</h3> '


/* cleanup first */
a=sre_cache_data(,'CLEANUP CACHE')

if a<>0 then do
    amess=sre_cache_data('CLEANUP','ERROR',a,'CACHE')
    call lineout tempfile,'<b>Error cleaning up:</b> '||amess
    signal gooble
end

call lineout tempfile,'Backing up  CMS dataseries <b>'||stuff.!series||'</b><p>'
call lineout tempfile,'<em>files will be copied to </em> <tt>'||cmsdir_archive||'</tt>'

call lineout tempfile,'<dl>'

errs.='unspecified error '
errs.2 =' source file not found '
errs.3 =' source or target path not found '
errs.5 =' target file exists but  A  or  R  mode not specified '
errs.32 =' sharing violation for source or target file '
errs.108 =' source or target drive locked '
errs.112 =' disk full '
errs.206 =' invalid source or target file name '
errs.267 =' source name is a directory '
errs.282 =' extended attributes not supported for target '


nowtime=sre_gmt(,,'JS',0)
nowtime=abs(trunc(nowtime,4))
nowtime=space(translate(nowtime,' ','.'),0)

parse var daindx ahost0 '_' . ; ahost=strip(ahost0)||'$'

infoset='; CMS backup summary file'||'0d0a'x
infoset=infoset||'Created: '||time('n')||" "||date('n')||'0d0a'x
infoset=infoset||'Note: '||optname.!NOTE||'0d0a'x
infoset=infoset||'Host: '||ahost0||'0d0a'x
infoset=infoset||'Series: '||stuff.!series||'0d0a'x
infoset=infoset||'Desc: '||stuff.!desc||'0d0a'x

/* the .sds file */
call lineout tempfile,'<dt>Copying main database file:<tt>'||stuff.!file||'</tt>'
f1=stuff.!file
if pos('.',f1)=0 then f1=f1||'.SDS'
aname=filespec('n',f1)
parse var aname aname1 '.' aext
newname=nowtime||'$'||aname1||'.'||aext
adest=cmsdir_archive||'\'||newname
foo=doscopy(f1,adest,'R')
infoset=infoset||'RECORDS: '||stuff.!file||'0d0a'x

if foo<>0 then do
   call lineout tempfile,'<dd><b>Error copying to <tt>'||newname||'</tt> <em>'||errs.foo||'</em>'
   infoset=infoset||'NEWRECORDS: '||'0d0a'x
end 
else do
   call lineout tempfile,'<dd>File copied to <tt>'||newname||'</tt>'
   infoset=infoset||'NEWRECORDS: '||newname||'0d0a'x
end


/* the _cmt.sds file */
call lineout tempfile,'<dt>Copying comments database file:<tt>'||stuff.!commentfile||'</tt>'
f1=stuff.!commentfile
if pos('.',f1)=0 then f1=f1||'.SDS'
aname=filespec('n',f1)
parse var aname aname1 '.' aext
newname=nowtime||'$'||aname1||'.'||aext
adest=cmsdir_archive||'\'||newname
foo=doscopy(f1,adest,'R')
infoset=infoset||'COMMENTS: '||stuff.!commentfile||'0d0a'x

if foo<>0 then do
   call lineout tempfile,'<dd><b>Error copying to<tt>'||newname||'</tt> <em>'||errs.foo||'</em>'
end 
else do
   call lineout tempfile,'<dd>File copied to <tt>'||newname||'</tt>'
   infoset=infoset||'NEWCOMMENTS: '||newname||'0d0a'x
end

/* the .def file */
call lineout tempfile,'<dt>Copying definition file:<tt>'||stuff.!commentfile||'</tt>'
f1=daindx_file
aname=filespec('n',f1)
parse var aname aname1 '.' aext
newname=nowtime||'$'||aname1||'.'||aext
adest=cmsdir_archive||'\'||newname
foo=doscopy(f1,adest,'R')
infoset=infoset||'DEF: '||ff||'0d0a'x

if foo<>0 then do
   call lineout tempfile,'<dd><b>Error copying to<tt>'||newname||'</tt> <em>'||errs.foo||'</em>'
end 
else do
   call lineout tempfile,'<dd>File copied to <tt>'||newname||'</tt>'
   infoset=infoset||'NEWDEF: '||newname||'0d0a'x
end

/* backup summary file */
call lineout tempfile,'<dt>Storing summary of backup'
newname=nowtime||'$SUMMARY.SUM'
adest=cmsdir_archive||'\'||newname
foo=sre_append_file(adest,infoset,1,,1)
select 
   when foo='-1' then call lineout tempfile,'Error saving summary to 'adest
   when foo='-2' then return 'Error  writing to file: 'adest
   otherwise    call lineout tempfile,'<dd>Summary saved to <tt>'||adest||'</tt>'
end 

astuff=stuff.!!template

if astuff<>'' then do
  call lineout tempfile,'<dt><p> The template files '
  call lineout tempfile,'<dd>You may want to copy the following template file: <ul>'
  do until astuff=''
    parse var astuff aline '0d0a'x astuff
    if aline='' then iterate
    parse var aline . atpl ',' adesc ; atpl=strip(atpl)
    if pos(':',atpl)=0 &  abbrev(atpl,'\')=0 then do
       atpl=cmsdir_files||'\'||atpl
    end 
    call lineout tempfile,'<li><tt>'||atpl||'</tt> <em>('||adesc||')</em>'  
  end 
  call lineout tempfile,'</ul>'
  call lineout tempfile,'Note that there may be other template files (such as archive or comment template files)'
  call lineout tempfile,'that are not included in the above list.'
end



gooble:         /* jump here on error */
call lineout tempfile,'</dl>'
call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode




/*******************/
/* restore: step 1 of 2 */
do_restore1:

/* check for superuser rights */
call check_access2 stuff.!SERIES
rcode=result
if rcode<>0 then return rcode

call lineout tempfile,'<html><head><title>CMS: Restoring a CMS dataseries</title> '

daindx=optname.!deffile
call lineout tempfile,'</head><body>'
call lineout tempfile,'<font size=-1><a href="'||mainaddon||'?action=1">Another CMS action</a> || '
call lineout tempfile,'<a href="'||thisaddon||'?action=2&dolist=1&deffile='||daindx||'">Restore a different backup of this dataseries</a>  '

call lineout tempfile,'</font><hr>'

call lineout tempfile,'<h3>Restoring a CMS dataseries</h3> '

afile=optname.!RESTORE
if afile='' | afile=0 then do
   call lineout tempfile,'You forgot to select a backup-set to restore.<br><a href="javascript:history.go(-1)">Go back and choose</a>.'
   signal gooble
end 

stuff=sre_read_file(cmsdir_archive||'\'||afile,2,2,1)
if stuff='' then do
   call lineout tempfile,'ERROR. Bad or empty backup-summary file:<tt>'||afile||'</tt>'
   signal gooble
end 
call do_stuff


call lineout tempfile,'<FORM name="" action="'||thisaddon||'" method="POST">'
call lineout tempfile,'<input type="hidden" name="action" value="5">'
call lineout tempfile,'<input type="hidden" name="RESTORE" value="'||optname.!RESTORE||'">'

call lineout tempfile,'<dl><dt>Using a backup created on <tt>'||opts.!created||' <em> ('||opts.!note||') </em> </tt>,'
call lineout tempfile,'<dd>you can restore the CMS dataseries <b>'||opts.!series||'</b> <em>('||opts.!desc||'</em>)'

call lineout tempfile,'<p>Backup details:'
call lineout tempfile,'<ul>'
call lineout tempfile,'<li> It is based on instuctions in backup-summary file:<tt> '||optname.!RESTORE||'</tt>'

call lineout tempfile,'<li>  records database:<tt> '||opts.!records||'</tt>'
call lineout tempfile,'<li> comments database:<tt> '||opts.!comments||'</tt>'
call lineout tempfile,'<li>  definitions file:<tt> '||opts.!def||'</tt>'


call lineout tempfile,'<ul>'
call lineout tempfile,'</dl>'

acomment='Pre_restore_backup_of_'||opts.!series||'_at_'||translate(time('N'),'-',' ')||'_'||translate(Date('n'),'-',' ')
call lineout tempfile,'Before restoring, we recommend backing up the current version.'
call lineout tempfile,'Would you like to '
call lineout tempfile,'<a target="backuper" href="'||thisaddon||,
                        '?action=2&closer=1&deffile='||,
                        filespec('n',opts.!DEF)||'&NOTE='||acomment||'">back up the current version</a>' 
call lineout tempfile,'of this CMS dataseries?'

call lineout tempfile,'<p>Are you ready to restore? Then <input type="submit" value="click this to restore the dataseries">'
call lineout tempfile,'</form>'

gooble:         /* jump here on error */
call lineout tempfile,'</body> </html>'
call lineout tempfile

rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode

/*******************/
/* restore: step 2 of 2 */
do_restore2:

errs.='unspecified error '
errs.0='Success.'
errs.2 ='Error: source file not found '
errs.3 ='Error: source or target path not found '
errs.5 ='Error: target file exists but  A  or  R  mode not specified '
errs.32 ='Error: sharing violation for source or target file '
errs.108 ='Error: source or target drive locked '
errs.112 ='Error: disk full '
errs.206 ='Error: invalid source or target file name '
errs.267 ='Error: source name is a directory '
errs.282 ='Error: extended attributes not supported for target '


/* check for superuser rights */
call check_access2 stuff.!SERIES
rcode=result
if rcode<>0 then return rcode

call lineout tempfile,'<html><head><title>CMS: Restoring a CMS dataseries (step 2 of 2)</title> '

call lineout tempfile,'</head><body>'
call lineout tempfile,'<font size=-1><a href="'||mainaddon||'?action=1">Another CMS action</a></font><br>'

call lineout tempfile,'<h3>Restoring a CMS dataseries: step 2 of 2</h3> '


afile=optname.!RESTORE
if afile='' | afile=0 then do
   call lineout tempfile,'Problem in specification of backup-summary file:<tt>'||afile||'</tt>'
   signal gooble
end 

stuff=sre_read_file(cmsdir_archive||'\'||afile,2,2,1)
if stuff='' then do
   call lineout tempfile,'ERROR. Bad or empty backup-summary file:<tt>'||afile||'</tt>'
   signal gooble
end 

call do_stuff

call lineout tempfile,'Restoring the CMS dataseries <u>'||opts.!series||'</u> using the backup of'
call lineout tempfile,opts.!CREATED||'<tt>('||opts.!NOTE||')</tt><br>'
call lineout tempfile,'<br><em>based on instuctions in backup-summary file:<tt> '||optname.!RESTORE||'</tt></em><p>'

call lineout tempfile,'<ul>'

call lineout tempfile,'<li>Restoring records database:<tt>'||opts.!records||'</tt>'
fto=opts.!records ; if pos('.',fto)=0 then fto=fto||'.SDS'
foo1=doscopy(cmsdir_archive||'\'||opts.!newrecords,fto,'R')
call lineout tempfile,'<br> Copy result: <tt>'||errs.foo1||'</tt>'

call lineout tempfile,'<li>Restoring comments database:<tt>'||opts.!comments||'</tt>'
fto=opts.!comments ; if pos('.',fto)=0 then fto=fto||'.SDS'
foo2=doscopy(cmsdir_archive||'\'||opts.!newcomments,fto,'R')
call lineout tempfile,'<br> Copy result: <tt>'||errs.foo2||'</tt>'

call lineout tempfile,'<li>Restoring definitions file:<tt>'||opts.!def||'</tt>'
foo3=doscopy(cmsdir_archive||'\'||opts.!newdef,opts.!def,'R')
call lineout tempfile,'<br> Copy result: <tt>'||errs.foo3||'</tt>'

call lineout tempfile,'</ul>'

gooble:         /* jump here on error */
call lineout tempfile,'</body> </html>'
call lineout tempfile

rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode




/*******************/
/* delete: step 1 of 2 */
do_delete1:

/* check for superuser rights */
call check_access2 stuff.!SERIES
rcode=result
if rcode<>0 then return rcode

daindx=optname.!deffile

call lineout tempfile,'<html><head><title>CMS: Deleting a backup of a CMS dataseries</title> '

call lineout tempfile,'</head><body>'
call lineout tempfile,'<font size=-1><a href="'||mainaddon||'?action=1">Another CMS action</a> || '
call lineout tempfile,'<a href="'||thisaddon||'?action=2&dolist=2&deffile='||daindx||'">Delete a different backup of this dataseries</a> || '
call lineout tempfile,'<a href="'||cmsroot||'cms_del.cmd?action=2&deffile='||daindx||'">Delete the actual CMS dataseries</a> '
call lineout tempfile,'</font><br>'

call lineout tempfile,'<h3>Deleting a backup of a CMS dataseries</h3> '

afile=optname.!DELETE
if afile='' | afile=0 then do
   call lineout tempfile,'You forgot to select a backup-set to delete.<br><a href="javascript:history.go(-1)">Go back and choose</a>.'
   signal gooble
end 

stuff=sre_read_file(cmsdir_archive||'\'||afile,2,2,1)
if stuff='' then do
   call lineout tempfile,'ERROR. Bad or empty backup-summary file:<tt>'||afile||'</tt>'
   signal gooble
end 
call do_stuff


call lineout tempfile,'<FORM name="" action="'||thisaddon||'" method="POST">'
call lineout tempfile,'<input type="hidden" name="action" value="7">'
call lineout tempfile,'<input type="hidden" name="DELETE" value="'||optname.!DELETE||'">'
call lineout tempfile,'<input type="hidden" name="deffile" value="'||daindx||'">'

parse var optname.!delete aname1 '$' .
call lineout tempfile,'<dl><dt>Deleting backup <tt>'||aname1||'</tt> of  CMS dataseries <b>'||opts.!series||'</b> <em>('||opts.!desc||'</em>)'
call lineout tempfile,'<dd>This backup was created on <tt>'||opts.!created||'</tt> (<em><tt>'||opts.!note||'</tt></em>)'
call lineout tempfile,'</dl>'


call lineout tempfile,'<p>Are you ready to delete? Then <input type="submit" value="click this to delete this dataseries archive">'
call lineout tempfile,'</form>'

gooble:         /* jump here on error */
call lineout tempfile,'</body> </html>'
call lineout tempfile

rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode



/*******************/
/* delete: step 2 of 2 */
do_delete2:

errs.0='File deleted successfully. '
errs.2='Error.  File not found. '
errs.3='Error.  Path not found. '
errs.5='Error.  Access denied. '
errs.26='Error.  Not DOS disk. '
errs.32='Error.  Sharing violation. '
errs.36='Error.  Sharing buffer exceeded. '
errs.87='Error.  Invalid parameter '
errs.206= 'Error.  Filename exceeds range error '


/* check for superuser rights */
call check_access2 stuff.!SERIES
rcode=result
if rcode<>0 then return rcode

call lineout tempfile,'<html><head><title>CMS: Deleteing backup of a CMS dataseries (step 2 of 2)</title> '

call lineout tempfile,'</head><body>'
call lineout tempfile,'<font size=-1><a href="'||mainaddon||'?action=1">Another CMS action</a></font><br>'

call lineout tempfile,'<h3>Deleting backup of a CMS dataseries: step 2 of 2</h3> '


afile=optname.!DELETE
if afile='' | afile=0 then do
   call lineout tempfile,'Problem in specification of backup-summary file:<tt>'||afile||'</tt>'
   signal gooble
end 

stuff=sre_read_file(cmsdir_archive||'\'||afile,2,2,1)
if stuff='' then do
   call lineout tempfile,'ERROR. Bad or empty backup-summary file:<tt>'||afile||'</tt>'
   signal gooble
end 

call do_stuff

parse var optname.!delete aname1 '$' .
call lineout tempfile,'Deleting backup <tt>'||aname1||'</tt> of CMS dataseries <u>'||opts.!series||'</u>.<br>'
call lineout tempfile,'This backup was created on '||opts.!CREATED||'<tt>('||opts.!NOTE||')</tt><br>'

call lineout tempfile,'<ul>'

call lineout tempfile,'<li>Deleting backup of records database:<tt>'||opts.!newrecords||'</tt>'
foo1=sysfiledelete(cmsdir_archive||'\'||opts.!newrecords)
call lineout tempfile,'<br> Deletion result: <tt>'||errs.foo1||'</tt>'

call lineout tempfile,'<li>Deleting backup of comments database:<tt>'||opts.!newcomments||'</tt>'
foo2=sysfiledelete(cmsdir_archive||'\'||opts.!newcomments)
call lineout tempfile,'<br> Deletion result: <tt>'||errs.foo2||'</tt>'

call lineout tempfile,'<li>Deleting backup of definitions file:<tt>'||opts.!newdef||'</tt>'
foo3=sysfiledelete(cmsdir_archive||'\'||opts.!newdef)
call lineout tempfile,'<br> Copy result: <tt>'||errs.foo3||'</tt>'

call lineout tempfile,'<li>Deleting backup summary file:<tt>'||optname.!DELETE||'</tt>'
foo3=sysfiledelete(cmsdir_archive||'\'||optname.!DELETE)
call lineout tempfile,'<br> Deletion results: <tt>'||errs.foo3||'</tt>'

call lineout tempfile,'</ul>'

gooble:         /* jump here on error */
call lineout tempfile,'</body> </html>'
call lineout tempfile

rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode



restor
/*************/
/* read a definition file */
read_deffile:
parse arg afile
stuff.=''
stuff=sre_read_file(afile,2,2,1)
do until stuff=''
   parse var stuff aline '0d0a'x stuff ; aline=strip(aline)
   if aline='' then iterate
   if abbrev(aline,';')=1 then iterate
   parse var aline aname ':' avalue
   if aname='' then iterate
   aname='!'||strip(translate(aname))
   stuff.aname=strip(avalue)
   aname='!'||strip(translate(aname))
   stuff.aname=strip(stuff.aname||'0d0a'x||avalue)
end

return 1



/******************/
/* access allowed? */
check_access2:
parse arg series
ss=sre_value('SECURITY_LEVEL',,'SRESYS')
if ss=0 then do
  foo=sre_command('String Sorry. Remote access to configuration utilities not permitted.',,idinfo)
  return foo
end
if ss=1 then do
    myaddr=sre_extract("clientaddr",idinfo)
    moreaddr=sre_value('SERVERADDR_INHOUSE',,'SRESYS')
    who=sre_extract("serveraddr",idinfo)||' '||moreaddr
    if wordpos(myaddr,who)=0 then do
      sfoo=sre_command('String External access to configuration utilities is not permitted' ,,idinfo)
      return sfoo
   end
end

/* else, normal superuser checking */


if wordpos('CMS_DEF',translate(privset))>0 then return 0     
if wordpos('SUPERUSER',translate(privset))>0 then return 0   

/* not enough privs */
if aiter='' then return 'PRIVS Defining a CMS dataseries requires superuser privileges '
return 'AUTH Defining a CMS dataseries requires that you have superuser privileges '



/******************************/
/* check access rights. Return 1 if okay. Otherwise, return a string to be
  sent back to SREhttp/2 (an authorization response string) */
check_access:procedure expose privset host_nickname idinfo uri aiter
parse  upper arg owners,series

if owners='' then return 1      /* no owners listed, means open access */

tpr=translate(privset)
pneeded=space(translate('CMS:'||strip(series)),0)
if wordpos(pneeded,tpr)>0 then return 1          /* explicit privilege for this */
if wordpos('SUPERUSER',tpr)>0 then return 1


/* see if a cookie exists */
look_cook='CMS_'||series
aa=sreh2_get_cookie(lookcook)
if aa<>''  then return 1

if aiter=''  then do            /* first time, so recheck privs */
  return 'PRIVS   Access to this dataseries is restricted to specific users '
end 

/* otherwise, see if a username has been sent  */
username=''
authh=sre_reqfield('Authorization')
if authh<>'' then username=sre_extract_username(authh) 
if username='' then do             /* no username available */
  return  'AUTH  Access to this dataseries is restricted to specific users '
end

/* is this one of the OWNERS? */
if pos('*',owners)=0 then do            /* * means "any user" */
if wordpos(translate(username),translate(owners))=0 then do
   return 'AUTH  Access to this dataseries is restricted to specific users '
end
end

/* One of the OWNERS, now check password */
stuff=sreh2_get_userinfo(authh,host_nickname,idinfo)
if stuff='' then do
  return 'AUTH   Access to this dataseries is restricted to specific users. Please enter a new username/password.'
end

parse var uri thisaddon '?' .
jj=lastpos('/',thisaddon)
pp=left(thisaddon,jj)

foo=sreh2_set_cookie(lookcook,1,'30m',pp,,1)

/* if here, legit user.  Record a cookie */
return 1

