/* The SREhttp/2 content management system (CMS) program 

   This module will delete a cms dataseries.


*/

/******** User changeable parameters ***/
/* root directory for the SREhttp/2 CMS addon.
   Leave blank to use default (CMS subdirectory of srehttp/2 addon directory */
cmsdir=''


/******** end of user changeable parameters ***/


parse arg list,servername,verb,tempfile,,
          prog_file,reqnum,verbose,client_ip,privset,,
          uri,host_nickname,idinfo,aiter,attribs,seluse2

crlf='0d0a'x

if verb=" " then do
   say "This SREhttp/2 procedure is not meant to be run in standalone mode "
   exit
end  

addon_dir=sre_value('H2_ADDON_DIR_DEFAULT',,'SRE')
if cmsdir='' then cmsdir=strip(addon_dir,,'\')||'\CMS'
foo=dosisdir(cmsdir)
if foo=0 then return 'String Error:unable to find CMS directory: ('cmsdir

cmsdir_data=cmsdir||'\DATA'
okk=dosisdir(cmsdir_data)
if okk=0 then do
  return 'string unable to find CMS data directory: 'cmsdir_data
end

cmsdir_index=cmsdir||'\INDEX'
okk=dosisdir(cmsdir_index)
if okk=0 then do
  return 'string unable to find CMS index directory: 'cmsdir_index
end

parse var uri thisaddon '?' .
jj=lastpos('/',thisaddon)
mainaddon=left(uri,jj)||'cms.cmd'

optname.=''
m=0
if list='' then list='action=1'
do until list=""
    parse var list opt1 '&' list
    m=m+1
    parse var opt1 avar '=' aval ; avar=strip(translate(avar)) 
    optname.0=optname.0||' '||avar
    aval=translate(aval,' ', '+')
    aval=sre_packur(aval)
    avar1='!!'avar
    if optname.avar1<>'' then
       optname.avar1=optname.avar1||' '||aval
    else
       optname.avar1=aval
    avar2='!'avar
    aval2=strip(translate(aval,' ','090a0d'x))
    optname.avar2=aval2
end

/***** End of GENERIC CMS addon code *****/

if optname.!action='1' then do   /* find the list of dataseries defined for this host*/
  call show_datafiles
  foo=result
  return foo
end

if optname.!action='2' then do   /* verify that this should be deleted */
  call verify_delete
  foo=result
  return foo
end


if optname.!action='3' then do   /* remove a record */
  call do_delete
  foo=result
  return foo
end



/*******************/
/* pick one of the current cms datafiles (for this host) */
show_datafiles:

call lineout tempfile,'<html><head><title>CMS: Delete a CMS datafile</title> '


call lineout tempfile,'<font size=-1><a href="'||mainaddon||'?action=1">Another CMS action</a></font><br>'

call lineout tempfile,'<h3>Delete a CMS dataseries</h3><p> '

ahost=host_nickname

/* look for files, in cmsDIR_index dir, of the form: ahost_nnnn.DEF
   These .DEF files define "CMS indices" --- nnnn is a number from 0 to 9999
*/

call lineout tempfile,'<FORM name="" action="'||thisaddon||'" method="POST">'
call lineout tempfile,'<input type="hidden" name="action" value="2">'
ff=cmsdir_index||'\'||ahost||'*.DEF'
goo=sysfiletree(ff,'ff2','FO')

call lineout tempfile,'For host: <Tt>'||ahost||'</tt>, the following CMS dataseries currently exist'

call lineout tempfile,'<table border=1>'
do jj=1 to ff2.0
   daname=filespec('n',ff2.jj)
   call read_deffile ff2.jj
   call lineout tempfile,'<tr><th align="left">' 
   call lineout tempfile,'<INPUT TYPE="RADIO"  name="deffile" value="'||daname||'">'
   gob=strip(stuff.!series)||'</th>'
   call lineout tempfile,gob||'<td> <em>&nbsp;'||stuff.!desc||'</em></td>'
end

call lineout tempfile,'</table>'


call lineout tempfile,''
call lineout tempfile,'<p><INPUT name="sub2" TYPE="submit" VALUE="Choose a CMS dataseries">'
call lineout tempfile,'</form>'
call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode


/*******************/
/* pick a record to remove */
verify_delete:

call lineout tempfile,'<html><head><title>CMS: Delete a dataseries</title> '
call lineout tempfile,'<script language="javascript">'


call lineout tempfile,'</head>'
call lineout tempfile,'<font size=-1><a href="'||mainaddon||'?action=1">Another CMS action</a></font><br>'

call lineout tempfile,'<h3>Delete a CMS dataseries</h3> '

daindx=optname.!deffile
ff=cmsdir_index||'\'||daindx
goo=stream(ff,'c','query exists')
if goo='' then do
   call lineout tempfile,'Error: could not find index file: '||ff
   signal gooble
end

call read_deffile ff
/* check for access rights */
rcode=check_access(stuff.!OWNERS,stuff.!SERIES)
if rcode<>1 then return rcode

a=sre_cache_data(stuff.!series,'OPEN  INDEX',stuff.!file)
if a>0 then do
   amess=sre_cache_data('OPEN','ERROR',a,stuff.!file)
   call lineout tempfile,'<b>Error:</b> '||amess
   signal gooble
end


a=sre_cache_data(stuff.!series,'INFO',,'MODIFIED RECORDS VARS DESCRIPTION')
parse var a astat a ; astat=strip(astat)
if astat<>'0' then do
   amess=sre_cache_data('INFO','ERROR',astat)
   call lineout tempfile,'<b>Error retrieving info:</b> '||amess
   signal gooble
end

parse var a . '0d0a'x . '09'x modified  '=' . '09'x nrecords '09'x  varlist '09'x  desc

ii=0
do until varlist=''
   parse var varlist avar varlist
   ii=ii+1
   varnames.ii=strip(translate(avar))
end
varnames.0=ii

call lineout tempfile,'<FORM name="dodelete" action="'||thisaddon||'" method="POST">'
call lineout tempfile,'<input type="hidden" name="action" value="3">'
call lineout tempfile,'<input type="hidden" name="deffile" value="'||daindx||'">'

call lineout tempfile,'<em>For the CMS dataseries: </eM><b>'||stuff.!series||'</b><br>'
call lineout tempfile,'<table>'
call lineout tempfile,'<tr><th align="left">Last modified:</th><td>'||modified||'</td>'
call lineout tempfile,'<tr><th align="left"># of records currently in dataseries:</th><td>'||nrecords||'</td>'
call lineout tempfile,'<tr><th align="left">Description:</th><td>'||desc||'</td>'
call lineout tempfile,'</table>'
call lineout tempfile,'<input type="checkbox" name="certain" value=1>Check this box to verify that you want to delete this CMS dataseries'

call lineout tempfile,'<input name="sub2" type="submit" value="and then click this button! ">'
call lineout tempfile,'</form>'


gooble:         /* jump here on error */
a=sre_cache_data(stuff.!series,'CLOSE')

call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode




/*******************/
/*  */
do_delete:

call lineout tempfile,'<html><head><title>CMS: Deleting a CMS dataseries</title> '

call lineout tempfile,'</head>'
call lineout tempfile,'<font size=-1><a href="'||mainaddon||'?action=1">Another CMS action</a></font><br>'

call lineout tempfile,'<h3>Deleting a CMS dataseries</h3> '

if optname.!CERTAIN<>1 then do
   call lineout tempfile,'You did not check the <tt>verify</tt> checkbox'
   signal gooble
end

daindx=optname.!deffile
ff=cmsdir_index||'\'||daindx
goo=stream(ff,'c','query exists')
if goo='' then do
   call lineout tempfile,'Error: could not find index file: '||ff
   signal gooble
end

call read_deffile ff
/* check for access rights */
rcode=check_access(stuff.!OWNERS,stuff.!SERIES)
if rcode<>1 then return rcode

/* get rid of records file */
a=sre_cache_data(stuff.!series,'DELETE INDEX',stuff.!file)
if a<>0 then do
   amess=sre_cache_data('DELETE','ERROR',a,stuff.!file)
   call lineout tempfile,'<br><b>Error:</b> '||amess
end

/* get rid of comments file */
cc=stuff.!SERIES||'_CMT'
tt=stuff.!file
ii=lastpos('.',tt)
if ii=0 then do
   cc2=tt||'_CMT'
end 
else do
   cc2=left(tt,ii-1)||'$CMT'||substr(tt,ii)
end

a=sre_cache_data(cc,'DELETE INDEX',cc2)
if a<>0 then do
   amess=sre_cache_data('DELETE','ERROR',a,cc2)
   call lineout tempfile,'<br><b>Error:</b> '||amess
end


/* delete index file */
foo=sysfiledelete(ff)
   
if foo<>0 then do
     ers.2   ='CMS Index File not found ('ff
     ers.3   ='Path not found ('||ff
     ers.5   ='Access denied. '
     ers.26  ='Not DOS disk ('||ff
     ers.32  ='Sharing violation. '
     ers.36  ='Sharing buffer exceeded. '
     ers.87  ='Invalid parameter '
     ers.206 ='Filename exceeds range error '
    call lineout tempfile,foo' Error, datafile deleted, but index file error: 'ers.foo
    signal gooble
end

call lineout tempfile,'<br>The <tt>'stuff.!series'</tt> CMS dataseries was deleted.'

gooble:         /* jump here on error */
call lineout tempfile,'</body> </html>'
call lineout tempfile

rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode


/*************/
/* read a definition file */
read_deffile:
parse arg afile
stuff.=''
stuff=sre_read_file(afile,2,2,1)
do until stuff=''
   parse var stuff aline '0d0a'x stuff ; aline=strip(aline)
   if aline='' then iterate
   if abbrev(aline,';')=1 then iterate
   parse var aline aname ':' avalue
   aname='!'||strip(translate(aname))
   stuff.aname=strip(avalue)
end

return 1


/*******************/
/* display a record  */
show_record:

call lineout tempfile,'<html><head><title>CMS: Display a record </title> '


call lineout tempfile,'<font size=-1>'
call lineout tempfile,'<a href="javascript:close()">Close window</a></font><br>'

call lineout tempfile,'<h3>Display a CMS record</h3> '

daindx=optname.!deffile
ff=cmsdir_index||'\'||daindx
goo=stream(ff,'c','query exists')
if goo='' then do
   call lineout tempfile,'Error: could not find index file: '||ff
   signal gooble
end

call read_deffile ff
/* check for access rights */
rcode=check_access(stuff.!OWNERS,stuff.!SERIES)
if rcode<>1 then return rcode

a=sre_cache_data(stuff.!series,'OPEN  INDEX',stuff.!file)
if a>0 then do
   amess=sre_cache_data('OPEN','ERROR',a,stuff.!file)
   call lineout tempfile,'<b>Error:</b> '||amess
   signal gooble
end

a=sre_cache_data(stuff.!series,'FIND ID7',optname.!id,'%ID '||stuff.!VARS)
parse var a astat a
if astat>0 then do
   amess=sre_cache_data('FIND','ERROR',astat,optname.!id)
   call lineout tempfile,'<b>Error:</b> '||amess
   signal gooble
end

call lineout tempfile,'<em>From the CMS dataseries: </eM><b>'||stuff.!series||'</b><br>'

parse var a id7 vlist '0d0a'x a
   call lineout tempfile,"<table border=1>"
do until vlist=''
   parse var vlist av1 vlist
   parse var a aval1 '0d0a'x a
   if av1='%ID' then do
     av1='Record ID<br>Entered on'
     tim=sre_gmt(,aval1,'I',0)
     parse var tim . ','  tim2
     aval1=aval1||'<br>'||tim2
   end
   call lineout tempfile,"<tr><th align="left" >"||av1||'</th><td>'||aval1||'</td>'
end 
call lineout tempfile,"</table>"

gooble:         /* jump here on error */
a=sre_cache_data(stuff.!series,'CLOSE')

call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode


/******************************/
/* check access rights. Return 1 if okay. Otherwise, return a string to be
  sent back to SREhttp/2 (an authorization response string) */
check_access:procedure expose privset host_nickname idinfo uri aiter
parse  upper arg owners,series

if owners='' then return 1      /* no owners listed, means open access */

tpr=translate(privset)
pneeded=space(translate('CMS:'||strip(series)),0)
if wordpos(pneeded,tpr)>0 then return 1          /* explicit privilege for this */
if wordpos('SUPERUSER',tpr)>0 then return 1


/* see if a cookie exists */
look_cook='CMS_'||series
aa=sreh2_get_cookie(lookcook)
if aa<>''  then return 1

if aiter=''  then do            /* first time, so recheck privs */
  return 'PRIVS   Access to this dataseries is restricted to specific users '
end 

/* otherwise, see if a username has been sent  */
username=''
authh=sre_reqfield('Authorization')
if authh<>'' then username=sre_extract_username(authh) 
if username='' then do             /* no username available */
  return  'AUTH  Access to this dataseries is restricted to specific users '
end

/* is this one of the OWNERS? */
if pos('*',owners)=0 then do            /* * means "any user" */
if wordpos(translate(username),translate(owners))=0 then do
   return 'AUTH  Access to this dataseries is restricted to specific users '
end
end

/* One of the OWNERS, now check password */
stuff=sreh2_get_userinfo(authh,host_nickname,idinfo)
if stuff='' then do
  return 'AUTH   Access to this dataseries is restricted to specific users. Please enter a new username/password.'
end

parse var uri thisaddon '?' .
jj=lastpos('/',thisaddon)
pp=left(thisaddon,jj)

foo=sreh2_set_cookie(lookcook,1,'30m',pp,,1)

/* if here, legit user.  Record a cookie */
return 1

