/* The SREhttp/2 content management system (CMS) program  

   This module will modify records in a CMS dataseries
  1) first, it will provide a pick list of cms dataseries (for this host)
  2) given the chosen dataseries, it will present a form with fields for each
     variable
  3) it will add the record, using filled in values for the variables, and
     report back


*/

/******** User changeable parameters ***/
/* root directory for the SREhttp/2 CMS addon.
   Leave blank to use default (CMS subdirectory of srehttp/2 addon directory */
cmsdir=''


/* maximum size, in bytes, of a record. This does NOT include size of uploaded files & URLS */
max_record_size=5000


/******** end of user changeable parameters ***/


parse arg list,servername,verb,tempfile,,
          prog_file,reqnum,verbose,client_ip,privset,,
          uri,host_nickname,idinfo,aiter,attribs,seluse2

crlf='0d0a'x

if verb=" " then do 
*   say "This SREhttp/2 procedure is not meant to be run in standalone mode "
   exit
end  

addon_dir=sre_value('H2_ADDON_DIR_DEFAULT',,'SRE')
if cmsdir='' then cmsdir=strip(addon_dir,,'\')||'\CMS'
foo=dosisdir(cmsdir)
if foo=0 then return 'String Error:unable to find CMS directory: ('cmsdir

cmsdir_data=cmsdir||'\DATA'
okk=dosisdir(cmsdir_data)
if okk=0 then do
  return 'string unable to find CMS data directory: 'cmsdir_data
end

cmsdir_index=cmsdir||'\INDEX'
okk=dosisdir(cmsdir_index)
if okk=0 then do
  return 'string unable to find CMS index directory: 'cmsdir_index
end

parse var uri thisaddon '?' .
jj=lastpos('/',thisaddon)
mainaddon=left(uri,jj)||'cms.cmd'
root=left(uri,jj)

optname.=''
m=0
if list='' then list='action=1'
do until list=""
    parse var list opt1 '&' list
    m=m+1
    parse var opt1 avar '=' aval ; avar=strip(translate(sre_packur(avar)))
    optname.0=optname.0||' '||avar
    aval=translate(aval,' ', '+')
    aval=sre_packur(aval)
    avar1='!!'avar
    if optname.avar1<>'' then
       optname.avar1=optname.avar1||' '||aval
    else
       optname.avar1=aval
    avar2='!'avar
    aval2=strip(translate(aval,' ','090a0d'x))
    optname.avar2=aval2
end

/***** End of GENERIC CMS addon code *****/

if optname.!action='1' then do   /* find the list of dataseries defined for this host*/
  call show_datafiles
  foo=result
  return foo
end

if optname.!action='2' then do   /* choose a record */
  call ask_record
  foo=result
  return foo
end


if optname.!action='3' then do   /* modify fields in the record*/
  call modify_record
  foo=result
  return foo
end

if optname.!action='4' then do   /* save the modified record */
  call save_record
  foo=result
  return foo
end

if optname.!action='5' then do   /* save the modified record */
  call view_file
  foo=result
  return foo
end


/*******************/
/* pick one of the current cms datafiles (for this host) */
show_datafiles:

call lineout tempfile,'<html><head><title>CMS: Choose a CMS datafile</title> '


call lineout tempfile,'<font size=-1><a href="'||mainaddon||'?action=1">Another CMS action</a></font><br>'

call lineout tempfile,'<h3>Select a CMS dataseries</h3><em>containing the record you want to modify...</em><p> '

ahost=host_nickname

/* look for files, in cmsDIR_index dir, of the form: ahost_nnnn.DEF
   These .DEF files define "CMS indices" --- nnnn is a number from 0 to 9999
*/

cookie_value=sreh2_get_cookie('CMS') 

call lineout tempfile,'<FORM name="" action="'||thisaddon||'" method="POST">'
call lineout tempfile,'<input type="hidden" name="action" value="2">'
ff=cmsdir_index||'\'||ahost||'*.DEF'
goo=sysfiletree(ff,'ff2','FO')

call lineout tempfile,'For host: <Tt>'||ahost||'</tt>, the following CMS dataseries have been created'

call lineout tempfile,'<table border=1>'
do jj=1 to ff2.0
   daname=filespec('n',ff2.jj)
   call read_deffile ff2.jj
   call lineout tempfile,'<tr><th align="left">' 
   if daname=cookie_value  | (cookie_value='' & jj=1) then
      call lineout tempfile,'<INPUT TYPE="RADIO" checked name="deffile" value="'||daname||'">' 
   else
      call lineout tempfile,'<INPUT TYPE="RADIO"  name="deffile" value="'||daname||'">' 
   gob=strip(stuff.!series)||'</th>'
   call lineout tempfile,gob||'<td> <em>&nbsp;'||stuff.!desc||'</em></td>'
end

call lineout tempfile,'</table>'


call lineout tempfile,''
call lineout tempfile,'<br>'

call lineout tempfile,'<table><tr><td><em>Range of records: </em><br> Display records entered <br>between </td>'
call lineout tempfile,'<td><table><tr><td><input type="text" name="SDAY" value="1">'
call lineout tempfile,' <select name="SMONTH" size=1>'
call lineout tempfile,'   <Option selected value="Jan">Jan '
call lineout tempfile,'   <Option value="Feb">Feb '
call lineout tempfile,'   <Option value="Mar">Mar '
call lineout tempfile,'   <Option value="Apr">Apr '
call lineout tempfile,'   <Option value="May">May '
call lineout tempfile,'   <Option value="Jun">Jun '
call lineout tempfile,'   <Option value="Jul">Jul '
call lineout tempfile,'   <Option value="Aut">Aug '
call lineout tempfile,'   <Option value="Sep">Sep '
call lineout tempfile,'   <Option value="Oct">Oct '
call lineout tempfile,'   <Option value="Nov">Nov '
call lineout tempfile,'   <Option value="Dec">Dec '
call lineout tempfile,'</select>'
call lineout tempfile,'<Input type="text" name="SYEAR" value="2003">'
call lineout tempfile,'</td>'
call lineout tempfile,' <tr><th>and</th>'
call lineout tempfile,'<tr valign="top" ><td>'
call lineout tempfile,'<input type="text" name="EDAY" value="31">'
call lineout tempfile,' <select name="EMONTH" size=1>' 
call lineout tempfile,'   <Option selected value="Jan">Jan '
call lineout tempfile,'   <Option value="Feb">Feb '
call lineout tempfile,'   <Option value="Mar">Mar '
call lineout tempfile,'   <Option value="Apr">Apr '
call lineout tempfile,'   <Option value="May">May '
call lineout tempfile,'   <Option value="Jun">Jun '
call lineout tempfile,'   <Option value="Jul">Jul '
call lineout tempfile,'   <Option value="Aut">Aug '
call lineout tempfile,'   <Option value="Sep">Sep '
call lineout tempfile,'   <Option value="Oct">Oct '
call lineout tempfile,'   <Option value="Nov">Nov '
call lineout tempfile,'   <Option selected value="Dec">Dec '
call lineout tempfile,'</select>'
call lineout tempfile,'<Input type="text" name="EYEAR" value="2004">'
call lineout tempfile,'</td></table>'
call lineout tempfile,'</td></table>'


call lineout tempfile,''
call lineout tempfile,'<p><INPUT name="sub2" TYPE="submit" VALUE="Choose a CMS dataseries">'
call lineout tempfile,'</form>'
call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode


/*******************/
/* pick a record to modify */
ask_record:

call lineout tempfile,'<html><head><title>CMS: Choose record to modify</title> '

daindx=optname.!deffile

call lineout tempfile,'</head>'
call lineout tempfile,'<font size=-1><a href="'||mainaddon||'?action=1">Another CMS action</a> || '
call lineout tempfile,'<a href="'||root||'cms_cmtm.cmd?action=2&deffile='||daindx||'">Modify a comment in this dataseries </a>  '
call lineout tempfile,'</font><br>'

call lineout tempfile,'<h3>Modify a record in a CMS dataseries</h3> '

ff=cmsdir_index||'\'||daindx
goo=stream(ff,'c','query exists')
if goo='' then do
   call lineout tempfile,'Error: could not find index file: '||ff
   signal gooble
end

call read_deffile ff
got_abs=wordpos('$ABSTRACT',translate(stuff.!SPECIALS))

/* check for access rights */
rcode=check_access(stuff.!OWNERS,stuff.!SERIES)
if rcode<>1 then return rcode


a=sre_cache_data(stuff.!series,'OPEN  INDEX',stuff.!file)
if a>0 then do
   amess=sre_cache_data('OPEN','ERROR',a,stuff.!file)
   call lineout tempfile,'<b>Error:</b> '||amess
   signal gooble
end

a=sre_cache_data(stuff.!series,'INFO',,'MODIFIED RECORDS VARS DESCRIPTION')
parse var a astat a ; astat=strip(astat)
if astat<>'0' then do
   amess=sre_cache_data('INFO','ERROR',astat)
   call lineout tempfile,'<b>Error retrieving info:</b> '||amess
   signal gooble
end

parse var a . '0d0a'x . '09'x modified  '=' . '09'x nrecords0 '09'x  varlist '09'x  desc
nrecords=nrecords0-4

astat=sreh2_set_cookie('CMS',daindx,1,root,,1) 

call lineout tempfile,'<FORM name="domodify" action="'||thisaddon||'" method="POST">'
call lineout tempfile,'<input type="hidden" name="action" value="3">'
call lineout tempfile,'<input type="hidden" name="deffile" value="'||daindx||'">'

call lineout tempfile,'<em>For the CMS dataseries: </eM><b>'||stuff.!series||'</b><br>'
call lineout tempfile,'<table>'
call lineout tempfile,'<tr><th align="left">Last modified:</th><td>'||modified||'</td>'
call lineout tempfile,'<tr><th align="left"># of records currently in dataseries:</th><td>'||nrecords||'</td>'
call lineout tempfile,'<tr><th align="left">Description:</th><td>'||desc||'</td>'
call lineout tempfile,'</table>'
call lineout tempfile,'<p>Select record to modify<p>'

tt='' 
if got_abs>0 then tt='ABSTRACT=$ABSTRACT '

a=sre_cache_data(stuff.!series,'EXTRACT ID7 ID '||tt,"1-"||nrecords0)
parse var a astat ndo '0d0a'x a
if astat<>0 then do
     amess=sre_cache_data('EXTRACT','ERROR',astat,"1-"||nrecords0)
     call lineout tempfile,'<b>Error retrieving info:</b> '||amess
     signal gooble
end

/* determine range */
s1=optname.!sday||' '||optname.!Smonth||' '||optname.!SYEAR
e1=optname.!eday||' '||optname.!emonth||' '||optname.!eYEAR

foo=dateconv(s1,'n','b')
if foo='' then 
 s2=0             /* error, no lower limit */
else
  s2=foo-726467

foo=dateconv(e1,'n','b')
if foo='' then 
 e2=1111110             /* error, no upper limit */
else
  e2=foo-726467

call lineout tempfile,'<em>Display records entered between '||s1||' and '||e1||'</em><br>'

ndo_real=0
nall=0

call lineout tempfile,'<ol>'
do nn=1 to ndo
   if got_abs>0 then
     parse var a id7 id '09'x abstract '0d0a'x a
   else
      parse var a id7 id '0d0a'x a

   if datatype(id)<>'NUM' then iterate

   nall=nall+1
   nid=trunc(id)
   if nid<s2 | nid>e2 then do
     iterate
   end
   ndo_real=ndo_real+1

   aaid='<a target="val" href="'||root||'cms_rem.cmd?action=4&deffile='||daindx||'&id='||id7||'">'||id||'</a>'
   call lineout tempfile,'<li><input   '
   call lineout tempfile,'             type="radio" name="modify" value="'||id7||'">'||aaid
   if got_abs>0 then call lineout tempfile,'<em>'||abstract||'</em>'
end 
call lineout tempfile,'</ol>'


call lineout tempfile,'<input name="sub2" type="submit" value="Choose record to modify ">'
call lineout tempfile,'</form>'

call lineout tempfile,'<br>Note: displaying <tt>'ndo_real'</tt> of <tt>'nall'</tt> total records.'


gooble:         /* jump here on error */
a=sre_cache_data(stuff.!series,'CLOSE')

call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode





/*************/
/* read a definition file */
read_deffile:
parse arg afile
stuff.=''
stuff=sre_read_file(afile,2,2,1)
do until stuff=''
   parse var stuff aline '0d0a'x stuff ; aline=strip(aline)
   if aline='' then iterate
   if abbrev(aline,';')=1 then iterate
   parse var aline aname ':' avalue
   aname='!'||strip(translate(aname))
   stuff.aname=strip(avalue)
end

return 1


/*******************/
/* modify a record  */
modify_record:

call lineout tempfile,'<html><head><title>CMS: Modify a record </title> '

daindx=optname.!deffile

call lineout tempfile,'<font size=-1>'
call lineout tempfile,'<a href="javascript:history.go(-1)">Back</a> '
call lineout tempfile,'</font><br>'

call lineout tempfile,'<h3>Modify a CMS record</h3> '

ff=cmsdir_index||'\'||daindx
goo=stream(ff,'c','query exists')
if goo='' then do
   call lineout tempfile,'Error: could not find index file: '||ff
   signal gooble
end

call read_deffile ff

/* check for access rights */
rcode=check_access(stuff.!OWNERS,stuff.!SERIES)
if rcode<>1 then return rcode

a=sre_cache_data(stuff.!series,'OPEN  INDEX',stuff.!file)
if a>0 then do
   amess=sre_cache_data('OPEN','ERROR',a,stuff.!file)
   call lineout tempfile,'<b>Error:</b> '||amess
   signal gooble
end

varnames=stuff.!varnames
vartypes=stuff.!vartypes
vartypes.=''
varnames.=''
varnames.0=0
do mm=1 to words(varnames)
  avar=strip(translate(word(varnames,mm)))
  varnames.mm=avar
  atype=strip(translate(word(vartypes,mm)))
  varnames.mm.!type=atype
  vv='!'||avar
  vartypes.vv=atype
end
varnames.0=words(varnames)

getvs='%ID VALS VALINDEX '||stuff.!SPECIALS
a=sre_cache_data(stuff.!series,'FIND ID7',optname.!modify,getvs)
parse var a astat a
if astat>0 then do
   amess=sre_cache_data('FIND','ERROR',astat)
   call lineout tempfile,'<b>Error:</b> '||amess
   signal gooble
end


/* find real id (in the actual data)
vars are: VALS VALINDX [$STATUS] [$abstract]  [Special1 ... ] */
parse var a . '0d0a'x realid '0d0a'x morea ; realid=strip(realid)

call lineout tempfile,'<em>From the CMS dataseries: </eM><b>'||stuff.!series||'</b><br>'

call lineout tempfile,'<FORM name="domodify" action="'||thisaddon||'" method="POST">'
call lineout tempfile,'<input type="hidden" name="action" value="4">'
call lineout tempfile,'<input type="hidden" name="deffile" value="'||daindx||'">'
call lineout tempfile,'<input type="hidden" name="id7" value="'||optname.!MODIFY||'">'
call lineout tempfile,'<input type="hidden" name="realid" value="'||realid||'">'

parse var a id7 vlist '0d0a'x a

call lineout tempfile,"<table border=1>"
av1='Record ID<br>Entered on'
tim=fig_time(realid)
aval1=realid||'<br>'||tim
call lineout tempfile,'<tr bgcolor="#998899"><th align="left" >'||av1||'</th><td>'||aval1||'</td>'

parse var morea vals '0d0a'x indx '0d0a'x morea
vvals.=''
if words(stuff.!pack)>0 then do               /* there are some packed variables */
  if strip(indx)=0 then do
     call lineout tempfile,'<b>Error</b>: packed variables specified, but no data '
     signal gooble
  end 
  iat=1
  do mm=1 to words(stuff.!pack)
      aww=strip(translate(word(stuff.!pack,mm)))
      vv='!'||aww
      vvals.vv.!name=aww
      vvals.vv.!type=vartypes.vv
      ilen=strip(word(indx,mm))
      if ilen=0 then iterate
      vvals.vv=substr(vals,iat,ilen)
      iat=iat+ilen
  end
end

/* add the special variables */
if stuff.!specials<>'' then do
  do jj=1 to words(stuff.!specials)
      aww=strip(translate(word(stuff.!specials,jj)))
      vv='!'||aww
      vvals.vv.!name=aww
      vvals.vv.!type=vartypes.vv
      parse var morea vvals.vv '0d0a'x morea
  end
end
ncomments=0

do ii=1 to varnames.0
   aww=varnames.ii ; vv='!'||aww
   atype=vvals.vv.!type
   aname=strip(vvals.vv.!name)
   aval1=vvals.vv
   select
     when aname='$STATUS' then
       call lineout tempfile,'<tr><td align="left" ><em>status</em></td>'
     when atype<>'A' then 
       call lineout tempfile,"<tr><th align="left" >"||aname||'</th>'
     otherwise
       call lineout tempfile,'<tr><td align="left" ><em>Abstract</em></td>'
   end  

   select 
        when aname='$STATUS' then do
          call lineout tempfile,'<td><input type="hidden" name="-VAR_'||aname||'" value="'||aval1||'" ><tt>'||aval1||'</tt>'
          parse upper var aval1 . 'CMT_CNT=' ncomments . ; ncomments=strip(ncomments)
        end  
        when atype='C' then do
           ischeck=''
           if aval1='1' then ischeck='CHECKED'
           call lineout tempfile,'<td><input 'ischeck' type="checkbox" name="-VAR_'||aname||'" value="1" >'
        end
        when atype='T' then do
           use_time=fig_time(aval1,1)
           if use_time<>'' then do
             use_time=translate(use_time,' ','/')
             parse var use_time aa1 aa2 aa3 
             if aa3>80 then 
                aa3='19'||aa3
             else
                aa3='20'||aa3
             use_time=aa1||' '||aa2||' '||aa3
           end
           call lineout tempfile,'<td><input size=24 type="text" name="-VAR_'||aname||'" value="'||use_time||'" ><tt>['||aval1||']</tt>'
           call lineout tempfile,'<em>(enter: day month year hour minute) </em>'
        end
        when atype='F' then do
           call lineout tempfile,'<td><input size=70 type="text" name="-VAR_'||aname||'" value="'||aval1||'" >'
           parse var aval1 oname '=' fname . ';' . '='  ctype ; ctype=space(ctype,0)
           call lineout tempfile,'<br><font size=-1><a href="'||thisaddon||'?action=5&deffile='||daindx||,
                                 '&file='||fname||'&ofile='||oname||'&ctype='||ctype||'" target="viewer">view</a>'
           call lineout tempfile,' or <font size=-1><a href="'||thisaddon||'?action=5&astext=1&deffile='||daindx||,
                                 '&file='||fname||'&ofile='||oname||'&ctype='||ctype||'" target="viewer">view as text</a>'
        end

        when atype='M' then do
           aval1=sre_pack64(aval1)
           call lineout tempfile,'<td><textarea rows=8 cols=80 name="-VAR_'||aname||'">'||aval1||'</textarea>'
        end

        when atype='N' then do
           call lineout tempfile,'<td><input size=22 type="text" name="-VAR_'||aname||'" value="'||aval1||'" ><em>(enter a number)</em>'
        end

        when atype='A' then do
           call lineout tempfile,'<td><input size=50 type="text" name="-VAR_'||aname||'" value="'||aval1||'" >'
        end

        when atype='S' then do
           call lineout tempfile,'<td><input size=40 type="text" name="-VAR_'||aname||'" value="'||aval1||'" >'
           call lineout tempfile,"<font size=-1><em>This value is from a list of options</em></font>"
        end

        when atype='P' then do
           call lineout tempfile,'<td><input size=40 type="text" name="-VAR_'||aname||'" value="'||aval1||'" >'
           call lineout tempfile,"<font size=-1><em>This value is from a poll-definition</em></font>"
        end
     
        otherwise do
           call lineout tempfile,'<td><input size=80 type="text" name="-VAR_'||aname||'" value="'||aval1||'" >'
        end
   end
   call lineout tempfile,"</td>"

end 
call lineout tempfile,"</table>"

call lineout tempfile,'<input name="sub2" type="submit" value="Modify these values ">'
call lineout tempfile,'</form>'


if ncomments>0 then do
  call lineout tempfile,'<br><a href="'||root||'cms_cmtm.cmd?action=30&deffile='||daindx||'&comment='||realid||'">Modify one of the 'ncomments' comments about this record</a>  '
end

gooble:         /* jump here on error */
a=sre_cache_data(stuff.!series,'CLOSE')

call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode



/*******************/
/* dave the modified values   */
save_record:

call lineout tempfile,'<html><head><title>CMS: Save modified values</title></head> '

call lineout tempfile,'<font size=-1><a href="'||mainaddon||'?action=1">Another CMS action</a></font><br>'

call lineout tempfile,'<h3>Saving modified values of a CMS record</h3> '

daindx=optname.!deffile
ff=cmsdir_index||'\'||daindx
goo=stream(ff,'c','query exists')
if goo='' then do
   call lineout tempfile,'Error: could not find index file: '||ff
   signal gooble
end

call read_deffile ff

/* check for access rights */
rcode=check_access(stuff.!OWNERS,stuff.!SERIES)
if rcode<>1 then return rcode

a=sre_cache_data(stuff.!series,'OPEN  INDEX',stuff.!file)
if a>0 then do
   amess=sre_cache_data('OPEN','ERROR',a,stuff.!file)
   call lineout tempfile,'<b>Error:</b> '||amess
   signal gooble
end

varnames=stuff.!varnames
vartypes=stuff.!vartypes
if words(varnames)<>words(stuff.!vartypes) then do
   call lineout tempfile,'Error: mismatch in vars and vatrypes in '||ff
   signal gooble
end
vartypes.=''
varnames.=''
varnames.0=0
do mm=1 to words(varnames)
  avar=strip(translate(word(varnames,mm)))
  varnames.mm=avar
  atype=strip(translate(word(vartypes,mm)))
  varnames.mm.!type=atype
  vv='!'||avar
  vartypes.vv=atype
end
varnames.0=words(varnames)

allopts=translate(optname.0)

vdo.='' 
do until allopts=''
   parse var allopts avv allopts
   if abbrev(avv,'-VAR_')=0 then iterate
   parse var avv '-VAR_' avv2 . ; 
   avv2=strip(translate(sre_packur(avv2)))
   vv='!'||avv2
   atype=vartypes.vv
   if atype='' then do
      call lineout tempfile,'<b>Error.</b> No type defined for variable '||avv2
      signal gooble
   end 
   avv3='!-VAR_'||avv2
   vdo.vv=optname.avv3

   if atype='N' then do
      if vdo.vv='' then vdo.vv=0
      if datatype(vdo.vv)<>'NUM' then do
         call lineout tempfile,'<pre>ERROR: non-number entered for a <tt>Number</tt> variable: '||avv2||'</pre>'
         signal gooble
      end
   end

   select
     when atype='T' then do

       tt=sre_packur(optname.avv3)
       parse var tt aday amonth  ayear ahour  aminute

       ayear=strip(ayear) ; aday=strip(aday); ahour=strip(ahour)
       aminute=strip(aminute) ; amonth=strip(amonth)
       if datatype(ayear)<>'NUM' then do
           call lineout tempfile,'Error: bad year entry: '||ayear
           signal gooble
       end 
       select
         when ayear<60 then uyear=1900+ayear
         when ayear<1000  then  uyear=1900+ayear
         otherwise uyear=right(ayear,4,'0')
       end

       if datatype(amonth)<>'NUM' then do
         Imonth=wordpos(translate(amonth),'JAN FEB MAR APR MAY JUN JUL AUG SEP OCT NOV DEC')
         IF IMONTH=0 then DO
           Imonth=wordpos(translate(amonth),'JANUARY FEBRUARY MARCH APRIL MAY JUNE JULY AUGUST SEPTEMBER OCTOBER NOVEMBER DECEMBER')
           IF IMONTH=0 then do
              call lineout tempfile,'Error: bad month entry: '||amonth
              signal gooble
           END
         END
         AMONTH=IMONTH
       end 
       IF AMONTH<1 | AMONTH>12 then DO
              call lineout tempfile,'Error: bad month entry: '||amonth
              signal gooble
       END
       tmonth=right(amonth,2,'0')

       if datatype(aday)<>'NUM' then do
           call lineout tempfile,'Error: bad day entry: '||aday
           signal gooble
       end 
       IF ADAY<1 | ADAY>31 then DO
           call lineout tempfile,'Error: bad day entry: '||aday
           signal gooble
       end 
       tday=right(aday,2,'0')

       ss=uyear||tmonth||tday

       goo=dateconv(ss,'S','B')

       if goo='' then do
          call lineout tempfile,'Error: bad date entry: '||ss
          signal gooble
       end 
       goo=goo-726467
       if datatype(ahour)<>'NUM' then do
           call lineout tempfile,'Error: bad hour entry: '||ahour
           signal gooble
       end 
       IF AHOUR<0 | AHOUR>23 then DO
           call lineout tempfile,'Error: bad hour entry: '||ahour
           signal gooble
       end 
       if datatype(aminute)<>'NUM' then do
           call lineout tempfile,'Error: bad minute entry: '||aminute
           signal gooble
       end 
       IF AMINUTE<0 | AMINUTE>59 then DO
           call lineout tempfile,'Error: bad minute entry: '||aminute
           signal gooble
       end 

       goo2=((ahour*60)+aminute)/1440
       if goo2>1 | GOO2<0 then do
           call lineout tempfile,'Error: bad time-of-day entry: '||tt
           signal gooble
       end 
       parse var goo2 . '.' goo2

       j_time=goo||'.'||goo2
       vdo.vv=j_time
    end
    when atype='M' then do
        aavv3='!!-VAR_'||avv2
        vdo.vv=sre_pack64_make(optname.aavv3)
    end
    otherwise do
      vdo.vv=sre_packur(optname.avv3)
    end
  end           /* select by atype */
end 


specs.=''
if stuff.!pack='' then do
   data_var1=''
   data_var2=0
end 
else do
   data_var1=''
   data_var2=''
   iat=1
   do nn=1 to words(stuff.!pack)
       aww=strip(translate(word(stuff.!pack,nn)))
       vv='!'||aww
       if vartypes.vv='' then do
          call lineout tempfile,'Error: unknown packed variable '||aww
          signal gooble
       end 
       data_var1=data_var1||vdo.vv
       klen=length(vdo.vv)
       data_var2=data_var2||klen||' ' 
       vvals.vv=substr(vals,iat,klen)
  end
end 

ltot=length(data_var1)+length(data_var2)


/* and the special variables */
if stuff.!specials<>'' then do
   do nn=1 to words(stuff.!specials)
       aww=strip(translate(word(stuff.!specials,nn)))
       vv='!'||aww
       if vartypes.vv='' then do
          call lineout tempfile,'Error: unknown special variable '||aww
          signal gooble
       end 

       if aww='$STATUS' then do         /* modify the MOD= field */
          poo='' ;tt=vdo.vv
          do until tt=''
             parse var tt aa tt
             parse upper var aa aa1 '=' aa2 ;aa1=strip(aa1); aa2=strip(aa2)
             if  aa1='MOD' then
                poo=poo||' MOD='||sre_gmt(,,'JS',0)
             else
                poo=poo||' '||aa
          end 
          vdo.vv=poo
       end 
       specs.nn=vdo.vv
       ltot=ltot+length(specs.nn)
   end
end


/* record too big? */
if ltot>max_record_size then do
   call lineout tempfile,'Error: record size (<tt>'||ltot||'</tt>) is too large (maximum is '||max_record_size||' bytes)'
   signal gooble
end


daid=strip(optname.!!id7)
poo=sre_cache_data(stuff.!series,'MODIFY WRITE ID7 ',daid,,
              data_var1,data_var2,specs.1,specs.2,specs.3,specs.4,specs.5,specs.6,specs.7,specs.8)

if length(poo)=1 then do
   amess=sre_cache_data('MODIFY','ERROR',poo)
   call lineout tempfile,'<b>Error:</b> '||amess
   signal gooble
end


gooble:         /* jump here on error */
a=sre_cache_data(stuff.!series,'CLOSE')

if lengtH(poo)>1 then
  call lineout tempfile,'Modifications saved for: <TT>'||optname.!realid||'</tt><em> ( '||daid||' ) </em>'
else
  call lineout tempfile,'<p>Unable to create new record -- try again later <p>'


call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode




/** vdo*****************/
/* view a stored file */
view_file:


daindx=optname.!deffile
ff=cmsdir_index||'\'||daindx
goo=stream(ff,'c','query exists')
if goo='' then do
   call lineout tempfile,'<html><head><title>CMS: View a stored file </title> '
   call lineout tempfile,'Error: could not find CMS dataseries''s index file: '||ff
   signal gooble
end

call read_deffile ff
/* check for access rights */
rcode=check_access(stuff.!OWNERS,stuff.!SERIES)
if rcode<>1 then return rcode

ff=strip(stuff.!UPLOADDIR,,'\')||'\'||optname.!file
if stream(ff,'c','query exists')='' then do
   call lineout tempfile,'<html><head><title>CMS: View a stored file </title> '
   call lineout tempfile,' Error: for 'optname.!ofile'; could not find stored file '||optname.!file
   signal gooble
end

dtype=optname.!ctype
if dtype='' | optname.!astext=1 then dtype='text/plain'
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF TYPE '||dtype||' NAME 'ff,,idinfo)
return rcode


gooble:         /* jump here on error */

call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode


/******************************/
/* check access rights. Return 1 if okay. Otherwise, return a string to be
  sent back to SREhttp/2 (an authorization response string) */
check_access:procedure expose privset host_nickname idinfo uri aiter
parse  upper arg owners,series

if owners='' then return 1      /* no owners listed, means open access */

pneeded=space(translate('CMS:'||strip(series)),0)
if wordpos(pneeded,translate(privset))>0 then return 1          /* explicit privilege for this */

/* see if a cookie exists */
look_cook='CMS_'||series
aa=sreh2_get_cookie(lookcook)
if aa<>''  then return 1

if aiter=''  then do            /* first time, so recheck privs */
  return 'PRIVS   Access to this dataseries is restricted to specific users '
end 

/* otherwise, see if a username has been sent  */
username=''
authh=sre_reqfield('Authorization')
if authh<>'' then username=sre_extract_username(authh) 
if username='' then do             /* no username available */
  return  'AUTH  Access to this dataseries is restricted to specific users '
end

/* is this one of the OWNERS? */
if pos('*',owners)=0 then do            /* * means "any user" */
if wordpos(translate(username),translate(owners))=0 then do
   return 'AUTH  Access to this dataseries is restricted to specific users '
end
end

/* One of the OWNERS, now check password */
stuff=sreh2_get_userinfo(authh,host_nickname,idinfo)
if stuff='' then do
  return 'AUTH   Access to this dataseries is restricted to specific users. Please enter a new username/password.'
end

parse var uri thisaddon '?' .
jj=lastpos('/',thisaddon)
pp=left(thisaddon,jj)

foo=sreh2_set_cookie(lookcook,1,'30m',pp,,1)

/* if here, legit user.  Record a cookie */
return 1




/************/
/* convert from CMS id  (JS time stamp) to "N" time stamp */
fig_time:procedure
parse arg atime0,is_simple

if datatype(atime0)<>'NUM' then return ''

parse var atime0 adate1 '.' atime
adate=adate1+726467
atime='0.'||atime

if is_simple=1 then
  dd=dateconv(adate,'B','E')
else
  dd=dateconv(adate,'B','N')

/* else, convert to hr min second */
zz=digits()
numeric digits 16
secs=trunc(atime*86400)
tmp0=secs/3600
parse var tmp0 hour '.' tmp1 ; if tmp1='' then tmp1=0
hour=right(hour,2,'0')
tmp1='0.'||tmp1
tmp2=tmp1*60
parse var tmp2 minute '.'tmp3 ; ; if tmp3='' then tmp3=0
minute=right(minute,2,'0')
tmp3='0.'||tmp3
tmp3=tmp3*60 ; parse var tmp3 second '.' .
second=right(second,2,'0')
numeric digits zz

if is_simple=1 then
  dd=dd||' '||hour||' '||minute
else
  dd=dd||' '||hour||':'||minute||':'||second
return dd


