/* The SREhttp/2 content management system (CMS) program 

Restructure a cms dataseries.
 

*/

/******** User changeable parameters ***/
/* root directory for the SREhttp/2 CMS addon.
   Leave blank to use default (CMS subdirectory of srehttp/2 addon directory */
cmsdir=''


/* maximum size, in bytes, of a record. This does NOT include size of uploaded files & URLS */
max_record_size=5000



/******** end of user changeable parameters ***/


parse arg list,servername,verb,tempfile,,
          prog_file,reqnum,verbose,client_ip,privset,,
          uri,host_nickname,idinfo,aiter,attribs,seluse2

crlf='0d0a'x

if verb=" " then do
   say "This SREhttp/2 procedure is not meant to be run in standalone mode "
   exit
end  

addon_dir=sre_value('H2_ADDON_DIR_DEFAULT',,'SRE')
if cmsdir='' then cmsdir=strip(addon_dir,,'\')||'\CMS'
foo=dosisdir(cmsdir)
if foo=0 then return 'String Error:unable to find CMS directory: ('cmsdir

cmsdir_data=cmsdir||'\DATA'
okk=dosisdir(cmsdir_data)
if okk=0 then do
  return 'string unable to find CMS data directory: 'cmsdir_data
end

cmsdir_upload=cmsdir||'\UPLOADS'
okk=dosisdir(cmsdir_upload)
if okk=0 then do
  return 'string unable to find CMS uploads directory: 'cmsdir_upload
end


cmsdir_file=cmsdir||'\FILES'
okk=dosisdir(cmsdir_file)
if okk=0 then do
  return 'string unable to find CMS working files directory: 'cmsdir_file
end

cmsdir_lib=cmsdir||'\LIB'
okk=dosisdir(cmsdir_lib)
if okk=0 then do
  return 'string unable to find CMS lib directory: 'cmsdir_lib
end

cmsdir_pol=cmsdir||'\LIB\POL'
okk=dosisdir(cmsdir_pol)
if okk=0 then do
  return 'string unable to find CMS index directory: 'cmsdir_pol
end


cmsdir_index=cmsdir||'\INDEX'
okk=dosisdir(cmsdir_index)
if okk=0 then do
  return 'string unable to find CMS index directory: 'cmsdir_index
end

parse var uri thisaddon '?' .
jj=lastpos('/',thisaddon)
mainaddon=left(uri,jj)||'cms.cmd'
root=left(uri,jj)

optname.=''
m=0
if list='' then list='action=1'
do until list=""
    parse var list opt1 '&' list
    m=m+1
    parse var opt1 avar '=' aval ; avar=strip(translate(avar)) 
    optname.0=optname.0||' '||avar
    aval=translate(aval,' ', '+')
    aval=sre_packur(aval)
    avar1='!!'avar
    if optname.avar1<>'' then
       optname.avar1=optname.avar1||' '||aval
    else
       optname.avar1=aval
    avar2='!'avar
    aval2=strip(translate(aval,' ','090a0d'x))
    optname.avar2=aval2
end

/***** End of GENERIC CMS addon code *****/

if optname.!action='1' then do   /* find the list of dataseries defined for this host*/
  call show_datafiles
  foo=result
  return foo
end

if optname.!action='2' then do   /* verify that this should be deleted */
  call step2
  foo=result
  return foo
end


if optname.!action='3' then do   /* verify that this should be deleted */
  call step3
  foo=result
  return foo
end

return 'string unknown action 'action


/*******************/
/* pick one of the current cms datafiles (for this host) */
show_datafiles:

call lineout tempfile,'<html><head><title>CMS: Restructure a CMS datafile</title> '


call lineout tempfile,'<font size=-1><a href="'||mainaddon||'?action=1">Another CMS action</a> ||'
call lineout tempfile,'<a href="'||root||'cms_def2.cmd?action=1">Modify dataseries templates</a> ||  '
call lineout tempfile,'<a href="'||root||'cms_def3.cmd?action=1">Modify dataseries directories</a> '
call lineout tempfile,'</font><br>'

call lineout tempfile,'<h3>Restructure a CMS dataseries</h3><p> '
call lineout tempfile,'<em>Modify the name, description, and  variables, of a CMS dataseries</em><br>' 
ahost=host_nickname

/* look for files, in cmsDIR_index dir, of the form: ahost_nnnn.DEF
   These .DEF files define "CMS indices" --- nnnn is a number from 0 to 9999
*/

call lineout tempfile,'<FORM name="" action="'||thisaddon||'" method="POST">'
call lineout tempfile,'<input type="hidden" name="action" value="2">'
ff=cmsdir_index||'\'||ahost||'*.DEF'
goo=sysfiletree(ff,'ff2','FO')

call lineout tempfile,'For host: <Tt>'||ahost||'</tt>, the following CMS dataseries currently exist'

call lineout tempfile,'<table border=1>'
do jj=1 to ff2.0
   daname=filespec('n',ff2.jj)
   call read_deffile ff2.jj
   call lineout tempfile,'<tr><th align="left">' 
   call lineout tempfile,'<INPUT TYPE="RADIO"  name="deffile" value="'||daname||'">'
   gob=strip(stuff.!series)||'</th>'
   call lineout tempfile,gob||'<td> <em>&nbsp;'||stuff.!desc||'</em></td>'
end

call lineout tempfile,'</table>'


call lineout tempfile,''
call lineout tempfile,'<p><INPUT name="sub2" TYPE="submit" VALUE="Restructure the selected CMS dataseries">'
call lineout tempfile,'</form>'
call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode


/*******************/
/* show current structure, ask for changes */
step2:

call lineout tempfile,'<html><head><title>CMS: Restructure a dataseries</title> '
call lineout tempfile,'<script language="javascript">'
call lineout tempfile,' var the_select="NEW_SELECT"; '
call lineout tempfile,'function putit(sfile) {'
call lineout tempfile,'  eval("document.doredo." + the_select + ".value= ''" +  sfile + "''" ) ;'
call lineout tempfile,' return 0 ;}'

call lineout tempfile,'function putit2(sfile) {'
call lineout tempfile,'  eval("document.doredo.NEW_SELECT.value= ''" +  sfile + "''" ) ;'
call lineout tempfile,' return 0 ;}'

 call lineout tempfile,'</script>'
call lineout tempfile,'</head>'

daindx=optname.!deffile
goo=lastpos('/',mainaddon)
goo2=left(mainaddon,goo)||'/cms_def2.cmd'
goo3=left(mainaddon,goo)||'/cms_bak.cmd'

call lineout tempfile,'<font size=-1>'
if optname.!CLOSEIT=1 then 
   call lineout tempfile,'<a href="javascript:close()">Close window</a> || '
else
   call lineout tempfile,'<a href="javascript:history.go(-1)">Back</a> || '
call lineout tempfile,' <a href="'||mainaddon||'?action=1">Another CMS action</a> || '
call lineout tempfile,'<a href="'||goo3||'?action=2&deffile='||daindx||'">Backup this dataseries</a> || ' 
call lineout tempfile,'<a href="'||goo2||'?action=1">Edit data series templates</a>' 
call lineout tempfile,'</font><br>'

call lineout tempfile,'<h3>Restructure a CMS dataseries</h3> '


if daindx='' then do
   call lineout tempfile,'Error: you forgot to select a dataseries.<br>'
   call lineout tempfile,'Please <a href="javascript:history.go(-1)">go back</a> and select one!'
   signal gooble
end


ff=cmsdir_index||'\'||daindx
goo=stream(ff,'c','query exists')
if goo='' then do
   call lineout tempfile,'Error: could not find index file: '||ff
   signal gooble
end

call read_deffile ff
/* check for access rights */
rcode=check_access(stuff.!OWNERS,stuff.!SERIES)
if rcode<>1 then return rcode

a=sre_cache_data(stuff.!series,'OPEN  INDEX',stuff.!file)
if a>0 then do
   amess=sre_cache_data('OPEN','ERROR',a,stuff.!file)
   call lineout tempfile,'<b>Error:</b> '||amess
   signal gooble
end

a=sre_cache_data(stuff.!series,'INFO',,'MODIFIED RECORDS VARS DESCRIPTION')
parse var a astat a ; astat=strip(astat)
if astat<>'0' then do
   amess=sre_cache_data('INFO','ERROR',astat)
   call lineout tempfile,'<b>Error retrieving info:</b> '||amess
   signal gooble
end

parse var a . '0d0a'x . '09'x modified  '=' . '09'x nrecords '09'x  varlist '09'x  desc
ii=0
do until varlist=''
   parse var varlist avar varlist
   ii=ii+1
   varnames.ii=strip(translate(avar))
end
varnames.0=ii

call lineout tempfile,'<FORM target="redo" name="doredo" action="'||thisaddon||'" method="POST">'
call lineout tempfile,'<input type="hidden" name="action" value="3">'
call lineout tempfile,'<input type="hidden" name="deffile" value="'||daindx||'">'

call lineout tempfile,'<em>For the CMS dataseries: </eM><b>'||stuff.!series||'</b><br>'
call lineout tempfile,'<table>'
call lineout tempfile,'<tr><th align="left">Last modified:</th><td>'||modified||'</td>'
call lineout tempfile,'<tr><th align="left"># of records currently in dataseries:</th><td>'||nrecords||'</td>'
call lineout tempfile,'<tr><th align="left">Description:</th><td>'||desc||'</td>'
call lineout tempfile,'</table>'


allvars=translate(stuff.!VARNAMES)
packvars=translate(stuff.!PACK)
specialVars=translate(stuff.!specials)
alltypes=translate(stuff.!vartypes)
call lineout tempfile,'<hr width="20%">'

call lineout tempfile,'<table><tr><td bgcolor="#a898a9">You can:</td>'
call lineout tempfile,'<td> <ul>'
call lineout tempfile,'<li>Overwrite the dataseries, or create a new dataseries'
call lineout tempfile,'<li>Remove a variable '
call lineout tempfile,'<li>Add a variable '
if wordpos('$ABSTRACT',allvars)=0 then
   call lineout tempfile,'<li>Add an <em>abstract </em> variable '

call lineout tempfile,'<li>Convert the <em>type</em> of a variable to <u>string</u> or <u>lines of text</u>'
call lineout tempfile,'<li>Convert a variable to <u>packed</u> or <u>sortable</u> storage '
call lineout tempfile,'<li>Change the list of usernames in OWNERS and OWNERS-Comment  '
call lineout tempfile,'</ul> </td></table>'


typenames.='undefined type'
typenames.!1='string'
typenames.!A='abstract'
typenames.!N='number'
typenames.!M='lines of text'
typenames.!C='checkbox'
typenames.!T='Date-time'
typenames.!S='select list'
typenames.!P='poll'
typenames.!F='file or url'

gotabs=0
selects=stuff.!SELECT
call lineout tempfile,'<hr width="20%">'

polls=stuff.!POLL 

call lineout tempfile,'Series name: <input type="text" size=20 name="SERIES" value="">'
call lineout tempfile,' <font size=-1><em>to overwrite, leave this field blank</em></font><br>'
call lineout tempfile,'Series description: <input type="text" size=70 name="DESC" value="'||stuff.!DESC||'">'

call lineout tempfile,'<table  >'
call lineout tempfile,'<tr bgcolor="#aaaaaa" >'
call lineout tempfile,'<th>Remove</th><th>Name</th><th>Type</th><th>Sortable/Packed</th>'
call lineout tempfile,'<th>Select/Poll File</th>'
do mm=1 to words(allvars)
    avar1=strip(word(allvars,mm))
    atype1=strip(word(alltypes,mm))
    vtype1='!'||atype1
    isspecial=wordpos(avar1,specialvars)
    ispack=wordpos(avar1,packvars)
    call lineout tempfile,'<tr>'
    if avar1<>'$STATUS' then
        call lineout tempfile,'<td><input type="checkbox" name="REMOVE" value="'||avar1||'"></td>'
    else 
        call lineout tempfile,'<td>&nbsp;</td>'
    call lineout tempfile,'<th>'||avar1||'</th>'

    call lineout tempfile,'<td>'
    select 
      when atype1='A' then do
         call lineout tempfile,'<em>abstract</em>'
      end 
      when avar1='$STATUS' then do
         call lineout tempfile,'<em>internal</em>'
      end
      when atype1='P' then do
         call lineout tempfile,'<tt>poll</tt>'
         call lineout tempfile,'<input type="hidden" name="_TYPE_'||avar1||'" value="P"  size=1>'
      end

      otherwise do
        call lineout tempfile,'<select name="_TYPE_'||avar1||'"  size=1>'
        call lineout tempfile,'<option selected value="'||atype1||'">Retain as '||typenames.vtype1
        if atype1<>'1' then call lineout tempfile,'<option value="1">String'
        if atype1<>'M' then call lineout tempfile,'<option value="M">Lines of text '
        call lineout tempfile,'</select>    '
       end
      end
      call lineout tempfile,'</td>'

     call lineout tempfile,'<td>'

     select
       when avar1='$STATUS' then do
             call lineout tempfile,'<tt>internal</tt>'
       end
       when avar1='$ABSTRACT'  then do
             call lineout tempfile,'<tt>sortable</tt>'
            gotabs=1
       end
       when  atype1="P" then do
             call lineout tempfile,'<tt>sortable</tt>'
       end

       otherwise do
         a1=''; a2=''
         if isspecial>0 then 
            a1=' Selected '
         else
            a2=' Selected '
         call lineout tempfile,'<select name="_PACK_'||avar1||'"  size=1>'
         call lineout tempfile,'<option '||a1||' value="0">Sortable'
         call lineout tempfile,'<option '||a2||' value="1">Packed'
         call lineout tempfile,'</select>    '
      end
     end
     call lineout tempfile,'</td>'



     select 
     when atype1="P" then do
        parse upper var polls . (avar1) . '=' apolfile ';' . ; apolfile=strip(apolfile)
        call lineout tempfile,'<td><input type="hidden" name="_POLL_'||avar1||'" value="'||apolfile||'" >'
        call lineout tempfile,'<tt><u>'||apolfile||'</u></tt></td>'
     end

     when atype1="S" then do
        parse upper var selects . (avar1) . '=' aselfile ';' . ; aselfile=strip(aselfile)
        call lineout tempfile,'<td><input '
        ssname='_SELECT_'||avar1 ; asq="'"
        call lineout tempfile,' type="text" size=15 name="'||ssname||'" '
        call lineout tempfile,' onClick=" document.doredo.hoist.value='||asq||avar1||asq||'  ;the_select='||asq||ssname||asq||'" ' 
        call lineout tempfile,' value="'||aselfile||'"> </tt></td>'
     end 
     otherwise do
        call lineout tempfile,'<td><tt>n.a.</tt></td>'
     end
     end
   
end 

call lineout tempfile,'</table>'

/* new variables */


call lineout tempfile,'<p><table border=1>'
call lineout tempfile,'<tr><th>Owners</th>'
msize=min(max(55,length(stuff.!OWNERS)+10),70)
call lineout tempfile,'<td><input type="text" name="OWNERS" '||,
                      ' value="'||stuff.!OWNERS||'" size='||msize||'></td>'

call lineout tempfile,'<tr><th>Owners-Comment</th>'
msize=min(max(55,length(stuff.!OWNERSCOMMENT)+10),70)
call lineout tempfile,'<td><input type="text" name="OWNERSCOMMENT" '||,
                      ' value="'||stuff.!OWNERSCOMMENT||'" size='||msize||'></td>'
call lineout tempfile,'</table>'

call lineout tempfile,'<p><table border=1>'
if gotabs=0 then do
   call lineout tempfile,'<tr><td colspan=2> <input type="checkbox" name="ADD_ABSTRACT" value=1>Add an <b>Abstract</b> '
end 

call lineout tempfile,'<p><tr><td bgcolor="#ccccdd"><em>Add a new <br>variable...</em></td>'
call lineout tempfile,'<td>'
call lineout tempfile,'<table cellpadding=3 border=1>'
call lineout tempfile,'<tr><th>Name</th><th>Type</th><th>Storage</th><th>Select/Poll<br>file</th>'
call lineout tempfile,'<tr><td><input type="text" size=20 name="NEW_NAME"></td>'
call lineout tempfile,''

tlist='1NTMCFSP'
call lineout tempfile,'<td><Select name="NEW_TYPE" size=1>'
do jj=1 to length(tlist)
   al1=substr(tlist,jj,1)
   vl1='!'||al1
   call lineout tempfile,'<option value="'||al1||'">'||typenames.vl1
end 
call lineout tempfile,'</Select></td>'


call lineout tempfile,'<td><select name="NEW_PACK"  size=1>'
call lineout tempfile,'<option value="0">Sortable'
call lineout tempfile,'<option value="1">Packed'
call lineout tempfile,'</select>  </td>  '

call lineout tempfile,'<td><input type="text"  onClick="document.doredo.hoist.value=''New variable'';the_select=''NEW_SELECT''" name="NEW_SELECT"  size=16></td>'


call lineout tempfile,'</table>'
call lineout tempfile,'</td>'
call lineout tempfile,'</table>'
call lineout tempfile,'<font size=-1><em>The <b>Select file</b> field is only required '
call lineout tempfile,'for <tt>Select list</tt> &amp; <tt>Poll</tt> variables (choose from one of'
call lineout tempfile,'the Select-List or Poll-Definition files listed below)</em> </font>'

call lineout tempfile,'<p><input type="submit" value="Restructure dataseries">'
call lineout tempfile,'<input type="reset" >'

call lineout tempfile,'<p>'

/* now, find all .OPT files in the LIB subdirectory */
  oo=sysfiletree(cmsdir_lib||'\*.OPT','ofiles','FO')
  if ofiles.0=0 then do
    call lineout tempfile,'There are <b>no</b> options files (.OPT files) currently available in '||cmsdir_lib||'</b>'
  end
  else do
     call lineout tempfile,'<dl><dt><b>List of available Select-List files</b> for '
     call lineout tempfile,' <input name="hoist" type="text" size="15" value="New variable">'

     call lineout tempfile,'<dd><table border=1>'
     ipoop=0
     do j1=1 to ofiles.0
        ofiles.j1=filespec('n',ofiles.j1)
        parse var ofiles.j1 ofiles.j1 '.' .
        ipoop=ipoop+1
        if ipoop=1 then call lineout tempfile,'<tr>'
        if ipoop=5 then ipoop=0
        asq="'"
        call lineout tempfile,'<td> <a href="" onClick="putit('||asq||ofiles.j1||asq||'); return false;">'
        call lineout tempfile,ofiles.j1||'</a></td>'
     end 
     call lineout tempfile,'</table>'
     call lineout tempfile,'<em>Select one of these files, and it will be pasted into the most recently clicked <tt>select-file</tt> field </em> '
     call lineout tempfile,'</dl>'
  end



/* now, find all .POL files in the LIB\pol subdirectory */
  oo=sysfiletree(cmsdir_pol||'\*.POL','ofiles','FO')
  oo=sysfiletree(stuff.!filedir||'\POLLS\*.POL','ofiles'2,'FO')

  if ofiles.0+ofiles2.0=0 then do
    call lineout tempfile,'There are <b>no</b> poll-definition files (.POL files) currently available in '||cmsdir_pol' &amp; '||stuff.!filedir||'\POLLS </b>'
  end
  else do
     call lineout tempfile,'<dl><dt><b>List of available poll-definition files</b> <tt>New variable</tt> '

     call lineout tempfile,'<dd><table border=1>'
     ipoop=0
     do j1=1 to ofiles.0
        ofiles.j1=filespec('n',ofiles.j1)
        parse var ofiles.j1 ofiles.j1 '.' .
        ipoop=ipoop+1
        if ipoop=1 then call lineout tempfile,'<tr>'
        if ipoop=5 then ipoop=0
        asq="'"
        call lineout tempfile,'<td> <a href="" onClick="putit2('||asq||ofiles.j1||asq||'); return false;">'
        call lineout tempfile,ofiles.j1||'</a></td>'
     end 
     if ofiles2.0>0 then call lineout tempfile,'<tr><td colspan=2><em>in '||stuff.!filedir||'&nbsp; </em></td>'
     ipoop=0
     do j1=1 to ofiles2.0
        ofiles2.j1=filespec('n',ofiles2.j1)
        parse var ofiles2.j1 ofiles2.j1 '.' .
        ipoop=ipoop+1
        if ipoop=1 then call lineout tempfile,'<tr>'
        if ipoop=5 then ipoop=0
        asq="'"
        call lineout tempfile,'<td> <a href="" onClick="putit2('||asq||'~'||ofiles2.j1||asq||'); return false;">'
        call lineout tempfile,ofiles2.j1||'</a></td>'
     end 
    call lineout tempfile,'<tr><td colspan=2><em>or ...</em></td>'
    call lineout tempfile,'<tr><td colspan=3>'
    call lineout tempfile,'<a href="" onClick="putit2('||asq||'*'||asq||'); return false;">'
    call lineout tempfile,'observation-specific</a></td>'

     call lineout tempfile,'</table>'
     call lineout tempfile,'<em>Select one of these files, and it will be pasted into the most recently clicked <tt>select/poll -file</tt> field </em> '
     call lineout tempfile,'</dl>'
  end




call lineout tempfile,'</form>'


gooble:         /* jump here on error */

a=sre_cache_data(stuff.!series,'CLOSE',stuff.!file)

call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode


/**********************************************************************/
/* show the choices */
step3:

call lineout tempfile,'<html><head><title>CMS: Restructure a dataseries (step 2)</title> '
call lineout tempfile,'<script language="javascript">'


call lineout tempfile,'</head>'
call lineout tempfile,'<font size=-1>'
call lineout tempfile,'<a href="'||mainaddon||'?action=1">Another CMS action</a> ||'
call lineout tempfile,'<a href="javascript:close()">Close window</a> '

call lineout tempfile,'</font><br>'

call lineout tempfile,'<h3>Restructure a CMS dataseries: new structure</h3> '

daindx=optname.!deffile
ff=cmsdir_index||'\'||daindx
goo=stream(ff,'c','query exists')
if goo='' then do
   call lineout tempfile,'Error: could not find index file: '||ff
   signal gooble
end

call read_deffile ff
/* check for access rights */
rcode=check_access(stuff.!OWNERS,stuff.!SERIES)
if rcode<>1 then return rcode

old_defname=ff
old_Filename=stuff.!file
if pos('.',old_Filename)=0 then old_Filename=old_Filename||'.SDS'

/* overwrite? */
new_series=strip(translate(optname.!series))
new_Desc=strip(optname.!desc)

old_series=strip(translate(stuff.!series))
if new_series='' then new_series=old_series

if new_series=old_series then do
   new_filename=sre_tempfile()   /* totally temporary file */
   new_defname=ff
   use_filename=old_filename
end 
else do
   tt0=old_filename
   udir=filespec('d',tt0)||filespec('p',tt0)
   tt=filespec('n',tt0)
   ii=lastpos('.',tt)
   if ii=0 then ii=length(tt)+1
   basename=left(tt,ii-1)
   if right(basename,1)='_' then do 
        is1=lastpos('_',basename,length(basename)-1)
        if is1=0 then is1=length(basename)
        basename=left(basename,is1-1)
   end 
   arf=sre_tempfile(basename||'_??_.SDS',,udir)
   if arf='' then 
      arf=sre_tempfile(basename||'_?????_.SDS',,udir)
   if arf='' then do
      call lineout tempfile,'Sorry, unable to create new file (too many files based on 'tt0')'
      signal gooble
   end 
   new_filename=arf
   use_filename=new_filename

   udir=filespec('d',ff)||filespec('p',ff)  /* get new name for .def file */
   tt=filespec('n',ff)
   ii=lastpos('.',tt)
   if ii=0 then ii=length(tt)+1
   basename=left(tt,ii-1)
   if right(basename,1)='_' then do 
        is1=lastpos('_',basename,length(basename)-1)
        if is1=0 then is1=length(basename)
        basename=left(basename,is1-1)
   end 
   arf=sre_tempfile(basename||'_??_.DEF',,udir)
   if arf='' then 
      arf=sre_tempfile(basename||'_?????_.DEF',,udir)
   if arf='' then do
      call lineout tempfile,'Sorry, unable to create new .DEF file (too many files based on 'ff')'
      signal gooble
   end 
   new_defname=arf
end

/* -- call lineout tempfile,'<ul>'
do until optname.0=''
   parse var optname.0 avv optname.0
   vv='!!'||strip(avv)
  call lineout tempfile,'<li>'avv '=' optname.vv
end
call lineout tempfile,'</ul>' --  */

/* working copy of various variables */
tvars=translate(stuff.!varnames)
ttypes=translate(stuff.!vartypes)
tspecials=translate(stuff.!specials)

removes=translate(optname.!!REMOVE)

/* start with $STATUS, which is always kept */
newvars='$STATUS '
newtypes='1 '
newspecials='$STATUS '
newpack=' '
nuselect=''
nupoll=''
myfiledir=strip(stuff.!FILEDIR)

/* what about abstract? */
if wordpos('$ABSTRACT',tvars)>0 then do /* got it, keep it? */
   if wordpos('$ABSTRACT',removes)>0  then do  /* nope, don't keep it */
      nop
   end
   else do              /* yep, keep it */
        newvars=newvars||' $ABSTRACT '
        newtypes=newtypes||' A '
        newspecials=newspecials||' $ABSTRACT '
   end
end 
else do                 /* no abstract currently, add one ? */
   if optname.!ADD_ABSTRACT=1 then do
        newvars=newvars||' $ABSTRACT '
        newtypes=newtypes||' A '
        newspecials=newspecials||' $ABSTRACT '
   end
end 

/* might need for checking select-file types */
oo=sysfiletree(cmsdir_lib||'\*.OPT','ofiles','FO')
ofiles_index.=''
do jj=1 to ofiles.0
   ttf=strip(translate(filespec('n',ofiles.jj)))
   parse var ttf ttf1 '.' .
   vttf1='!'||ttf1
   ofiles_index.vttf1=1
end

/*---- not really necessary ...
oo=sysfiletree(cmsdir_pol||'\*.POL','ofiles','FO')
pofiles_index.=''
tt='!*' ; pofiles_index.tt=1
do jj=1 to ofiles.0
   ttf=strip(translate(filespec('n',ofiles.jj)))
   parse var ttf ttf1 '.' .
   vttf1='!'||ttf1
   pofiles_index.vttf1=1
end

oo=sysfiletree(myfiledir||'\POLLS\*.POL','ofiles2','FO')
do jj=1 to ofiles2.0
   ttf=strip(translate(filespec('n',ofiles2.jj)))
   parse var ttf ttf1 '.' .
   vttf1='!~'||ttf1
   pofiles_index.vttf1=1
end
----  *****/

/* check on specs for new var */
newname1=''
new_poll_var=''
if optname.!NEW_NAME<>'' then do
   newname1=strip(translate(optname.!new_name))
   if length(newname1)>25 then do
      call lineout tempfile,'<B>Error:</b> new variable name too long: 'newname1
      signal gooble
   end
   if words(newname1)>1 then do
      call lineout tempfile,'<B>Error:</b> new variable contains spaces: 'newname1
      signal gooble
   end
   if wordpos(newname1,tvars)>0 then do
      call lineout tempfile,'<B>Error:</b> new variable name already in use: 'newname1
      signal gooble
   end 

   newtype1=strip(translate(optname.!NEW_TYPE))
   if wordpos(newtype1,'1 N T M C F S P')=0 then do
      call lineout tempfile,'<B>Error:</b> bad variable type: 'newtype1
      signal gooble
   end 

   if newtype1='S' then do
      newselectfile=strip(Translate(optname.!NEW_SELECT))
      if newselectfile='' then do  
         call lineout tempfile,'<B>Error:</b> Select-List variable chosen, but no select-file chosen: 'newname1
         signal gooble
      end
      vv='!'||newselectfile
      if ofiles_index.vv<>1 then do
         call lineout tempfile,'<B>Error:</b> no such select-file: 'newselectfile
         signal gooble
      end
      nuselect=nuselect||newname1||'='||newselectfile||'; '
   end 

   if newtype1='P' then do
      newpollfile=strip(Translate(optname.!NEW_SELECT))
      if newpollfile='' then do  
         call lineout tempfile,'<B>Error:</b> A poll variable chosen, but no poll-definition file selected: 'newname1
         signal gooble
      end

      poll_line=''              /* this is used for obs-specific poll files (*) */
      if newpollfile<>'*'  then do
        if abbrev(newpollfile,'~')=1 then do
           nn=substr(newpollfile,2)
           oo=stream(myfiledir||'\POLLS\'||nn||'.POL','c','query exists')
        end
        else do
           oo=stream(cmsdir_pol||'\'||newpollfile||'.POL','c','query exists')
        end
        if oo=''  then do
           call lineout tempfile,'<B>Error:</b> for '||newname1||', there is no such poll-definition file: 'newpollfile
           signal gooble
        end
        poll_line=get_poll_line(oo,newpollfile)    /* get a stub line to use for this new poll variable */
      end
      new_poll_var=newname1             /* a shortcut used below */
      nupoll=nupoll||newname1||'='||newpollfile||'; '
   end 


   newpack1=strip(optname.!new_pack)
   if wordpos(newpack1,'0 1')=0 then newpack1=0
   call lineout tempfile,'<Br>Adding new variable:<tt> '||newname1||'</tt>'
end

/* make list of retained variables */
do mm=1 to words(tvars)

   oldvar=strip(word(tvars,mm))

   if oldvar='$STATUS' | oldvar='$ABSTRACT' then iterate  /* dealt with above */

   if wordpos(oldvar,removes)>0 then do
       call lineout tempfile,'<br>Removing old variable:<tt>'oldvar||'</tt>'
       iterate
   end

/* else, retain this variable */
   newvars=newvars||' '||oldvar

   vv='!_TYPE_'||oldvar
   ttype=strip(translate(optname.vv))
   if wordpos(ttype,'1 N T M C F S P ')=0 then do
      call lineout tempfile,'<B>Error:</b> a bad variable type 'ttype' for ' oldvar
      signal gooble
   end 
   newtypes=newtypes||' '||ttype

   if ttype='S' then do
      dov1='!_SELECT_'||oldvar
      dosf=strip(Translate(optname.dov1))
      if dosf='' then do  
         call lineout tempfile,'<B>Error:</b> Select-List variable chosen, but no select-file chosen: 'oldvar
         signal gooble
      end
      vv='!'||dosf
      if ofiles_index.vv<>1 then do
         call lineout tempfile,'<B>Error:</b> there is no such select-file: 'dosf
         signal gooble
      end
      nuselect=nuselect||' '||oldvar||'='||dosf||'; '
   end 

   if ttype='P' then do
      dov1='!_POLL_'||oldvar
      dosf=strip(Translate(optname.dov1))
      if dosf='' then do  
         call lineout tempfile,'<B>Error:</b> An old poll variable ('||oldvar||') has but no poll-definition file chosen: 'oldvar
         signal gooble
      end
      if dosf<>'*' then do
        if abbrev(dosf,'~')=1 then do
           nn=substr(dosf,2)
           oo=stream(myfiledir||'\POLLS\'||nn||'.POL','c','query exists')
        end
        else do
           oo=stream(cmsdir_pol||'\'||dosf||'.POL','c','query exists')
        end
        if dosf='' then do
         call lineout tempfile,'<B>Error:</b> for '||oldvar||' there is no such poll-definition file: 'dosf
         signal gooble
       end
     end                        /* don't check for obs-specific .pol files */
     nupoll=nupoll||' '||oldvar||'='||dosf||'; '
   end 


   vv='!_PACK_'||oldvar
   if optname.vv=1 then         /* 1 means "pack it" */
       newpack=newpack||' '||oldvar
   else
       newspecials=newspecials||' '||oldvar

end 
if newname1<>'' then do
    newvars=newvars||' '||newname1
    newtypes=newtypes||' '||newtype1
    if newpack1=0 then
       newspecials=newspecials||' '||newname1
    else
       newpack=newpack||' '||newname1
end 


/* too many specials? */
if words(newspecials)>7 then do
   call lineout tempfile,'<br>Error. You have too many <em>sortable</em> variables. Change one of them to <tt>packed</tt>.'
   signal gooble
end /* do */


call lineout tempfile,'<p><table>'

call lineout tempfile,'<TR><td bgcolor="#aaaaaa">Old series:<br><tt>'stuff.!series||'</tt></td>'

call lineout tempfile,'<td><ul type="circle">'
call lineout tempfile,'<li>Filename: '||old_filename
call lineout tempfile,'<li>VARNAMES: '||stuff.!varnames
call lineout tempfile,'<li>VARtypes: '||stuff.!vartypes
call lineout tempfile,'<li>Sortables: '||stuff.!specials
call lineout tempfile,'<li>Pack: '||stuff.!pack
call lineout tempfile,'</ul>'
call lineout tempfile,'</td>'


call lineout tempfile,'<TR><td  bgcolor="#cacaca">'
if new_series<>old_series then 
  call lineout tempfile,'New series:<br><tt>'optname.!series||'</tt></td>'
else
  call lineout tempfile,'overwrite:<br>with</tt></td>'


call lineout tempfile,'<td><ul type="square">'
call lineout tempfile,'<li>Filename: '||new_filename
call lineout tempfile,'<li>VARNAMES: '||newvars
call lineout tempfile,'<li>VARtypes: '||newtypes
call lineout tempfile,'<li>Sortables: '||newspecials
call lineout tempfile,'<li>Pack: '||newpack
call lineout tempfile,'</ul>'
call lineout tempfile,'</td>'
call lineout tempfile,'</table> <p>'


/* recreate .def file using the selections of the client */
newfile='; CMS index file modified on '||time('n')||' '||date('n')||'0d0a'x

didpoll=0; didselect=0

do ii=1 to stuff.!lines.0
   aline=stuff.!lines.ii
   if aline='' then do
        newfile=newfile||aline||'0d0a'x
        iterate
   end
   aline2=translate(strip(aline))
   if abbrev(aline2,';')=1 then do
        newfile=newfile||aline||'0d0a'x
        iterate
   end

   parse var aline2 avar ':' avalue ; avar=strip(translate(avar))
/* if here, do something with it */
   select 
     when avar='SERIES' then do                /* remove/add variables */
        newfile=newfile||'Series: '||new_series||'0d0a'x
     end 
     when avar='DESC' then do                /* remove/add variables */
        newfile=newfile||'Desc: '||new_desc||'0d0a'x
     end 
     when avar='FILE' then do                /* remove/add variables */
        newfile=newfile||'File: '||use_filename||'0d0a'x
     end 

     when avar='OWNERS' then do
        newfile=newfile||'Owners: '||optname.!OWNERS||'0d0a'x
     end 
     when avar='OWNERSCCOMMENT' then do
        newfile=newfile||'OwnersComment: '||optname.!OWNERSCOMMENT||'0d0a'x
     end 
     when avar='VARNAMES' then do                /* remove/add variables */
        newfile=newfile||'Varnames: '||newvars||'0d0a'x
     end 
     when avar='VARTYPES' then do                /* remove/add variables */
        newfile=newfile||'Vartypes: '||newtypes||'0d0a'x
     end 
     when avar='PACK' then do                /* remove/add variables */
        newfile=newfile||'Pack: '||newpack||'0d0a'x
     end 
     when avar='SPECIALS' then do                /* remove/add variables */
        newfile=newfile||'Specials: '||newspecials||'0d0a'x
     end 
     when avar='SELECT' then do                /* remove/add variables */
        didselect=1
        newfile=newfile||'Select: '||nuselect||'0d0a'x
     end 
     when avar='POLL' then do                /* remove/add variables */
        didpoll=1
        newfile=newfile||'Poll: '||nupoll||'0d0a'x
     end 

     otherwise do               /* otherwise, retain it */
       if aline<>"" then   newfile=newfile||aline||'0d0a'x
     end
   end  /* select */
end
if didpoll=0 then newfile=newfile||'Poll: '||nupoll||'0d0a'x
if didselect=0 then newfile||'Select: '||nuselect||'0d0a'x

call lineout tempfile,'<table cellpadding=2><tr><th>New .DEF<br> file</td><td><pre>'newfile'</pre></td></table>'


/*  =============== Now do the actual writing -- */

/* 1 - create new dataseries file */

nuseries=stuff.!series
vstore='VALS VALINDEX '||newspecials
a=sre_cache_data(nuseries,'DEFINE',new_filename,vstore,stuff.!desc,'Restructuring of '||old_Filename)
if a<>0 then do
  amess=sre_cache_data('DEFINE','ERROR',a,new_filename)
  call lineout tempfile,'<b>Error</b>: '||amess||crlf
  signal gooble
end

/* create a !STATUS and !INFORM record */
nuseries='_TMP_'
a=sre_cache_data(nuseries,'OPEN',new_filename)
if a>0 then do
   amess=sre_cache_data('OPEN','ERROR',a,new_filename)
   call lineout tempfile,'<b>Error:</b> '||amess
   signal gooble
end

poo=sre_cache_data(nuseries,'ADD WRITE ID7','_INFORM ', ,
   'Varnames='||newvars||,
   ' ; VarTypes='||newtypes||,
   ' ; SORTABLE='||newspecials||,
   ' ; SELECT='nuselect||,
   ' ; POLL='nupoll)
poo=sre_cache_data(nuseries,'ADD WRITE ID7','_LOOKUP',space(' ',70,' '))
poo=sre_cache_data(nuseries,'ADD WRITE ID7','_STATUS','                 ')


/* 1b) info on old file */

a=sre_cache_data(stuff.!series,'OPEN  INDEX',stuff.!file)
if a>0 then do
   amess=sre_cache_data('OPEN','ERROR',a,stuff.!file)
   call lineout tempfile,'<b>Error opening old database:</b> '||amess
   signal gooble
end

a=sre_cache_data(stuff.!series,'INFO',,' RECORDS VARS')
parse var a astat a ; astat=strip(astat)
if astat<>'0' then do
   amess=sre_cache_data('INFO','ERROR',astat)
   call lineout tempfile,'<b>Error retrieving old info:</b> '||amess
   signal gooble
end
parse var a . '0d0a'x . '09'x  nrecords0 '09'x  varlist0

/* a useful index */
vlist.=''
vlist.0=words(stuff.!varnames)
do mm=1 to vlist.0
  avar=translate(strip(word(stuff.!varnames,mm)))
  vvar='!'||avar
  vlist.mm=vvar
  atype=translate(strip(word(stuff.!vartypes,mm)))
  vlist.vvar.!type=atype                /* empty means "no such old variable */
end

/* a 2nd useful index */
nuvlist.=''
nuvlist.0=words(newvars)
do mm=1 to vlist.0
  avar=translate(strip(word(newvars,mm)))
  vvar='!'||avar
  nuvlist.mm=vvar
  atype=translate(strip(word(newtypes,mm)))
  nuvlist.vvar.!type=atype              
end


/* 2) start loop of read from old file, write to new */
ierrs=0 ; ioks=0
call lineout tempfile,'<ul>'
do iold=1 to nrecords0


  arec=sre_cache_data(stuff.!series,'EXTRACT ',iold)
  if abbrev(arec,0)=0 then do              /* error reading */
       parse var arec astat .
       amess=sre_cache_data('EXTRACT','ERROR',astat)
       call lineout tempfile,'<li>Error reading record 'iold ' from old dataseries file: 'amess
       call lineout tempfile,'</ul>'
       signal gooble
  end 

  parse var arec . '0d0a'x id7 ',' id '09'x cvals '09'x cindex '09'x astatus '09'x svals
  if id7=id then iterate        /* skip meta records*/
  if pos('**',id7)>0 then iterate

  sp.=''
  call lineout tempfile,'<li>'

  call unpack_rec             /* get values */

/* now do all the pack variables */
   nucval='' ; nucindex=''
   do jj=1 to words(newpack)
      avar=strip(word(newpack,jj))
      vvar='!'||avar
      aval=vs.vvar              /* will be '' if no such old variable */
      oldtype=vlist.vvar.!TYPE  /* if '', no such old variable */
      nutype=nuvlist.vvar.!TYPE  
      if oldtype='F' & nutype<>'F' then do      /* was file type, now 1 or M -- read it in! */
        aval=read_file(aval)
      end
      if nutype='M' & aval<>'' then aval=sre_pack64_make(aval)
      if nutype<>'M' then aval=translate(aval,' ','0d0a09'x)
      nucval=nucval||aval
      nucindex=nucindex||' '||length(aval)
   end
   sp.1=nucval
   sp.2=strip(nucindex)||' '

/* status, and abstract */
   newvs.=''
   tv1='!$STATUS'
   sp.3=vs.tv1             /* no change in status */
   isp=3
   if wordpos('$ABSTRACT',newvars)>0 then do
       tv1='!$ABSTRACT'
       sp.4=vs.tv1   /* might be '' if no prior abstract value */
       isp=4
   end

/* and other sortable (special) variables */
   do jj=1 to words(newspecials)
      avar=strip(word(newspecials,jj))
      if avar='$STATUS' | avar='$ABSTRACT' then iterate
      vvar='!'||avar
      aval=vs.vvar              /* will be '' if no such old variable */
      oldtype=vlist.vvar.!TYPE  /* if '', no such old variable */
      nutype=nuvlist.vvar.!TYPE  
      if oldtype='F' & nutype<>'F' then do      /* was file type, now 1 or M -- read it in! */
        aval=read_file(aval)
      end

/* check for new poll var. If so, add a basic (0 0 0 ...: sfile, question:)
   line (rather then a blank line) */
      if avar=new_poll_var then aval=poll_line  /*kind of a hack */
      
      if nutype='M' & aval<>'' then aval=sre_pack64_make(aval)
      if nutype<>'M' then aval=translate(aval,' ','0d0a09'x)
      isp=isp+1
      sp.isp=aval
   end  

  totlen=0
  do ij=1 to 10
     totlen=totlen+length(sp.ij)
  end 
  if totlen>max_record_size then do
     call lineout tempfile,'Error: record 'id' not written (record size is <tt>'||totlen||'</tt>, max  is '||max_record_size||')'
     signal gooble
  end
  
   poo=sre_cache_data(nuseries,'ADD WRITE',id,,
              sp.1,sp.2,sp.3,sp.4,sp.5,sp.6,sp.7,sp.8,sp.9,sp.10)
   if length(poo)=1 then do
      amess=sre_cache_data('ADD','ERROR',poo)
      call lineout tempfile,'<br>Unable to add record 'id': 'amess)
      ierrs=ierrs+1
   end   
   else do
      call lineout tempfile,' Record added: 'id
      ioks=ioks+1
   end 

end             /* get next record */

call lineout tempfile,'</ul>'

call lineout tempfile,'<h4>Done writing records</h4>'
call lineout tempfile,'<table><tr><td>Records added:</td><td><tt>'||ioks||'</tt></td>'
call lineout tempfile,'<tr><td>Records unable to add:</td><td><tt>'||ierrs||'</tt></td>'
call lineout tempfile,'</table><p>'

a=sre_cache_data(nuseries,'CLOSE')
a=sre_cache_data(stuff.!series,'CLOSE')

/* now try copying files */
errs.='unspecified error '
errs.2 =' source file not found '
errs.3 =' source or target path not found '
errs.5 =' target file exists but  A  or  R  mode not specified '
errs.32 =' sharing violation for source or target file '
errs.108 =' source or target drive locked '
errs.112 =' disk full '
errs.206 =' invalid source or target file name '
errs.267 =' source name is a directory '
errs.282 =' extended attributes not supported for target '

if  old_series<>new_series then do      /* not an overwrite, so just save new .DEF file */
  call lineout tempfile,'<br>Records file stored as '||new_filename
  call lineout tempfile,'<br>Creating new .DEF file:<tt>'||new_defname||'</tt>'
  foo=sre_append_file(new_defname,newfile,1,,1)
      select 
      when foo='-1' then do
       call lineout tempfile,' Could not open .DEF file '
      end
      when foo='-2' then  do
       call lineout tempfile, 'Error. Problem writing to .DEF file'
      end
      otherwise do
         call lineout tempfile,' '
      end
      end 
end
else  do                /* might copy temporarily if error */
  if ierrs=0 then do
      call lineout tempfile,'<br>Overwriting records file:<tt>'||old_filename||'</tt>'
      foo2=doscopy(new_filename,old_filename,'R')
      if foo2<>0 then do
         call lineout tempfile,'<br>Error copying records file: '||errs.foo2
         signal gooble2         
      end 
      call lineout tempfile,'<br>Overwriting .DEF file:<tt>'||new_defname||'</tt>'
      foo=sre_append_file(new_defname,newfile,1,,1)
      select 
      when foo='-1' then do
       call lineout tempfile,' Could not open .DEF file '
      end
      when foo='-2' then  do
       call lineout tempfile, 'Error. Problem writing to .DEF file'
      end
      otherwise do
         call lineout tempfile,' '
      end
      end 
  end
  else do
    call lineout tempfile,'<bR>Since errors occurred, overwrite will not take place:'
    call lineout tempfile,'<ul>'
    call lineout tempfile,'<li>Records file stored as '||new_filename
    call lineout tempfile,'<li>.DEF file stored as '||old_defname||'_TMP'
    call lineout tempfile,'</ul>'
    foo=sre_append_file(old_defname||'_TMP',newfile,1,,1)
      select 
      when foo='-1' then do
       call lineout tempfile,' Could not open .DEF file '
      end
      when foo='-2' then  do
       call lineout tempfile, 'Error. Problem writing to .DEF file'
      end
      otherwise do
         call lineout tempfile,' '
      end
      end 

  end
end


signal gooble2


gooble:         /* jump here on error */
a=sre_cache_data(nuseries,'CLOSE')
a=sre_cache_data(stuff.!series,'CLOSE')

gooble2:        /* jump here on non-error */

call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode

/**************/
/* read a poll file, build the poll_line */
get_poll_line:procedure
parse arg dafile,sfile
polstuff=sre_read_file(dafile,2,2,1)
if polstuff='' then return ''              /* bad poll file, give up */
vopts.=''
daques=''
nopts=0 ; noptlist=''
do until polstuff=''
   parse var polstuff aline '0d0a'x polstuff
   aline=strip(aline)
   if aline='' then iterate
   if abbrev(aline,';')=1 then iterate
   parse var aline a1 ':' a2
   a1=strip(translate(a1))
   va1='!'||a1
   if datatype(a1)='NUM' then do
      if wordpos(a1,noptlist)=0 then do
          nopts=nopts+1
          vopts.nopts=a1
          noptlist=noptlist||' '||a1
       end
   end 
   if a1='?' then daques=daques||' '||strip(a2)
end 
zz='0    '
tmp=zz
do jj=1 to nopts
   tmp=tmp||zz
end 
ll=max(20,length(sfile)+1)
tmp=tmp||':'||left(sfile,ll,' ')
tmp=tmp||','||left(daques,50,' ')||':'
return tmp

tmp=






/**************/
/* read a file, return it's value ; get file from F record type */
read_file:procedure expose cmsdir cmsdir_upload tempfile
parse arg vval
parse var vval origname '=' dafile ';' uptype
if abbrev(dafile,'\')=0 & pos(':',dafile)=0 then do     /* relative filename */
      defdir=strip(cmsdir_upload,,'\')||'\' 
      dafile=defdir_up||dafile
end
vval=sre_read_file(dafile,2,,1)
parse var vval astat . '0d0a'x vval ; astat=strip(astat)
if astat<0 then do
  astat=abs(astat)
  errs.1 = 'no such filename'
  errs.2 = 'filename exists, but size was not produced'
  errs.3 = 'unable to open this file, even after trying'
  call lineout tempfile,'<br>Error ('||errs.astat||') reading file: 'dafile
  return ''
end
return vval




/**************/
/* unpack a record to VS. */
unpack_rec:
  vs.=''
  tv1='!$STATUS'
  vs.tv1=astatus

   inrec=1
   do mm2=1 to words(stuff.!pack)           
           blen=strip(word(cindex,mm2))
           avar=translate(strip(word(stuff.!pack,mm2)))
           vvar='!'||avar
           vs.vvar=substr(cvals,inrec,blen)
           if vlist.vvar.!TYPE='M' then vs.vvar=sre_pack64(vs.vvar)
           inrec=inrec+blen
    end
    do k1=1 to words(stuff.!specials)
           avar=translate(strip(word(stuff.!specials,k1)))
           if avar='$STATUS' then iterate
           vvar='!'||avar
           parse var Svals aval '09'x Svals
           vs.vvar=aval
           if vlist.vvar.!TYPE='M' then vs.vvar=sre_pack64(vs.vvar)
    END
return 1

/*************/
/* read a definition file */
read_deffile:
parse arg afile
stuff.=''
stuff=sre_read_file(afile,2,2,1)
ilines=0
do until stuff=''
   parse var stuff aline '0d0a'x stuff ; aline=strip(aline)
   ilines=ilines+1
   stuff.!lines.ilines=aline
   if aline='' then iterate
   if abbrev(aline,';')=1 then iterate
   parse var aline aname ':' avalue
   aname='!'||strip(translate(aname))
   stuff.aname=strip(avalue)
end
stuff.!lines.0=ilines
return 1




/******************************/
/* check access rights. Return 1 if okay. Otherwise, return a string to be
  sent back to SREhttp/2 (an authorization response string) */
check_access:procedure expose privset host_nickname idinfo uri aiter
parse  upper arg owners,series

if owners='' then return 1      /* no owners listed, means open access */

tpr=translate(privset)
pneeded=space(translate('CMS:'||strip(series)),0)
if wordpos(pneeded,tpr)>0 then return 1          /* explicit privilege for this */
if wordpos('SUPERUSER',tpr)>0 then return 1


/* see if a cookie exists */
look_cook='CMS_'||series
aa=sreh2_get_cookie(lookcook)
if aa<>''  then return 1

if aiter=''  then do            /* first time, so recheck privs */
  return 'PRIVS   Access to this dataseries is restricted to specific users '
end 

/* otherwise, see if a username has been sent  */
username=''
authh=sre_reqfield('Authorization')
if authh<>'' then username=sre_extract_username(authh) 
if username='' then do             /* no username available */
  return  'AUTH  Access to this dataseries is restricted to specific users '
end

/* is this one of the OWNERS? */
if pos('*',owners)=0 then do            /* * means "any user" */
if wordpos(translate(username),translate(owners))=0 then do
   return 'AUTH  Access to this dataseries is restricted to specific users '
end
end

/* One of the OWNERS, now check password */
stuff=sreh2_get_userinfo(authh,host_nickname,idinfo)
if stuff='' then do
  return 'AUTH   Access to this dataseries is restricted to specific users. Please enter a new username/password.'
end

parse var uri thisaddon '?' .
jj=lastpos('/',thisaddon)
pp=left(thisaddon,jj)

foo=sreh2_set_cookie(lookcook,1,'30m',pp,,1)

/* if here, legit user.  Record a cookie */
return 1

