/* The SREhttp/2 content management system (CMS) program 

   This module will remove records from a CMS dataseries
  1) first, it will provide a pick list of cms dataseries (for this host)
  2) given the chosen dataseries, it will present a form with fields for each
     variable
  3) it will add the record, using filled in values for the variables, and
     report back


*/

/******** User changeable parameters ***/
/* root directory for the SREhttp/2 CMS addon.
   Leave blank to use default (CMS subdirectory of srehttp/2 addon directory */
cmsdir=''


/******** end of user changeable parameters ***/


parse arg list,servername,verb,tempfile,,
          prog_file,reqnum,verbose,client_ip,privset,,
          uri,host_nickname,idinfo,aiter,attribs,seluse2

crlf='0d0a'x

if verb=" " then do
   say "This SREhttp/2 procedure is not meant to be run in standalone mode "
   exit
end  

addon_dir=sre_value('H2_ADDON_DIR_DEFAULT',,'SRE')
if cmsdir='' then cmsdir=strip(addon_dir,,'\')||'\CMS'
foo=dosisdir(cmsdir)
if foo=0 then return 'String Error:unable to find CMS directory: ('cmsdir

cmsdir_lib=cmsdir||'\LIB'
okk=dosisdir(cmsdir_lib)
if okk=0 then do
  return 'string unable to find CMS index directory: 'cmsdir_lib
end

cmsdir_pol=cmsdir||'\LIB\POL'
okk=dosisdir(cmsdir_pol)
if okk=0 then do
  return 'string unable to find CMS index directory: 'cmsdir_pol
end


cmsdir_data=cmsdir||'\DATA'
okk=dosisdir(cmsdir_data)
if okk=0 then do
  return 'string unable to find CMS data directory: 'cmsdir_data
end

cmsdir_index=cmsdir||'\INDEX'
okk=dosisdir(cmsdir_index)
if okk=0 then do
  return 'string unable to find CMS index directory: 'cmsdir_index
end

parse var uri thisaddon '?' .
jj=lastpos('/',thisaddon)
mainaddon=left(uri,jj)||'cms.cmd'
root=left(uri,jj)

optname.=''
m=0
if list='' then list='action=1'
do until list=""
    parse var list opt1 '&' list
    m=m+1
    parse var opt1 avar '=' aval ; avar=strip(translate(avar)) 
    optname.0=optname.0||' '||avar
    aval=translate(aval,' ', '+')
    aval=sre_packur(aval)
    avar1='!!'avar
    if optname.avar1<>'' then
       optname.avar1=optname.avar1||' '||aval
    else
       optname.avar1=aval
    avar2='!'avar
    aval2=strip(translate(aval,' ','090a0d'x))
    optname.avar2=aval2
end

/***** End of GENERIC CMS addon code *****/

if optname.!action='1' then do   /* find the list of dataseries defined for this host*/
  call show_datafiles
  foo=result
  return foo
end

if optname.!action='2' then do   /* choose a record */
  call ask_record
  foo=result
  return foo
end


if optname.!action='3' then do   /* remove a record */
  call remove_record
  foo=result
  return foo
end

if optname.!action='4' then do   /* display a record's values */
  call show_record
  foo=result
  return foo
end


/*******************/
/* pick one of the current cms datafiles (for this host) */
show_datafiles:

call lineout tempfile,'<html><head><title>CMS: Choose a CMS dataseries</title></head> '


call lineout tempfile,'<font size=-1><a href="'||mainaddon||'?action=1">Another CMS action</a></font><br>'

call lineout tempfile,'<h3>Select a CMS dataseries</h3><em>from which to remove, or view, records  ...</em><p> '

ahost=host_nickname

/* look for files, in cmsDIR_index dir, of the form: ahost_nnnn.DEF
   These .DEF files define "CMS indices" --- nnnn is a number from 0 to 9999
*/

cookie_value=sreh2_get_cookie('CMS') 

call lineout tempfile,'<FORM name="" action="'||thisaddon||'" method="POST">'
call lineout tempfile,'<input type="hidden" name="action" value="2">'
ff=cmsdir_index||'\'||ahost||'*.DEF'
goo=sysfiletree(ff,'ff2','FO')

call lineout tempfile,'For host: <Tt>'||ahost||'</tt>, the following CMS dataseries have been created'

call lineout tempfile,'<table border=1>'
do jj=1 to ff2.0
   daname=filespec('n',ff2.jj)
   call read_deffile ff2.jj
   call lineout tempfile,'<tr><th align="left">' 
   if daname=cookie_value  | (cookie_value='' & jj=1) then
      call lineout tempfile,'<INPUT TYPE="RADIO" checked name="deffile" value="'||daname||'">' 
   else
      call lineout tempfile,'<INPUT TYPE="RADIO"  name="deffile" value="'||daname||'">' 
   gob=strip(stuff.!series)||'</th>'
   call lineout tempfile,gob||'<td> <em>&nbsp;'||stuff.!desc||'</em></td>'
end

call lineout tempfile,'</table>'

call lineout tempfile,''
call lineout tempfile,'<br>'

call lineout tempfile,'<table><tr><td><em>Range of records: </em><br> Display records entered <br>between </td>'
call lineout tempfile,'<td><table><tr><td><input type="text" name="SDAY" value="1">'
call lineout tempfile,' <select name="SMONTH" size=1>'
call lineout tempfile,'   <Option selected value="Jan">Jan '
call lineout tempfile,'   <Option value="Feb">Feb '
call lineout tempfile,'   <Option value="Mar">Mar '
call lineout tempfile,'   <Option value="Apr">Apr '
call lineout tempfile,'   <Option value="May">May '
call lineout tempfile,'   <Option value="Jun">Jun '
call lineout tempfile,'   <Option value="Jul">Jul '
call lineout tempfile,'   <Option value="Aut">Aug '
call lineout tempfile,'   <Option value="Sep">Sep '
call lineout tempfile,'   <Option value="Oct">Oct '
call lineout tempfile,'   <Option value="Nov">Nov '
call lineout tempfile,'   <Option value="Dec">Dec '
call lineout tempfile,'</select>'
call lineout tempfile,'<Input type="text" name="SYEAR" value="2003">'
call lineout tempfile,'</td>'
call lineout tempfile,' <tr><th>and</th>'
call lineout tempfile,'<tr valign="top" ><td>'
call lineout tempfile,'<input type="text" name="EDAY" value="31">'
call lineout tempfile,' <select name="EMONTH" size=1>' 
call lineout tempfile,'   <Option selected value="Jan">Jan '
call lineout tempfile,'   <Option value="Feb">Feb '
call lineout tempfile,'   <Option value="Mar">Mar '
call lineout tempfile,'   <Option value="Apr">Apr '
call lineout tempfile,'   <Option value="May">May '
call lineout tempfile,'   <Option value="Jun">Jun '
call lineout tempfile,'   <Option value="Jul">Jul '
call lineout tempfile,'   <Option value="Aut">Aug '
call lineout tempfile,'   <Option value="Sep">Sep '
call lineout tempfile,'   <Option value="Oct">Oct '
call lineout tempfile,'   <Option value="Nov">Nov '
call lineout tempfile,'   <Option selected value="Dec">Dec '
call lineout tempfile,'</select>'
call lineout tempfile,'<Input type="text" name="EYEAR" value="2004">'
call lineout tempfile,'</td></table>'
call lineout tempfile,'</td></table>'

call lineout tempfile,'<p><INPUT name="sub2" TYPE="submit" VALUE="Choose a CMS dataseries">'
call lineout tempfile,'<INPUT type="reset">'

call lineout tempfile,'</form>'
call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode


/*******************/
/* pick a record to remove */
ask_record:

call lineout tempfile,'<html><head><title>CMS: Choose record to remove</title></head> '
call lineout tempfile,'<script language="javascript">'
call lineout tempfile,'nrem=0 ;'

call lineout tempfile,'function set_submit(bonew) {'
call lineout tempfile,'if (bonew)'
call lineout tempfile,' { nrem=nrem+1} '
call lineout tempfile,'else { nrem=nrem-1} ;'
call lineout tempfile,' nrem=Math.max(nrem,0);'
call lineout tempfile,' document.doremove.sub2.value="Remove " + nrem + " records" ;'
call lineout tempfile,'}'
call lineout tempfile,'</script>'


call lineout tempfile,'</head>'
call lineout tempfile,'<font size=-1>'
if optname.!CLOSEIT=1 then 
   call lineout tempfile,'<a href="javascript:close()">Close window</a> || '
call lineout tempfile,'<a href="'||mainaddon||'?action=1">Another CMS action</a>'
call lineout tempfile,'</font><br>'

call lineout tempfile,'<h3>Remove record from a CMS dataseries</h3> '

daindx=optname.!deffile
ff=cmsdir_index||'\'||daindx
goo=stream(ff,'c','query exists')
if goo='' then do
   call lineout tempfile,'Error: could not find index file: '||ff
   signal gooble
end

call read_deffile ff

/* check for access rights */
rcode=check_access(stuff.!OWNERS,stuff.!SERIES)
if rcode<>1 then return rcode
got_abs=wordpos('$ABSTRACT',translate(stuff.!SPECIALS))

a=sre_cache_data(stuff.!series,'OPEN  INDEX',stuff.!file)
if a>0 then do
   amess=sre_cache_data('OPEN','ERROR',a,stuff.!file)
   call lineout tempfile,'<b>Error:</b> '||amess
   signal gooble
end

a=sre_cache_data(stuff.!series,'INFO',,'MODIFIED RECORDS VARS DESCRIPTION')
parse var a astat a ; astat=strip(astat)
if astat<>'0' then do
    amess=sre_cache_data('INFO','ERROR',astat)
   call lineout tempfile,'<b>Error retrieving info:</b> '||amess
   signal gooble
end

parse var a . '0d0a'x . '09'x modified  '=' . '09'x nrecords0 '09'x  vlist_sre '09'x  desc
nrecords=nrecords0-4

astat=sreh2_set_cookie('CMS',daindx,1,root,,1) 

call lineout tempfile,'<FORM name="doremove" action="'||thisaddon||'" method="POST">'
call lineout tempfile,'<input type="hidden" name="action" value="3">'
call lineout tempfile,'<input type="hidden" name="deffile" value="'||daindx||'">'

call lineout tempfile,'<em>For the CMS dataseries: </eM><b>'||stuff.!series||'</b><br>'
call lineout tempfile,'<table>'
call lineout tempfile,'<tr><th align="left">Last modified:</th><td>'||modified||'</td>'
call lineout tempfile,'<tr><th align="left"># of records currently in dataseries:</th><td>'||nrecords||'</td>'
call lineout tempfile,'<tr><th align="left">Description:</th><td>'||desc||'</td>'
call lineout tempfile,'</table>'
call lineout tempfile,'<p>Select records to remove, or <u>click on record id</u> to view a record''s contents<p>'

gaa='ABSTRACT=$STATUS '
if got_abs>0 then gaa='ABSTRACT=$ABSTRACT&$STATUS '

a=sre_cache_data(stuff.!series,'EXTRACT ID7 ID '||gaa,"1-"||nrecords0)

parse var a astat ndo '0d0a'x a
if astat<>0 then do
     amess=sre_cache_data('EXTRACT','ERROR',astat,"1-"||nrecords0)
     call lineout tempfile,'<b>Error retrieving info:</b> '||amess
     signal gooble
end

/* determine range */
s1=optname.!sday||' '||optname.!Smonth||' '||optname.!SYEAR
e1=optname.!eday||' '||optname.!emonth||' '||optname.!eYEAR

foo=dateconv(s1,'n','b')
if foo='' then 
 s2=0             /* error, no lower limit */
else
  s2=foo-726467

foo=dateconv(e1,'n','b')
if foo='' then 
 e2=1111110             /* error, no upper limit */
else
  e2=foo-726467

call lineout tempfile,'<em>Display records entered between '||s1||' and '||e1||'</em><br>'
call lineout tempfile,'<ol type="i">'

ndo_real=0
nall=0
do nn=1 to ndo

   if got_abs>0 then
      parse var a id7 id '09'x abstract '09'x astatus '0d0a'x a
   else
      parse var a id7 id  '09'x astatus  '0d0a'x a

   if datatype(id)<>'NUM' then iterate

   if pos('*',id7)>0 then iterate                /* skip this */
   if id7=id then iterate               /* CMS meta data */

   if datatype(id)<>'NUM' then do 
      call lineout tempfile,'<li><input  onChange="set_submit(this.checked)" '
      call lineout tempfile,'            type="checkbox" name="remove" value="'||id7||'">'
      call lineout tempfile,'<em>Contaminated record...</em><u>'||id7||'</u>'
      nall=nall+1
      iterate
   end 

   nall=nall+1
   nid=trunc(id)
   if nid<s2 | nid>e2 then do
     iterate
   end
   ndo_real=ndo_real+1

   parse var astatus . 'CMT_CNT=' ncomments . ; if datatype(ncomments)<>'NUM' then ncomments=0

     call lineout tempfile,''
     call lineout tempfile,'<li><input  onChange="set_submit(this.checked)" '
     call lineout tempfile,'            type="checkbox" name="remove" value="'||id7||'">'
     call lineout tempfile,'<a target="val"'
     call lineout tempfile,' href="'thisaddon||'?action=4&deffile='||daindx||'&id='||id7||'">'||id||'</a>'
     if ncomments>0 then  call lineout tempfile,'<tt> ['||ncomments||' comments] </tt>'
     if got_abs>0 then call lineout tempfile,' <em>'||abstract||'</em>'

 
end 
call lineout tempfile,'</ol>'


call lineout tempfile,'<input name="sub2" type="submit" value="No records to remove ">'
call lineout tempfile,'<input name="sub3" type="Reset" onClick="nrem=0; document.doremove.sub2.value=''No records to remove'' ">'

call lineout tempfile,'</form>'

call lineout tempfile,'<br>Note: displaying <tt>'ndo_real'</tt> of <tt>'nall'</tt> total records.'

gooble:         /* jump here on error */
a=sre_cache_data(stuff.!series,'CLOSE')

call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode




/*******************/
/*  */
remove_record:

call lineout tempfile,'<html><head><title>CMS: Removing record from a CMS dataseries</title> </head>'

call lineout tempfile,'</head>'
call lineout tempfile,'<font size=-1><a href="'||mainaddon||'?action=1">Another CMS action</a></font><br>'

call lineout tempfile,'<h3>Removing record from a CMS dataseries</h3> '

daindx=optname.!deffile
ff=cmsdir_index||'\'||daindx
goo=stream(ff,'c','query exists')
if goo='' then do
   call lineout tempfile,'Error: could not find index file: '||ff
   signal gooble
end

call read_deffile ff
/* check for access rights */
rcode=check_access(stuff.!OWNERS,stuff.!SERIES)
if rcode<>1 then return rcode

a=sre_cache_data(stuff.!series,'OPEN  INDEX',stuff.!file)
if a>0 then do
   amess=sre_cache_data('OPEN','ERROR',a,stuff.!file)
   call lineout tempfile,'<b>Error:</b> '||amess
   signal gooble
end

vv=optname.!!REMOVE
idd=0
remlist=''
do until  vv=''
   parse var vv a7  vv
   if a7='' then iterate
   a=sre_cache_data(stuff.!series,'REMOVE ID7',strip(a7))
   idd=idd+1
   remlist=remlist||' '||a7
end

/*      1  = Data series was not defined
        3 = No such record
        4 = Bad ID7
        5  = Record not found
        8  = Bad data series name */

call lineout tempfile,'<dl><dt>'||idd||' records were removed'
call lineout tempfile,'<dd><tt>'||remlist||'</tt></dl>'

gooble:         /* jump here on error */
a=sre_cache_data(stuff.!series,'CLOSE')
a=sre_cache_data(stuff.!series,'REWRITE',stuff.!file) 
call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode


/*************/
/* read a definition file */
read_deffile:
parse arg afile
stuff.=''
stuff=sre_read_file(afile,2,2,1)
do until stuff=''
   parse var stuff aline '0d0a'x stuff ; aline=strip(aline)
   if aline='' then iterate
   if abbrev(aline,';')=1 then iterate
   parse var aline aname ':' avalue
   aname='!'||strip(translate(aname))
   stuff.aname=strip(avalue)
end

return 1


/*******************/
/* display a record  */
show_record:

call lineout tempfile,'<html><head><title>CMS: Display a record </title></head> '


call lineout tempfile,'<font size=-1>'
call lineout tempfile,'<a href="javascript:close()">Close window</a></font><br>'

call lineout tempfile,'<h3>Display a CMS record</h3> '

daindx=optname.!deffile
ff=cmsdir_index||'\'||daindx
goo=stream(ff,'c','query exists')
if goo='' then do
   call lineout tempfile,'Error: could not find index file: '||ff
   signal gooble
end

call read_deffile ff

/* check for access rights */
rcode=check_access(stuff.!OWNERS,stuff.!SERIES)
if rcode<>1 then return rcode

a=sre_cache_data(stuff.!series,'OPEN  INDEX',stuff.!file)
if a>0 then do
   amess=sre_cache_data('OPEN','ERROR',a,stuff.!file)
   call lineout tempfile,'<b>Error:</b> '||amess
   signal gooble
end

varnames=stuff.!varnames
vartypes=stuff.!vartypes
vartypes.=''
varnames.=''
varnames.0=0
do mm=1 to words(varnames)
  avar=strip(translate(word(varnames,mm)))
  varnames.mm=avar
  atype=strip(translate(word(vartypes,mm)))
  varnames.mm.!type=atype
  vv='!'||avar
  vartypes.vv=atype
end
varnames.0=words(varnames)

getvs='%ID VALS VALINDEX '||stuff.!SPECIALS
a=sre_cache_data(stuff.!series,'FIND ID7',optname.!id,getvs)

parse var a astat a
if astat>0 then do
   amess=sre_cache_data('FIND','ERROR',astat)
   call lineout tempfile,'<b>Error:</b> '||amess
   signal gooble
end
/* find real id (in the actual data)
vars are: VALS VALINDX [$abstract] [Special1 ... ] */
parse var a . '0d0a'x realid '0d0a'x morea ; realid=strip(realid)


call lineout tempfile,'<FORM name="domodify" action="'||thisaddon||'" method="POST">'
call lineout tempfile,'<input type="hidden" name="action" value="4">'
call lineout tempfile,'<input type="hidden" name="deffile" value="'||daindx||'">'
call lineout tempfile,'<input type="hidden" name="id7" value="'||optname.!ID||'">'
call lineout tempfile,'<input type="hidden" name="realid" value="'||realid||'">'

call lineout tempfile,'<em>From the CMS dataseries: </eM><b>'||stuff.!series||'</b><br>'

parse var a id7 vlist '0d0a'x a

call lineout tempfile,"<table border=1>"
av1='Record ID<br>Entered on'
tim=fig_time(realid)
aval1=realid||'<br>'||tim
call lineout tempfile,'<tr bgcolor="#998899"><th align="left" >'||av1||'</th><td>'||aval1||'</td>'

parse var morea vals '0d0a'x indx '0d0a'x morea
vvals.=''
if words(stuff.!pack)>0 then do               /* there are some packed variables */
  if strip(indx)=0 then do
     call lineout tempfile,'<b>Error</b>: packed variables specified, but no data '
     signal gooble
  end 
  iat=1
  do mm=1 to words(stuff.!pack)
      aww=strip(translate(word(stuff.!pack,mm)))
      vv='!'||aww
      vvals.vv.!name=aww
      vvals.vv.!type=vartypes.vv
      ilen=strip(word(indx,mm))
      if ilen=0 then iterate
      vvals.vv=substr(vals,iat,ilen)
      iat=iat+ilen
  end
end

/* add the special variables */
if stuff.!specials<>'' then do
  do jj=1 to words(stuff.!specials)
      aww=strip(translate(word(stuff.!specials,jj)))
      vv='!'||aww
      vvals.vv.!name=aww
      vvals.vv.!type=vartypes.vv
      parse var morea vvals.vv '0d0a'x morea
  end
end

do ii=1 to varnames.0
   aww=varnames.ii ; vv='!'||aww
   atype=vvals.vv.!type
   aname=vvals.vv.!name
   if abbrev(aname,'$A')=1 then aname='Abstract'
   if abbrev(aname,'$S')=1 then aname='Status'

   aval1=vvals.vv

   if atype='M' then do
      aval1=sre_pack64(aval1)
      aval1=sre_replacestrg(aval1,'0d0a'x,'<BR>','ALL')
   end 
   if atype='T' then do
       use_time=fig_time(aval1)
       aval1=aval1||' ('||use_time||')'
    end

   if atype="P" then do  /* note use of .POL file stored with record, not the one in .DEF file */
      call lineout tempfile,"<tr><th align="left" >"||aname||'</th>'
      parse var aval1 nresp aval1 ':' sfile ',' daquest ; 
      aval1=strip(aval1) ;daquest=strip(daquest,,':')
      sfile=strip(sfile)

      usedir=cmsdir_pol
      if abbrev(sfile,'~')=1 then do
          sfile=substr(sfile,2)
          usedir=stuff.!filedir||'\POLLS'
      end 
      afile=usedir||'\'||strip(sfile)||'.POL'

      pfile=stream(afile,'c','query exists')

      if pfile='' then do
         call lineout tempfile,'<td><b>Error:</b> No  poll-definition file specified '||'</td>'
         iterate
       end
       polstuff=sre_read_file(pfile,2,2,1)
       if polstuff='' then do
          call lineout tempfile,'<td><b>Error:</b> Empty poll-definition file '||pfile||'</td>'
          iterate
       end

       vopts.=''
       nopts=0 ; noptlist=''
       do until polstuff=''
          parse var polstuff aline '0d0a'x polstuff
          aline=strip(aline)
          if aline='' then iterate
          if abbrev(aline,';')=1 then iterate
          parse var aline a1 ':' a2
          a1=strip(translate(a1))
          if datatype(a1)='NUM' then do
             if wordpos(a1,noptlist)=0 then do
               nopts=nopts+1
               vopts.nopts=a2
               noptlist=noptlist||' '||a1
             end
          end 
       end   
       call lineout tempfile,"<td><font size=-1>"
       call lineout tempfile,'<table border=1><Tr bgcolor="#ababab"><td><b> # of responses=</b>' nresp||'</td>'
       call lineout tempfile,'<td><b># of choices</b>: '||words(aval1)||'</td>'
       call lineout tempfile,' <td colspan=3><b> Question:</b> <eM>'||sre_html_encode(left(daquest,35))||'</em></td>'
       call lineout tempfile,'<tr>'
       if words(aval1)<>nopts then do
          call lineout tempfile,'<td colspan=5><b>Error:</b> '||nopts||' choices, but '||words(aval1)||' seperate counts found.</td>'
       end
       else do
          nww=words(aval1) ;iiitmp=0
          do iii0=1 to nww by 5
            do iii=iii0 to min(nww,iii0+4)
              parse var aval1 ct1 aval1 
              aaopt=vopts.iii
              call lineout tempfile,'<td>'||aaopt||'<br><TT>'||ct1||'</tt></td>'             
              iiitmp=iiitmp+1
            end
            if iiitmp < nww then call lineout tempfile,'<tr>'
          end           /* iii0 */
       end        /* proper # of responses */
       call lineout tempfile,'</table></font></td>'
    end

    else do             /* not a POLL type, so just display the stored value */
       call lineout tempfile,"<tr><th align="left" >"||aname||'</th><td>'||aval1||'</td>'
    end

end 
call lineout tempfile,"</table>"


gooble:         /* jump here on error */
a=sre_cache_data(stuff.!series,'CLOSE')

call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode







/******************************/
/* check access rights. Return 1 if okay. Otherwise, return a string to be
  sent back to SREhttp/2 (an authorization response string) */
check_access:procedure expose privset host_nickname idinfo uri aiter
parse  upper arg owners,series

if owners='' then return 1      /* no owners listed, means open access */


tpr=translate(privset)
pneeded=space(translate('CMS:'||strip(series)),0)
if wordpos(pneeded,tpr)>0 then return 1          /* explicit privilege for this */
if wordpos('SUPERUSER',tpr)>0 then return 1

/* see if a cookie exists */
look_cook='CMS_'||series
aa=sreh2_get_cookie(lookcook)
if aa<>''  then return 1 

if aiter=''  then do            /* first time, so recheck privs */
  return 'PRIVS   Access to this dataseries is restricted to specific users '
end 

/* otherwise, see if a username has been sent  */
username=''
authh=sre_reqfield('Authorization')
if authh<>'' then username=sre_extract_username(authh) 
if username='' then do             /* no username available */
  return  'AUTH  Access to this dataseries is restricted to specific users '
end

/* is this one of the OWNERS? */
if pos('*',owners)=0 then do            /* * means "any user" */
if wordpos(translate(username),translate(owners))=0 then do
   return 'AUTH  Access to this dataseries is restricted to specific users '
end
end

/* One of the OWNERS, now check password */
stuff=sreh2_get_userinfo(authh,host_nickname,idinfo)
if stuff='' then do
  return 'AUTH   Access to this dataseries is restricted to specific users. Please enter a new username/password.'
end

parse var uri thisaddon '?' .
jj=lastpos('/',thisaddon)
pp=left(thisaddon,jj)

foo=sreh2_set_cookie(lookcook,1,'30m',pp,,1)

/* if here, legit user.  Record a cookie */
return 1

/************/
/* convert from CMS id  (JS time stamp) to "N" time stamp */
fig_time:procedure
parse arg atime0

if datatype(atime0)<>'NUM' then return ''
parse var atime0 adate1 '.' atime
adate=adate1+726467
atime='0.'||atime
dd=dateconv(adate,'B','N')

/* else, convert to hr min second */
zz=digits()
numeric digits 16
secs=trunc(atime*86400)
tmp0=secs/3600
parse var tmp0 hour '.' tmp1 ; if tmp1='' then tmp1=0
hour=right(hour,2,'0')
tmp1='0.'||tmp1
tmp2=tmp1*60
parse var tmp2 minute '.'tmp3 ; ; if tmp3='' then tmp3=0
minute=right(minute,2,'0')
tmp3='0.'||tmp3
tmp3=tmp3*60 ; parse var tmp3 second '.' .
second=right(second,2,'0')
numeric digits zz

dd=dd||' '||hour||':'||minute||':'||second
return dd


