/* The SREhttp/2 content management system (CMS) program  

   This module will schedule updates for a CMS dataseries
*/

/******** User changeable parameters ***/
/* root directory for the SREhttp/2 CMS addon.
   Leave blank to use default (CMS subdirectory of srehttp/2 addon directory */
cmsdir=''


/******** end of user changeable parameters ***/


parse arg list,servername,verb,tempfile,,
          prog_file,reqnum,verbose,client_ip,privset,,
          uri,host_nickname,idinfo,aiter,attribs,seluse2

crlf='0d0a'x

if verb=" " then do
   say "This SREhttp/2 procedure is not meant to be run in standalone mode "
   exit
end  

signal on error name cmserr
signal on syntax name cmserr
signal on novalue name cmserr

addon_dir=sre_value('H2_ADDON_DIR_DEFAULT',,'SRE')
if cmsdir='' then cmsdir=strip(addon_dir,,'\')||'\CMS'
foo=dosisdir(cmsdir)
if foo=0 then return 'String Error:unable to find CMS directory: ('cmsdir

cmsdir_data=cmsdir||'\DATA'
okk=dosisdir(cmsdir_data)
if okk=0 then do
  return 'string unable to find CMS data directory: 'cmsdir_data
end

cmsdir_lib=cmsdir||'\LIB'
okk=dosisdir(cmsdir_lib)
if okk=0 then do
  return 'string unable to find CMS lib directory: 'cmsdir_lib
end

cmsdir_pol=cmsdir||'\LIB\POL'
okk=dosisdir(cmsdir_pol)
if okk=0 then do
  return 'string unable to find CMS index directory: 'cmsdir_pol
end


cmsdir_files=cmsdir||'\FILES'
okk=dosisdir(cmsdir_files)
if okk=0 then do
  return 'string unable to find CMS input/output files directory: 'cmsdir_files
end

cmsdir_uploads=cmsdir||'\UPLOADS'
okk=dosisdir(cmsdir_uploads)
if okk=0 then do
  return 'string unable to find CMS upload files directory: 'cmsdir_uploads
end


cmsdir_index=cmsdir||'\INDEX'
okk=dosisdir(cmsdir_index)
if okk=0 then do
  return 'string unable to find CMS index directory: 'cmsdir_index
end

vers=sre_cache_data(' ','INFO',,'VERSION')
parse var vers . '0d0a'x aversion ; aversion=strip(translate(aversion,' ','09'x))
if aversion<1.19 then do
  return 'string SRE2003 version ('||c2x(aversion)||') is too old (must at least support SRE_DCSH version 1.19) '
end

parse var uri thisaddon '?' .
jj=lastpos('/',thisaddon)
mainaddon=left(uri,jj)||'cms.cmd'
root=left(uri,jj)


optname.=''
m=0
if list='' then list='action=1'

list0=list
do until list=""
    parse var list opt1 '&' list
    m=m+1
    parse var opt1 avar '=' aval ; avar=strip(translate(avar)) 
    optname.0=optname.0||' '||avar
    aval=translate(aval,' ', '+')
    aval=sre_packur(aval)
    avar1='!!'avar
    if optname.avar1<>'' then
       optname.avar1=optname.avar1||' '||aval
    else
       optname.avar1=aval
    avar2='!'avar
    aval2=strip(translate(aval,' ','090a0d'x))
    optname.avar2=aval2
end

/***** End of GENERIC CMS addon code *****/

if optname.!action='0' then do   /* find the list of dataseries defined for this host*/
  call basic_action
  foo=result
  return foo
end

if optname.!action='10' then do   /* find the list of dataseries defined for this host*/
  call start_scheduler
  foo=result
  return foo
end

if optname.!action='11' then do   /* find the list of dataseries defined for this host*/
  call stop_scheduler
  foo=result
  return foo
end


if optname.!action='20' then do  
  call check_status
  foo=result
  return foo
end

if optname.!action='50' then do  
  call check_history
  foo=result
  return foo
end


if optname.!action='30' then do  
  call add_schedule
  foo=result
  return foo
end

if optname.!action='31' then do  
  call ask_template
  foo=result
  return foo
end

if optname.!action='32' then do  
  call add_item
  foo=result
  return foo
end

if optname.!action='41' then do   
  call remove_items
  foo=result
  return foo
end


if optname.!action='60' then do   
  call save_state2
  foo=result
  return foo
end


if optname.!action='61' then do   
  call reset_state
  foo=result
  return foo
end


return 'ERROR'

cmserr:
call sre_pmprintf("CMS_UPD error at "sigl' rc='rc)
exit 


/*******************/
/* start the cms scheduler daemon */
start_scheduler:

call lineout tempfile,'<html><head><title>CMS: Start the CMS Scheduler</title> '
call lineout tempfile,'<font size=-1><a href="javascript:close()">close window</a></font><br>'
call lineout tempfile,'<h3>Launch the CMS Scheduler</h3><p> '

call lineout tempfile,'The CMS Scheduler is a <em>daemon</em> that takes care of scheduled'
call lineout tempfile,'updates of CMS dataseries. <p>'

/* is the scheduler already running? */
STUFf=SRE_DMN_command("SRE_CMS_SCHEDULE","VERIFY",100)
if stuff=1 then do
   ttid=SRE_DMN_command("SRE_CMS_SCHEDULE","TID",100)
   call lineout tempfile,'<b>The CMS Scheduler</b> is <u>currently running</u> (<tt>on thread 'ttid'</tt>).<p>'
   call lineout tempfile,'If it doesn''t seem to be working, you can try shutting down, and then restarting, the CMS Scheduler.'
   signal gooble
end 


/* load macrospace procedure */
oof=cmsdir||'\CMS_MAKE.CMD'
goo=macrodrop('SREH2_CMS_MAKE_M')
goo=macroadd('SREH2_CMS_MAKE_M',oof,'b')
if goo=0 then do
    call lineout tempfile,'<b>Error.</b> Unable to load procedure in 'oof
    signal gooble
end

call lineout tempfile,'Launching the CMS Scheduler <em> daemon</em> ... <br>'
dafile=cmsdir||'\CMS_DMN.CMD'
stuf=SRE_DMN_Launch('SRE_CMS_SCHEDULE',dafile,1,cmsdir)
if abbrev(stuf,'error')=1 then do
   parse var stuf . stuf
   call lineout tempfile,'<ul>'
   call lineout tempfile,'<LI><B>Error</b> launching CMS Scheduler: '||stuf
   call lineout tempfile,'</ul>'
   signal gooble
end
parse var stuf tid_sched',' dmnid_sched ',' vresult
if strip(vresult)<>1 then do
   call lineout tempfile,'<ul>'
   call lineout tempfile,'<LI><B>Error</b> on launching CMS Scheduler: '||vresult
   call lineout tempfile,'</ul>'
   signal gooble
end
call lineout tempfile,'<ul>'
call lineout tempfile,'<li><b> Result: </b> The CMS Scheduler has been started (as a daemon running on thread 'tid_sched', using id of:'dmnid_sched
call lineout tempfile,'</ul>'

call lineout tempfile,'<hr>'
call lineout tempfile,'<h4>Hint</h4>'
call lineout tempfile,'If you want the scheduler to be enabled everytime SREhttp/2 is started:'
call lineout tempfile,'<ol type="i">'
call lineout tempfile,'<li> Make sure the <tt>STARTREQ.CMD</tt> <em>SRE2003 initialization procedure</em> is enabled.<br>'
call lineout tempfile,'<tt>If you do not have a  May 2004 version of SRE2003 (or later)</tt>, you can get STARTREQ.CMD <a href="http://srehttp.org/pubfiles/startreq.cmd">here</a> -- save it to your SREHTTP2 directory!'
call lineout tempfile,'<li>Add the following to your <tt>STARTREQ.REQ</tt> file (in your <tt>SREHTTP2</tt> directory):'
call lineout tempfile,' (you can get a copy of STARTREQ.REQ <a href="http://srehttp.org/pubfiles/startreq.req">here</a>)'
call lineout tempfile,'<pre>'
call lineout tempfile,''
call lineout tempfile,';start scheduler'
call lineout tempfile,'server: your.server.org'
call lineout tempfile,'request: /cms/cms_upd.cmd'
call lineout tempfile,'option: action=10'
call lineout tempfile,'username: your_superuser'
call lineout tempfile,'password: your_password'
call lineout tempfile,''
call lineout tempfile,'</pre>'
call lineout tempfile,'<em>where</em>'
call lineout tempfile,'<menu>'
call lineout tempfile,'<li> <tt>your.server.org</tt> is the IP name of your site '
call lineout tempfile,'<li> <tt>your_superuser</tt> is the username of a superuser for your server'
call lineout tempfile,'<li> <tt>your_password</tt> is the password for this superuser '
call lineout tempfile,'</menu>'
call lineout tempfile,'<li>Next, add all the scheduled entries you want to be processed by the scheduler.'
call lineout tempfile,'<li>... and <a target="cms" href="/cms/cms_upd.cmd?action=60&afile=">store them</a>'
call lineout tempfile,'<li>Add the following to your  <tt>STARTREQ.REQ</tt> file'

call lineout tempfile,'<pre>'
call lineout tempfile,';start1.lst contains update commands '
call lineout tempfile,'server: your.server.org'
call lineout tempfile,'request: /cms/cms_upd.cmd'
call lineout tempfile,'option: action=61'
call lineout tempfile,'option: afile='
call lineout tempfile,'username: your_superuser'
call lineout tempfile,'password: your_password'
call lineout tempfile,'verbose: 1'
call lineout tempfile,''
call lineout tempfile,'</pre>'

call lineout tempfile,'</ol>'
call lineout tempfile,'Now, whenever SRE2003 &amp; SREhttp/2 starts (or restarts), the scheduler will start, using the entries'
call lineout tempfile,'you stored in the above step!'

gooble: 
call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode



/*******************/
/* start the cms scheduler daemon */
stop_scheduler:

call lineout tempfile,'<html><head><title>CMS: Stop the CMS Scheduler</title> '
call lineout tempfile,'<font size=-1><a href="javascript:close()">close window</a></font><br>'
call lineout tempfile,'<h3>Stop the CMS Scheduler</h3><p> '

call lineout tempfile,'The CMS Scheduler is a <em>daemon</em> that takes care of scheduled'
call lineout tempfile,'updates of CMS dataseries. <p>'

/* is the scheduler not running? */
STUFf=SRE_DMN_command("SRE_CMS_SCHEDULE","VERIFY",100)
if stuff<>1 then do
  fi=sre_flag_set("SRE_CMS_BUSY")
  if abbrev(fi,'error')=1 then do
     call lineout tempfile,'<b>The CMS Scheduler</b> is <u>not currently running</u> <p>'
     signal gooble
  end
end 

call lineout tempfile,'Stopping the CMS Scheduler <em> daemon</em> ... <br>'
STUFf=SRE_DMN_command("SRE_CMS_SCHEDULE","EXIT",100)
fi=sre_flag_close("SRE_CMS_BUSY")
call syssleep(1)
STUFf=SRE_DMN_command("SRE_CMS_SCHEDULE","VERIFY",100)
if stuff=1 then do
   call lineout tempfile,'Problem stopping CMS Scheduler. You may have to stop SRE2003'
   signal gooble
end 


call lineout tempfile,'<ul>'
call lineout tempfile,'<li><b> Result: </b> CMS Scheduler has been stopped.'
call lineout tempfile,'</ul>'

gooble: 
call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode






/*******************/
/* pick the basic action */
basic_action:

call lineout tempfile,'<html><head><title>CMS: Select a CMS update action</title> '


call lineout tempfile,'<font size=-1><a href="'||mainaddon||'?action=1">Another CMS action</a> || '
call lineout tempfile,'<a href="'||thisaddon||'?action=0">refresh</a>  '
call lineout tempfile,'</font><br>'

call lineout tempfile,'<h3>Select a CMS update action</h3><p> '

ahost=host_nickname

/* see if cms-scheduler daemon is running */
STUFf=SRE_DMN_command("SRE_CMS_SCHEDULE","VERIFY",100)
if stuff<>1  then do
  fi=sre_flag_set("SRE_CMS_BUSY")
  if abbrev(fi,'error')=1 then do
     call lineout tempfile,'<hr><b>The CMS scheduler has not been started</b><p>'
     call lineout tempfile,'Would you like to <a target="launch" href="'||thisaddon||'?action=10">start the CMS scheduler</a>? <hr>'
     call lineout tempfile,'<b>After starting the scheduler, you can ...</b><p>'  
     tt='not yet started'
  end
  else do
      tt='scheduler is busy '
  end 
end 
else do
   tt=SRE_DMN_command("SRE_CMS_SCHEDULE","TID",100)
   call lineout tempfile,'<em>You can ...</em>'
end

call lineout tempfile,'<ul>'
call lineout tempfile,'<li> <a href="'||thisaddon||'?action=30">Schedule a new update</a> <p>'
call lineout tempfile,'<li> <a href="'||thisaddon||'?action=20">Check status, &amp; unschedule, currently scheduled updates </a> '
call lineout tempfile,'<li> <a href="'||thisaddon||'?action=50">View update history</a> <p>'
call lineout tempfile,'<li><form name="recover" method="GET" action="'||thisaddon||'">'
call lineout tempfile,'<input type="hidden" name="action" value=60>'
call lineout tempfile,'<input type="submit" value="Store update specs"> or '
call lineout tempfile,'<input type="submit" value="recover update specs" '
call lineout tempfile,'       onclick="this.form.action.value=61">'
call lineout tempfile,' <em>optional: enter file (no path, no ext) to use</em> '
call lineout tempfile,'<input type="text" name="afile" size=30>'
call lineout tempfile,'</form>'
call lineout tempfile,'<li><a target="launch" href="'||thisaddon||'?action=11">Shutdown</a> the CMS scheduler.'

call lineout tempfile,'</ul>'


call lineout tempfile,'<hr><tt>Note:</tt> the CMS Scheduler is running on thread #'||tt

gooble: 
call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode




/*******************/
/* pick one of the current cms datafiles (for this host) */
add_schedule:

call lineout tempfile,'<html><head><title>CMS: Update output from a CMS dataseries</title> '


call lineout tempfile,'<font size=-1><a href="'||mainaddon||'?action=1">Another CMS action</a>||'
call lineout tempfile,'<a href="'||thisaddon||'?action=0">Scheduler</a>  '
call lineout tempfile,'</font><br>'

call lineout tempfile,'<h3>Select a CMS dataseries</h3><em>from which you want to schedule updates...</em><p> '

ahost=host_nickname

/* look for files, in cmsDIR_index dir, of the form: ahost_nnnn.DEF
   These .DEF files define "CMS indices" --- nnnn is a number from 0 to 9999
*/

cookie_value=sreh2_get_cookie('CMS') 

call lineout tempfile,'<FORM name="" action="'||thisaddon||'" method="POST">'
call lineout tempfile,'<input type="hidden" name="action" value="31">'
ff=cmsdir_index||'\'||ahost||'*.DEF'
goo=sysfiletree(ff,'ff2','FO')

call lineout tempfile,'For host: <Tt>'||ahost||'</tt>, the following CMS dataseries have been created'


call lineout tempfile,'<table border=1>'
do jj=1 to ff2.0
   daname=filespec('n',ff2.jj)
   call read_deffile ff2.jj
   call lineout tempfile,'<tr><th align="left">' 
   if daname=cookie_value  | (cookie_value='' & jj=1) then
      call lineout tempfile,'<INPUT TYPE="RADIO" checked name="deffile" value="'||daname||'">' 
   else
      call lineout tempfile,'<INPUT TYPE="RADIO"  name="deffile" value="'||daname||'">' 
   gob=strip(stuff.!series)||'</th>'
   call lineout tempfile,gob||'<td> <em>&nbsp;'||stuff.!desc||'</em></td>'
end

call lineout tempfile,'</table>'


call lineout tempfile,''
call lineout tempfile,'<p><INPUT name="sub2" TYPE="submit" VALUE="Choose a CMS dataseries">'
call lineout tempfile,'</form>'
call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode


/*******************/
/* pick template(s) to generate output files from */
ask_template:
stuff.=''

call lineout tempfile,'<html><head><title>CMS: What to update</title> '

call lineout tempfile,'</head>'
call lineout tempfile,'<font size=-1><a href="javascript:history.go(-1)">Back</a> || <a href="'||mainaddon||'?action=1">Another CMS action</a></font><br>'

call lineout tempfile,'<h3>Update instructions</h3> '


foo=sre_flag_set("SRE_CMS_BUSY")
if abbrev(foo,'error')=1 then do
   call lineout tempfile,'Unable to schedule -- have you started the <a href="'||thisaddon||'?action=0">CMS Scheduler</a> yet? '
   signal gooble
end 

daindx=optname.!deffile
ff=cmsdir_index||'\'||daindx
goo=stream(ff,'c','query exists')
if goo='' then do
   call lineout tempfile,'Error: could not find index file: '||ff
   signal gooble
end

call read_deffile ff

astat=sreh2_set_cookie('CMS',daindx,1,root,,1) 

/* check for access rights */
rcode=check_access(stuff.!OWNERS,stuff.!SERIES)
if rcode<>1 then return rcode

a=sre_cache_data(stuff.!series,'OPEN  INDEX',stuff.!file)
if a>0 then do
   amess=sre_cache_data('OPEN','ERROR',a,stuff.!file)
   call lineout tempfile,'<b>Error:</b> '||amess
   signal gooble
end


a=sre_cache_data(stuff.!series,'INFO',,'MODIFIED RECORDS VARS DESCRIPTION')
parse var a astat a ; astat=strip(astat)
if astat<>'0' then do
   amess=sre_cache_data('INFO','ERROR',astat)
   call lineout tempfile,'<b>Error retrieving info:</b> '||amess
   signal gooble
end

parse var a . '0d0a'x . '09'x modified  '=' . '09'x nrecords '09'x  varlist '09'x  desc

call lineout tempfile,'<FORM name="dogenerate" action="'||thisaddon||'" method="POST">'
call lineout tempfile,'<input type="hidden" name="action" value="32">'
call lineout tempfile,'<input type="hidden" name="deffile" value="'||daindx||'">'
call lineout tempfile,'<input type="hidden" name="backup" value=0>'
call lineout tempfile,'<input type="hidden" name="DEBUG" value="-1">'
call lineout tempfile,'<input type="hidden" name="series" value="'||stuff.!SERIES||'">'

call lineout tempfile,'<em>For the CMS dataseries: </eM><b>'||stuff.!series||'</b><br>'
call lineout tempfile,'<table>'
call lineout tempfile,'<tr><th align="left">Last modified:</th><td>'||modified||'</td>'
call lineout tempfile,'<tr><th align="left"># of records currently in dataseries:</th><td>'||nrecords||'</td>'
call lineout tempfile,'<tr><th align="left">Description:</th><td>'||desc||'</td>'
call lineout tempfile,'</table>'

if stuff.!template='' then do
   call lineout tempfile,'<b>No outputs specified</b> for this CMS dataseries '
   signal gooble

end 

call lineout tempfile,'<table border=1>'
call lineout tempfile,'<tr bgcolor="#abab9b"><td>A short description<br><b>(required)</b></td>'
call lineout tempfile,'<td><input type="text" name="desc" value="" size=70></td>'

call lineout tempfile,'<tr><td bgcolor="#ababab">Specify what to update,<br> and some options</td>'
call lineout tempfile,'<td>'
call lineout tempfile,''
call lineout tempfile,'<p>Select one, or more, output files to update.<br>'

call lineout tempfile,'<table border=1>'

tt=stuff.!template
do until tt=''
    parse var tt aline '0d0a'x tt
    parse var aline ofile tfile ',' desc ; tfile=strip(tfile)
    call lineout tempfile,'<tr><td><input type="checkbox" name="tfile" value="'||tfile||'">'    
    hh='<a target="viewer" href="'||thisaddon||'?action=5&deffile='||optname.!deffile||'&tplfile='||tfile||'">'||tfile||'</a>'
     call lineout tempfile,'<b>'||ofile||'</b><br><tt>('||hh||')</tt>'
    call lineout tempfile,'</td><td><em>'||desc||'</em>'
    call lineout tempfile,'</td>'
end 
call lineout tempfile,'</table>'
call lineout tempfile,'<b>Note:  </b>The <u>template file</u> contains CMS instructions used to generate each output file.<br> '
call lineout tempfile,'It may also contain instructions on creating comment &amp; archive files.'

call lineout tempfile,'<p><table><tr><td colspan=3 ><table border=1>'
call lineout tempfile,'<tr><td>We <b>strongly recommend</b> selecting values for the followings <em>options</em> that are the same as the values selected  '
call lineout tempfile,'when you  <u>generated output</u> for this dataseries</td></table></td>' 

call lineout tempfile,'<tr><td colspan=3>Optional <em>argument</em> string: <input type="text" name="arg" size=60></td>'

if stuff.!specials<>'' then do
  call lineout tempfile,'<tr><td>Sort variable:</td>'
  call lineout tempfile,'<td><select name="SORTIT_VAR">'
  call lineout tempfile,'<option selected value="">Entry date'
  do jj=1 to words(stuff.!specials)
      aww=strip(translate(word(stuff.!specials,jj)))
      call lineout tempfile,'<option value="'||aww||'">'||aww
  end
  call lineout tempfile,'</select></td>'
  call lineout tempfile,'<td><input type="checkbox" name="SORTIT_ORDER" value="D">Descending order <em>unchecked means ascending</em></td>'
end

call lineout tempfile,'<tr><td>Display recent:'
  call lineout tempfile,'<input type="hidden" name="SELECTVAL" value="RECENT"></td>'
  call lineout tempfile,'<td><select name="SELECT">'
      call lineout tempfile,'<option  selected value="0">No (display all records)'
      call lineout tempfile,'<option    value="HOUR">Last hour'
      call lineout tempfile,'<option  value="DAY">Last day'
      call lineout tempfile,'<option  value="WEEK">Last week'
      call lineout tempfile,'<option  value="MONTH">Last month'
      call lineout tempfile,'<option  value="YEAR">Last year'
      if stuff.!specials<>'' then 
         call lineout tempfile,'<option  value="SORT">Last sorted-variable'
call lineout tempfile,'</select></td>'

call lineout tempfile,'<tr><td colspan=3>'
call lineout tempfile,'This will update (the latest archives &amp; possibly comments) <em>to recreate, use CMS '
call lineout tempfile,'<a href="/cms/cms_make.cmd?action=1">Generate output files from an existing CMS dataseries</a> option.</em>'
call lineout tempfile,'</td>'
call lineout tempfile,'</table>'

call lineout tempfile,'</td>'


call lineout tempfile,'<tr><td bgcolor="#abab88">Select some scheduling options'
call lineout tempfile,'</td>'

call lineout tempfile,'<td> <menu>'

call lineout tempfile,'<li>How often should updates occur: '
call lineout tempfile,'<select size=1 name="FREQ" '
call lineout tempfile,' onChange="i1=this.selectedIndex ; a1=options[i1].value ; '
call lineout tempfile,'  if (a1==''$''){ a2=options[i1].text ;  '
call lineout tempfile,'     a3=window.prompt(''Enter a fraction of a day (example: 0.5=12 hours, 0.0007=1 minute))'') ;'
call lineout tempfile,'     options[i1].value=a3 ; options[i1].text=options[i1].text + '' = '' + a3 ; '
call lineout tempfile,'     }"> '
call lineout tempfile,'<option  value="1"> Daily '
call lineout tempfile,'<option   value="0.17"> Every 4 hours '
call lineout tempfile,'<option selected   value="0.04"> Every hour'
call lineout tempfile,'<option   value="0.01"> Every 15 minutes'
call lineout tempfile,'<option   value="0.003"> Every 5 minutes'
call lineout tempfile,'<option   value="0.001"> Every 90 seconds'
call lineout tempfile,'<option   value="$"> Specify ...'
call lineout tempfile,'</select><p>'


call lineout tempfile,'<li>How many times should the update be done: '
call lineout tempfile,'<select size=1 name="COUNT" '
call lineout tempfile,' onChange="i1=this.selectedIndex ; a1=options[i1].value ; '
call lineout tempfile,'  if (a1==''$''){ a2=options[i1].text ;  '
call lineout tempfile,'     a3=window.prompt(''Enter number of times to schedule this update'') ;'
call lineout tempfile,'     options[i1].value=a3 ; options[i1].text=options[i1].text + '' = '' + a3 ; '
call lineout tempfile,'     }"> '
call lineout tempfile,'<option  value="1"> Just once '
call lineout tempfile,'<option   value="2"> Two times '
call lineout tempfile,'<option   value="3"> 5 times'
call lineout tempfile,'<option selected value="0"> No limit  '
call lineout tempfile,'<option   value="$"> Specify ...'
call lineout tempfile,'</select><p>'



call lineout tempfile,'<li><input type="checkbox" name="immediate" value=1>'
call lineout tempfile,' Do an update immediately (if not checked, wait the chosen time before updating)'
call lineout tempfile,'<p>'
call lineout tempfile,'<li><input type="checkbox" name="do_check" value=1>Only update if dataseries files have changed'
call lineout tempfile,'<p>'

call lineout tempfile,'<li><input type="checkbox" name="do_main" checked value=1>Update main output file ||'
call lineout tempfile,'<input type="checkbox" name="do_arc" checked value=1> Update archives ||'
call lineout tempfile,'<input type="checkbox" name="do_cmt" checked value=1> Update comments<p> '

call lineout tempfile,'<li><input type="radio" name="how_update" checked value=1>Update only ||'
call lineout tempfile,'<input type="radio" name="how_update"  value=2> Update or re-create  ||'
call lineout tempfile,'<input type="radio" name="how_update" value=3> Re-create '


call lineout tempfile,'</menu></td>'


call lineout tempfile,'</table>'

call lineout tempfile,'<input name="sub2" type="submit" value="Schedule the updates"> (<TT>of output files, and their archives &amp; comments</tt>)'
call lineout tempfile,'</form>'


gooble:         /* jump here on error */
a=sre_cache_data(stuff.!series,'CLOSE')

call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode



/*******************/
/* send an ADD request to the cms update daemon */
add_item:

call lineout tempfile,'<html><head><title>CMS: Adding item to CMS scheduler</title> '

call lineout tempfile,'<font size=-1>'
call lineout tempfile,'<a href="'||mainaddon||'?action=1">Another CMS action</a> || '
call lineout tempfile,'<a href="'||thisaddon||'?action=0">Scheduler</a>'

call lineout tempfile,'</font><br>'

call lineout tempfile,'<h3>Adding item to CMS scheduler</h3><p> '

ahost=host_nickname


daindx=optname.!deffile
ff=cmsdir_index||'\'||daindx
goo=stream(ff,'c','query exists')
if goo='' then do
   call lineout tempfile,'Error: could not find index file: '||ff
   signal gooble
end
call read_deffile ff

call lineout tempfile,'Scheduling an update for series:<b> 'stuff.!series||'</b> <em>('||stuff.!desc||')</em> '
call lineout tempfile,'<br>Update frequency (in days)=<tt>'||optname.!freq||'</tt> '

tfiles=optname.!!TFILE
if tfiles='' then do
   call lineout tempfile,'<P><b>Error:</b> you did not specify an output file/template<br>'
   call lineout tempfile,'<a href="javascript:history.go(-1)">go back and try again ...</a>'
   signal gooble
end 

if optname.!!DESC='' then do
   call lineout tempfile,'<P><b>Error:</b> you did not specify a description'
   call lineout tempfile,'<a href="javascript:history.go(-1)">go back and try again ...</a>'
   signal gooble
end

ibb=sre_flag_set('SRE_CMS_BUSY')
if abbrev(ibb,'error')=1 then do
   call lineout tempfile,'<b>Error</b>. Did you forget to start the CMS scheduler? '
   signal gooble
end 
if ibb<> 0 then
  swait=0
else
  swait=1000

if pos('.',stuff.!FILE)=0 then stuff.!file=strip(stuff.!file)||'.SDS'
if pos('.',stuff.!commentFILE)=0 then stuff.!commentfile=strip(stuff.!commentfile)||'.SDS'

STUF= SRE_DMN_ask("SRE_CMS_SCHEDULE",'ADD '||'0d0a'x||stuff.!series||,
                                    '0d0a'x||translate(optname.!!tfile,' ','0d0a'x)||,
                                    '0d0a'x||stuff.!file||'0d0a'x||stuff.!CommentFile||,
                                    '0d0a'x||list0,swait)
if abbrev(stuf,'error')=1  stuf='' then do
   call lineout tempfile,'<ul><li><b>Error:</b> '||subword(stuf,2)||'</ul>'
   signal gooble
end 
parse var stuf  amessage
call lineout tempfile,'<p> Update scheduled: <tt>'||amessage||'</tt>'


gooble:         /* jump here on error */


a=sre_cache_data(stuff.!series,'CLOSE')

call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode

/******************************/
/* check status of schedule */
check_history:

call lineout tempfile,'<html><head><title>CMS: Checking history CMS scheduler</title> '

call lineout tempfile,'<font size=-1><a href="'||mainaddon||'?action=1">Another CMS action</a> || '
call lineout tempfile,'<a href="'||thisaddon||'?action=0">Scheduler</a>  '
call lineout tempfile,'</font><br>'

call lineout tempfile,'<h3>Checking history of CMS scheduler</h3><p> '

ibb=sre_flag_set('SRE_CMS_BUSY')
if abbrev(ibb,'error')=1 then do
   call lineout tempfile,'<b>Error</b>. Did you forget to start the CMS scheduler? '
   signal gooble
end 
if ibb=1 then do
   call lineout tempfile,'<b>Busy</b>. The CMS Scheduler is busy. Try again in a minute or so.'
   signal gooble
end

STUF= SRE_DMN_ask("SRE_CMS_SCHEDULE",'HISTORY ',1000)

call lineout tempfile,'<pre>'||stuf||'</pre>'

gooble:         /* jump here on error */

call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode

/******************************/
/* check status of schedule */
check_status:

call lineout tempfile,'<html><head><title>CMS: Checking status of CMS scheduler</title> '

call lineout tempfile,'<font size=-1><a href="'||mainaddon||'?action=1">Another CMS action</a> || '
call lineout tempfile,'<a href="'||thisaddon||'?action=0">Scheduler</a>'
call lineout tempfile,'</font><br>'

call lineout tempfile,'<h3>Checking status of CMS scheduler</h3><p> '

atime=sre_gmt(0,,'JS',0)
call lineout tempfile,'<em>Current time: '||fig_time(atime)||' ('||atime||')</em><br>'
ibb=sre_flag_set('SRE_CMS_BUSY')
if abbrev(ibb,'error')=1 then do
   call lineout tempfile,'<b>Error</b>. Did you forget to start the CMS scheduler? '
   signal gooble
end 
if ibb=1 then do
   call lineout tempfile,'<b>Busy</b>. The CMS Scheduler is busy. Try again in a minute or so.'
   signal gooble
end

STUF= SRE_DMN_ask("SRE_CMS_SCHEDULE",'SHOW ',1000)
call lineout tempfile,'<form name="oy" method="POST" name="'||thisaddon||'">'
call lineout tempfile,'<input type="hidden" name="action" value="41">'
call lineout tempfile,'<table border=1>'
call lineout tempfile,'<th>&nbsp;</th>'
call lineout tempfile,'<th>Description</th>'
call lineout tempfile,'<th>Series</th>'
call lineout tempfile,'<th>Update time</th>'
call lineout tempfile,'<th>Freq<br>Ct</th>'
call lineout tempfile,'<th>Data Series<br>last updated<br>(comments)</th>'
call lineout tempfile,'<th>Update-type<br>Check: if-updated<br> main archive comments </th>'
call lineout tempfile,'<th>.DEF file</th>'
call lineout tempfile,'<th>Template files</th>'
call lineout tempfile,'<th>SORT-var<br> Sort-order</th>'
call lineout tempfile,'<th>argument</th>'
yn.='No' ; yn.1='Yes'
upd.1='Update only '; upd.2='Update or re-create' ; upd.3='Always re-create '
do until stuf=''
   parse var stuf aline '0d0a'x stuf
   if aline='' then iterate
   parse var aline ,
      update_time '09'x ct '09'x freq '09'x series '09'x ,
      sfile '09'x sfile_mdate '09'x cfile '09'x cfile_mdate  '09'x , 
      desc '09'x do_check '09'x do_main '09'x do_arc '09'x do_cmt '09'x  update_type '09'x ,
      deffile '09'x tfiles '09'x sortit_var  '09'x sortit_order '09'x ,
      darg '09'x  . '01'x puds
    call lineout tempfile,'<tr>'  
    rthis=space(update_time||';'||series,0)
    call lineout tempfile,'<td><input type="checkbox" name="remove" value="'||rthis||'"></td>'
    call lineout tempfile,'<td><font size=-1><em>'desc'</em></font></td>'
    call lineout tempfile,'<td>'||series||'</td>'
    tt=sre_gmt(0,update_time+726467,'',0) 
    parse var tt . ',' tt ;tt=strip(tt)
    call lineout tempfile,'<td>'||update_time||'<br><tt>('||tt||')</tt></td>'
    if ct=0 then ct='no-limit'
    
    call lineout tempfile,'<td>'||freq||"<br>"||ct||'</td>'
    sfile1=filespec('n',sfile); parse var sfile1 sfile1 '.' .
    call lineout tempfile,'<td>'||sfile1||'<br>'||sfile_mdate||'<br>'||cfile_mdate||'</td>'
    call lineout tempfile,'<td>'||upd.update_type||'<br>'||yn.do_check||'<br>'||yn.do_main||' '||yn.do_arc||' '||yn.do_cmt||'</td>'
    parse var deffile d1 '.' .
    call lineout tempfile,'<td>'||d1||'</td>'
    call lineout tempfile,'<td>'
    do jj=1 to words(tfiles)
        call lineout tempfile,strip(word(tfiles,jj))||'<br>'
    end 
    call lineout tempfile,'</td>'
    call lineout tempfile,'<td>'||sortit_var||'<br>'||sortit_order||'</td>'
    call lineout tempfile,'<td>'||darg||'</td>'
end
call lineout tempfile,'</table>'
call lineout tempfile,'<input type="submit" value="Remove checked items">'
call lineout tempfile,'</form>'

gooble:         /* jump here on error */

call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode


/******************************/
/* save current update entries */
save_state2:

call lineout tempfile,'<html><head><title>CMS: Save Update entries</title> '

call lineout tempfile,'<font size=-1><a href="'||mainaddon||'?action=1">Another CMS action</a> || '
call lineout tempfile,'<a href="'||thisaddon||'?action=0">Scheduler</a>'
call lineout tempfile,'</font><br>'

call lineout tempfile,'<h3>Saving Update Entries</h3><p> '

atime=sre_gmt(0,,'JS',0)
call lineout tempfile,'<em>Current time: '||fig_time(atime)||' ('||atime||')</em><br>'
ibb=sre_flag_set('SRE_CMS_BUSY')
if abbrev(ibb,'error')=1 then do
   call lineout tempfile,'<b>Error</b>. Did you forget to start the CMS scheduler? '
   signal gooble
end 
if ibb=1 then do
   call lineout tempfile,'<b>Busy</b>. The CMS Scheduler is busy. Try again in a minute or so.'
   signal gooble
end

STUF= SRE_DMN_ask("SRE_CMS_SCHEDULE",'SHOW ',1000)
call lineout tempfile,'<ul>'
ndo=0
nsave=';CMS Update entries saved on '||date('n')||' '||time('n')
do until stuf=''
   parse var stuf aline '0d0a'x stuf
   if aline='' then iterate
   ndo=ndo+1
   parse var aline ,
      update_time '09'x ct '09'x freq '09'x series '09'x ,
      sfile '09'x sfile_mdate '09'x cfile '09'x cfile_mdate  '09'x , 
      desc '09'x do_check '09'x do_main '09'x do_arc '09'x do_cmt '09'x  update_type '09'x ,
      deffile '09'x tfiles '09'x sortit_var  '09'x sortit_order '09'x ,
      darg '09'x  . '01'x puds

      desc=translate(desc,' ','09'x)
      call lineout tempfile,'<li>Entry found= <tt>'||series||'</tt> : <em>'||desc||'</em>'  

      oout=series||'09'x||desc||'09'x||tfiles||'09'x ||sfile||'09'x||cfile
      nsave=nsave||'0d0a'x||puds||' '||oout
end   
call lineout tempfile,'</ul>'


aafile=space(optname.!afile,0)
if aafile='' | aafile='0' then aafile='CMS_UPD'

aafile=filespec('n',aafile)||'.LST'

call lineout tempfile,'Saving 'ndo' entries (to '||cmsdir||'\'||aafile||')'

astat=sre_append_file(cmsdir||'\'||aafile,nsave,2,,1) 

if astat<0 then
   call lineout tempfile,'<bR><b>Error.</b>Unable to save to '||cmsdir||'\'||aafile
else
  call lineout tempfile,'<p>'||cmsdir||'\'||aafile||' has been created.<br>You can <u>reload</u> these entries at a future date.'

gooble:         /* jump here on error */

call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode



/******************************/
/* reset update entries */
reset_state:

call lineout tempfile,'<html><head><title>CMS: Recover update entries</title> '

call lineout tempfile,'<font size=-1><a href="'||mainaddon||'?action=1">Another CMS action</a> || '
call lineout tempfile,'<a href="'||thisaddon||'?action=0">Scheduler</a>'
call lineout tempfile,'</font><br>'

call lineout tempfile,'<h3>Recover update Entries</h3><p> '

atime=sre_gmt(0,,'JS',0)
call lineout tempfile,'<em>Current time: '||fig_time(atime)||' ('||atime||')</em><br>'
ibb=sre_flag_set('SRE_CMS_BUSY')
if abbrev(ibb,'error')=1 then do
   call lineout tempfile,'<b>Error</b>. Did you forget to start the CMS scheduler? '
   signal gooble
end 


aafile=filespec('n',space(optname.!afile,0))
if aafile='' | aafile='0' then aafile='CMS_UPD'

efile=cmsdir||'\'||aafile||'.LST'

stuf=sre_read_file(efile,2,2,1)
if stuf='' then do
   call lineout tempfile,'Error. Update file ('efile')could not be read.'
   signal gooble
end 

call lineout tempfile,'Reading entries stored in: 'efile

call lineout tempfile,'<ul>'
do until stuf=''
    parse var stuf aline '0d0a'x stuf
    aline=strip(aline)
    if abbrev(aline,';')=1 then iterate
    parse var aline tlist aseries '09'x adesc '09'x  tfiles '09'x sfile '09'x cfile

    QSTUF= SRE_DMN_ask("SRE_CMS_SCHEDULE",'ADD '||'0d0a'x||strip(Aseries)||,
          '0d0a'x||TfileS||'0d0a'x||Sfile||'0d0a'x||CFile||'0d0a'x||tlist,0)

    call lineout tempfile,'<li>Entry= <tt>'||aseries||'</tt>: <em>'||adesc||'</em>'
end
call lineout tempfile,'</ul>'
call lineout tempfile,'<b>Note:</b> these entries were added to any currently active entries'

gooble:         /* jump here on error */

call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode



/******************************/
/* unschedule an item */
remove_items:

call lineout tempfile,'<html><head><title>CMS: Remove from CMS scheduler</title>  '
call lineout tempfile,'<font size=-1><a href="'||mainaddon||'?action=1">Another CMS action</a> || '
call lineout tempfile,'<a href="'||thisaddon||'?action=0">Scheduler</a>  '
call lineout tempfile,'</font><br>'

call lineout tempfile,'<h3>Remove from CMS scheduler</h3><p> '

ibb=sre_flag_set('SRE_CMS_BUSY')
if abbrev(ibb,'error')=1 then do
   call lineout tempfile,'<b>Error</b>. Did you forget to start the CMS scheduler? '
   signal gooble
end d
if ibb=1 then do
   call lineout tempfile,'<b>Busy</b>. The CMS Scheduler is busy. Try again in a minute or so.'
   signal gooble
end

STUF= SRE_DMN_ask("SRE_CMS_SCHEDULE",'REMOVE '||'0d0a'x||optname.!!REMOVE,1000)
call lineout tempfile,'Status: <tt>'||stuf||'</tt>'

gooble:         /* jump here on error */

call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode


 

/*************/
/* read a definition file */
read_deffile:
parse arg afile
stuff.=''
stuff=sre_read_file(afile,2,2,1)
do until stuff=''
   parse var stuff aline '0d0a'x stuff ; aline=strip(aline)
   if aline='' then iterate
   if abbrev(aline,';')=1 then iterate
   parse var aline aname ':' avalue
   aname0=strip(translate(aname))
   aname='!'||aname0
   if stuff.aname='' then
      stuff.aname=strip(avalue)
   else
      stuff.aname=stuff.aname||'0d0a'x||strip(avalue)
   stuff.0=stuff.0||' '||aname0
end

return 1



/************/
/* convert from CMS id  (JS time stamp) to "N" time stamp */
fig_time:procedure
parse arg atime0

if datatype(atime0)<>'NUM' then return ''

parse var atime0 adate1 '.' atime
adate=adate1+726467
atime='0.'||atime

dd=dateconv(adate,'B','N')

/* else, convert to hr min second */
zz=digits()
numeric digits 16
secs=trunc(atime*86400)
tmp0=secs/3600
parse var tmp0 hour '.' tmp1 ; if tmp1='' then tmp1=0
hour=right(hour,2,'0')
tmp1='0.'||tmp1
tmp2=tmp1*60
parse var tmp2 minute '.'tmp3 ; ; if tmp3='' then tmp3=0
minute=right(minute,2,'0')
tmp3='0.'||tmp3
tmp3=tmp3*60 ; parse var tmp3 second '.' .
second=right(second,2,'0')
numeric digits zz

dd=dd||' '||hour||':'||minute||':'||second
return dd

/******************************/
/* check access rights. Return 1 if okay. Otherwise, return a string to be
  sent back to SREhttp/2 (an authorization response string) */
check_access:procedure expose privset host_nickname idinfo uri  aiter
parse  upper arg owners,series

if owners='' then return 1      /* no owners listed, means open access */

tpr=translate(privset)
pneeded=space(translate('CMS:'||strip(series)),0)
if wordpos(pneeded,tpr)>0 then return 1          /* explicit privilege for this */
if wordpos('SUPERUSER',tpr)>0 then return 1


/* see if a cookie exists */
look_cook='CMS_'||series
aa=sreh2_get_cookie(lookcook)
if aa<>''  then return 1

if aiter=''  then do            /* first time, so recheck privs */
  return 'PRIVS   Access to this dataseries is restricted to specific users '
end 

/* otherwise, see if a username has been sent  */
username=''
authh=sre_reqfield('Authorization')
if authh<>'' then username=sre_extract_username(authh) 
if username='' then do             /* no username available */
  return  'AUTH  Access to this dataseries is restricted to specific users '
end

/* is this one of the OWNERS? */
if pos('*',owners)=0 then do            /* * means "any user" */
if wordpos(translate(username),translate(owners))=0 then do
   return 'AUTH  Access to this dataseries is restricted to specific users '
end
end

/* One of the OWNERS, now check password */
stuff=sreh2_get_userinfo(authh,host_nickname,idinfo)
if stuff='' then do
  return 'AUTH   Access to this dataseries is restricted to specific users. Please enter a new username/password.'
end

parse var uri thisaddon '?' .
jj=lastpos('/',thisaddon)
pp=left(thisaddon,jj)

foo=sreh2_set_cookie(lookcook,1,'30m',pp,,1)

/* if here, legit user.  Record a cookie */
return 1
 

